#!/usr/bin/env python

"""
usage: argparseexercise1.py [-h] [-v] [-c COUNT] arg1 arg2

synopsis:
    A simple demonstration of the argparse module.

positional arguments:
  arg1                  Argument 1 -- an integer
  arg2                  Argument 2 -- a string

optional arguments:
  -h, --help            show this help message and exit
  -v, --verbose         Print additional information
  -c COUNT, --count COUNT
                        The number of repetitions

examples:
    python argparseexercise1.py --help
    python argparseexercise1.py 123 "abc def"
    python argparseexercise1.py -v --count=25 123 "abc def"
"""

import argparse


def test(args):
    print 'count: %d  %s' % (args.count, type(args.count), )
    print 'verbose: %s  %s' % (args.verbose, type(args.verbose), )
    print 'arg1: %d  %s' % (args.arg1, type(args.arg1), )
    print 'arg2: "%s"  %s' % (args.arg2, type(args.arg2), )


Description = """
synopsis:
    A simple demonstration of the argparse module.
"""

Epilog = """
examples:
    python argparseexercise1.py --help
    python argparseexercise1.py 123 "abc def"
    python argparseexercise1.py -v --count=25 123 "abc def"
"""


def main():
    parser = argparse.ArgumentParser(
        description=Description,
        epilog=Epilog,
        formatter_class=argparse.RawDescriptionHelpFormatter,
    )
    parser.add_argument(
        '-v', '--verbose', action='store_true', dest='verbose',
        help='Print additional information'
    )
    parser.add_argument(
        '-c', '--count', type=int, dest='count',
        help='The number of repetitions'
    )
    parser.add_argument(
        type=int, dest='arg1',
        help='Argument 1 -- an integer'
    )
    parser.add_argument(
        type=str, dest='arg2',
        help='Argument 2 -- a string'
    )
    args = parser.parse_args()
    test(args)


if __name__ == '__main__':
    main()
