#!/usr/bin/env python


"""
synopsis:
    Print a report of sections and options in one or more config file.
usage:
    python config_report.py in_config.ini ...
examples:
    python config_report.py config1.ini config2.ini config3.ini
"""

import sys
from ConfigParser import ConfigParser


def report(config_file_names):
    parser = ConfigParser()
    parser.read(config_file_names)
    sections = parser.sections()
    for section in sections:
        options = parser.options(section)
        for option in options:
            value = parser.get(section, option)
            print '%s:%s: %s' % (section, option, value, )


def main():
    args = sys.argv[1:]
    if len(args) < 1 or args[0] == '-h' or args[0] == '--help':
        sys.exit(__doc__)
    config_file_names = args
    report(config_file_names)

if __name__ == '__main__':
    main()
