#!/usr/bin/env python

"""
synopsis:
    Implement a decorator that can be used to trace function calls.
usage:
    python decorator02.py
"""


def trace(msg, count):
    print 'Creating wrapper -- msg:', msg, 'count:', count

    def inner1(func):
        def inner2(*args, **kwargs):
            indent = '    ' * count
            print '%s>> [%s:%s] args: %s' % (
                indent, msg, func.func_name, args, )
            retval = func(*args, **kwargs)
            print '%s<< [%s]' % (indent, msg, )
            return retval
        return inner2

    return inner1


@trace('tracing func1', 1)
def func1(x, y):
    print 'x:', x, 'y:', y
    result = func2((x, y))
    return result
#func1 = trace('tracing func1', 3)(func1)


@trace('tracing func2', 2)
def func2(content):
    print 'content:', content
    return content * 3


def test():
    print '-' * 40
    result = func1('aa', 'bb')
    print 'result:', result

if __name__ == '__main__':
    test()
