#!/usr/bin/env python

"""
synopsis:
    Implement a simple descriptor for exploration.
    This example stores descriptor values in the enclosing object, not
    the descriptor object.
usage:
    python descriptor02.py
"""


import logging
##Logger = logging.getLogger('simple_logger')
##Logger.setLevel(logging.INFO)    # logging on
###Logger.setLevel(logging.ERROR)    # logging off
##_logger_handler = logging.StreamHandler()    # send logging to console
###_logger_handler = logging.FileHandler('tmp01.log')    # send logging to file
##_logger_format = '%(asctime)s - %(name)s - %(levelname)s - %(message)s'
##_logger_formatter = logging.Formatter(_logger_format)
##_logger_handler.setFormatter(_logger_formatter)
##Logger.addHandler(_logger_handler)

_logger_format = '%(asctime)s - %(name)s - %(levelname)s - %(message)s'
logging.basicConfig(
    #filename='tmp.log',
    level=logging.INFO,
    #level=logging.ERROR,
    format=_logger_format)


class MonitoredAccess(object):
    def __init__(self, name):
        self.name = name

    def __get__(self, obj, objtype):
        logging.info(
            '(__get__) obj: %s  objtype: %s  value: %s',
            obj, objtype, obj.__dict__[self.name])
        return obj.__dict__[self.name]

    def __set__(self, obj, value):
        logging.info('(__set__) obj: %s  value: %s', obj, value)
        obj.__dict__[self.name] = value
        # cannot do the following.  Causes recursion.
        #obj.__setattr__(self.name, value)


class TestClass(object):
    def __init__(self, value):
        self.var1 = value

    var1 = MonitoredAccess('var1')


def main():
    a = TestClass('nil')
    a.var1 = 'abc'
    print '-' * 10
    print 'the current value of a.var1: "{}"'.format(a.var1)
    print 'a.__dict__: {}'.format(a.__dict__)


if __name__ == '__main__':
    main()
