#!/usr/bin/env python

"""
Synopsis:
    Use IPython parallel processing to execute a function on a list.
Usage:
    python ipy_multiprocessing01.py <count>
Example:
    python ipy_multiprocessing01.py 100
Notes:
    Before running this program, start up an IPython cluster.  For example:
        $ ipcluster start -n 4
"""

import sys
from ipyparallel import Client


def test(count):
    data = range(count)
    client = Client()
    views = client[:]
    result = views.map_sync(lambda x: x * 100, data)
    #result = map(lambda x: x * 100, data)
    return result


def main():
    args = sys.argv[1:]
    if len(args) != 1:
        sys.exit(__doc__)
    count = int(args[0])
    result = test(count)
    print '-' * 50
    print result
    print '-' * 50


if __name__ == '__main__':
    main()
