#!/usr/bin/env python

"""
Synopsis:
    Implement a client that uses a low level Python socket to echo a response.
    Use the "socket" module in the Python standard library.
Usage:
    python socket_echo_client.py
"""

import socket


def request():
    HOST = ''
    PORT = 50007              # The same port as used by the server
    sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
    sock.connect((HOST, PORT))
    msg = 'Hello, world'
    sock.sendall(msg)
    print 'Sent', repr(msg)
    data = sock.recv(1024)
    sock.close()
    print 'Received', repr(data)


def main():
    request()


if __name__ == '__main__':
    main()
