#!/usr/bin/env python

"""
Synopsis:
    Implement a server that uses a low level Python socket to echo a response.
    Use the "socket" module in the Python standard library.
Usage:
    python socket_echo_server.py
Resources:
    The Python socket module -- https://docs.python.org/2/library/socket.html
"""

import socket


def serve():
    HOST = ''                 # Symbolic name meaning all available interfaces
    PORT = 50007              # Arbitrary non-privileged port
    sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
    sock.bind((HOST, PORT))
    sock.listen(1)
    conn, addr = sock.accept()
    print 'Connected by', addr
    while True:
        data = conn.recv(1024)
        if not data:
            break
        data = data.upper()
        conn.sendall(data)
    conn.close()


def main():
    serve()


if __name__ == '__main__':
    main()
