#!/usr/bin/env python


def show1(node, path, indent):
    print '%snode: %s  path: %s' % (indent, node[0], path, )
    indent += '    '
    for child, edge in node[1]:
        path1 = '%s%s/' % (path, edge, )
        show1(child, path1, indent)


def test1():
    """Construct a digraph from lists.

    [node-name, [child1, child2, ...]]
    where child is a 2-tuple: (child-node, edge-name).
    """
    n1 = ['n1', []]
    n2 = ['n2', []]
    n3 = ['n3', []]
    n4 = ['n4', []]
    n5 = ['n5', [(n1, 'edge01'), (n2, 'edge04')]]
    n6 = ['n6', [(n3, 'edge02'), (n4, 'edge05')]]
    n7 = ['n7', [(n5, 'edge03'), (n6, 'edge06')]]
    show1(n7, '/', '')


def show2(graph, node, path, indent):
    print '%s%s  path: %s' % (indent, node, path, )
    indent += '    '
    children = graph[node]
    for child, edge in children:
        path1 = '%s%s/' % (path, edge, )
        show2(graph, child, path1, indent)


def test2():
    """Construct a graph from a dictionary of edges.

    Key is from-node;  value is list of edges: (to-node, edge).
    """
    graph = {}
    graph['n7'] = [('n5', 'edge03'), ('n6', 'edge06')]
    graph['n6'] = [('n3', 'edge02'), ('n4', 'edge05')]
    graph['n5'] = [('n1', 'edge01'), ('n2', 'edge04')]
    graph['n4'] = []
    graph['n3'] = []
    graph['n2'] = []
    graph['n1'] = []
    show2(graph, 'n7', '/', '')


def main():
    test1()
    print '-' * 40
    test2()


if __name__ == '__main__':
    main()
