#!/usr/bin/env python

"""
Implement a simple descriptor for exploration.

This example stores descriptor values in the descriptor object itself,
not in the enclosing object.
"""


class Control01(object):
    """Descriptor for controlled access to instance variables."""

    def __init__(self, initial_value, name):
        self.value = initial_value
        self.name = name

    def __get__(self, obj, value):
        value = self.value
        print 'accessing -- {0}:{1}'.format(self.name, self.value)
        return value

    def __set__(self, obj, value):
        self.value = value
        print 'setting -- {0}:{1}'.format(self.name, self.value)


class TestDescriptor1(object):
    x = Control01(11, 'instance_var_x')


def test():
    obj1 = TestDescriptor1()
    print obj1.x
    obj1.x = 22
    print obj1.x


def main():
    test()


if __name__ == '__main__':
    # dbg
    #import pdb; pdb.set_trace()
    main()
