"""
Synopsis:
    Download a Web page and write to stdout.
Usage:
    python urllib_wget.py url
Examples:
    python urllib_wget.py http://www.python.org
    python urllib_wget.py --help
"""

import sys
import urllib


def get(url):
    infile = urllib.urlopen(url)
    content = infile.read()
    infile.close()
    sys.stdout.write(content)


def main():
    args = sys.argv[1:]
    if len(args) != 1:
        sys.exit(__doc__)
    arg = args[0]
    if arg == '-h' or arg == '--help':
        sys.exit(__doc__)
    get(arg)


if __name__ == '__main__':
    main()
