#!/usr/bin/env python

"""
synopsis:
    Scan the current directory and subdirectories for .txt and .html files.
    Report .html files that are missing or out-of-date.
usage:
    python scan_txt_html_dates.py
"""


import os


def scan():
    for dirname, _, filenames in os.walk('.'):
        for filename in filenames:
            parts = os.path.splitext(filename)
            textname = os.path.join(dirname, filename)
            htmlname = os.path.join(dirname, parts[0] + '.html')
            if len(parts) == 2 and parts[1] == '.txt':
                if os.path.exists(htmlname):
                    textdate = os.path.getmtime(textname)
                    htmldate = os.path.getmtime(htmlname)
                    if textdate > htmldate:
                        print 'out of date: {}'.format(htmlname)
                else:
                    print 'missing: {}'.format(htmlname)


def main():
    scan()


if __name__ == '__main__':
    #import pdb; pdb.set_trace()
    main()
