#!/usr/bin/env python
# -*- coding: utf-8 -*-

#
# Generated Mon Mar 17 14:37:49 2014 by generateDS.py version 2.12c.
#

import sys
import getopt
import re as re_
import base64
import datetime as datetime_

etree_ = None
Verbose_import_ = False
(
    XMLParser_import_none, XMLParser_import_lxml,
    XMLParser_import_elementtree
) = range(3)
XMLParser_import_library = None
try:
    # lxml
    from lxml import etree as etree_
    XMLParser_import_library = XMLParser_import_lxml
    if Verbose_import_:
        print("running with lxml.etree")
except ImportError:
    try:
        # cElementTree from Python 2.5+
        import xml.etree.cElementTree as etree_
        XMLParser_import_library = XMLParser_import_elementtree
        if Verbose_import_:
            print("running with cElementTree on Python 2.5+")
    except ImportError:
        try:
            # ElementTree from Python 2.5+
            import xml.etree.ElementTree as etree_
            XMLParser_import_library = XMLParser_import_elementtree
            if Verbose_import_:
                print("running with ElementTree on Python 2.5+")
        except ImportError:
            try:
                # normal cElementTree install
                import cElementTree as etree_
                XMLParser_import_library = XMLParser_import_elementtree
                if Verbose_import_:
                    print("running with cElementTree")
            except ImportError:
                try:
                    # normal ElementTree install
                    import elementtree.ElementTree as etree_
                    XMLParser_import_library = XMLParser_import_elementtree
                    if Verbose_import_:
                        print("running with ElementTree")
                except ImportError:
                    raise ImportError(
                        "Failed to import ElementTree from any known place")


def parsexml_(*args, **kwargs):
    if (XMLParser_import_library == XMLParser_import_lxml and
            'parser' not in kwargs):
        # Use the lxml ElementTree compatible parser so that, e.g.,
        #   we ignore comments.
        kwargs['parser'] = etree_.ETCompatXMLParser()
    doc = etree_.parse(*args, **kwargs)
    return doc

#
# User methods
#
# Calls to the methods in these classes are generated by generateDS.py.
# You can replace these methods by re-implementing the following class
#   in a module named generatedssuper.py.

try:
    from generatedssuper import GeneratedsSuper
except ImportError, exp:

    class GeneratedsSuper(object):
        tzoff_pattern = re_.compile(r'(\+|-)((0\d|1[0-3]):[0-5]\d|14:00)$')
        class _FixedOffsetTZ(datetime_.tzinfo):
            def __init__(self, offset, name):
                self.__offset = datetime_.timedelta(minutes=offset)
                self.__name = name
            def utcoffset(self, dt):
                return self.__offset
            def tzname(self, dt):
                return self.__name
            def dst(self, dt):
                return None
        def gds_format_string(self, input_data, input_name=''):
            return input_data
        def gds_validate_string(self, input_data, node, input_name=''):
            if not input_data:
                return ''
            else:
                return input_data
        def gds_format_base64(self, input_data, input_name=''):
            return base64.b64encode(input_data)
        def gds_validate_base64(self, input_data, node, input_name=''):
            return input_data
        def gds_format_integer(self, input_data, input_name=''):
            return '%d' % input_data
        def gds_validate_integer(self, input_data, node, input_name=''):
            return input_data
        def gds_format_integer_list(self, input_data, input_name=''):
            return '%s' % input_data
        def gds_validate_integer_list(self, input_data, node, input_name=''):
            values = input_data.split()
            for value in values:
                try:
                    float(value)
                except (TypeError, ValueError):
                    raise_parse_error(node, 'Requires sequence of integers')
            return input_data
        def gds_format_float(self, input_data, input_name=''):
            return ('%.15f' % input_data).rstrip('0')
        def gds_validate_float(self, input_data, node, input_name=''):
            return input_data
        def gds_format_float_list(self, input_data, input_name=''):
            return '%s' % input_data
        def gds_validate_float_list(self, input_data, node, input_name=''):
            values = input_data.split()
            for value in values:
                try:
                    float(value)
                except (TypeError, ValueError):
                    raise_parse_error(node, 'Requires sequence of floats')
            return input_data
        def gds_format_double(self, input_data, input_name=''):
            return '%e' % input_data
        def gds_validate_double(self, input_data, node, input_name=''):
            return input_data
        def gds_format_double_list(self, input_data, input_name=''):
            return '%s' % input_data
        def gds_validate_double_list(self, input_data, node, input_name=''):
            values = input_data.split()
            for value in values:
                try:
                    float(value)
                except (TypeError, ValueError):
                    raise_parse_error(node, 'Requires sequence of doubles')
            return input_data
        def gds_format_boolean(self, input_data, input_name=''):
            return ('%s' % input_data).lower()
        def gds_validate_boolean(self, input_data, node, input_name=''):
            return input_data
        def gds_format_boolean_list(self, input_data, input_name=''):
            return '%s' % input_data
        def gds_validate_boolean_list(self, input_data, node, input_name=''):
            values = input_data.split()
            for value in values:
                if value not in ('true', '1', 'false', '0', ):
                    raise_parse_error(
                        node,
                        'Requires sequence of booleans '
                        '("true", "1", "false", "0")')
            return input_data
        def gds_validate_datetime(self, input_data, node, input_name=''):
            return input_data
        def gds_format_datetime(self, input_data, input_name=''):
            if input_data.microsecond == 0:
                _svalue = '%04d-%02d-%02dT%02d:%02d:%02d' % (
                    input_data.year,
                    input_data.month,
                    input_data.day,
                    input_data.hour,
                    input_data.minute,
                    input_data.second,
                )
            else:
                _svalue = '%04d-%02d-%02dT%02d:%02d:%02d.%s' % (
                    input_data.year,
                    input_data.month,
                    input_data.day,
                    input_data.hour,
                    input_data.minute,
                    input_data.second,
                    ('%f' % (float(input_data.microsecond) / 1000000))[2:],
                )
            if input_data.tzinfo is not None:
                tzoff = input_data.tzinfo.utcoffset(input_data)
                if tzoff is not None:
                    total_seconds = tzoff.seconds + (86400 * tzoff.days)
                    if total_seconds == 0:
                        _svalue += 'Z'
                    else:
                        if total_seconds < 0:
                            _svalue += '-'
                            total_seconds *= -1
                        else:
                            _svalue += '+'
                        hours = total_seconds // 3600
                        minutes = (total_seconds - (hours * 3600)) // 60
                        _svalue += '{0:02d}:{1:02d}'.format(hours, minutes)
            return _svalue
        @classmethod
        def gds_parse_datetime(cls, input_data):
            tz = None
            if input_data[-1] == 'Z':
                tz = GeneratedsSuper._FixedOffsetTZ(0, 'UTC')
                input_data = input_data[:-1]
            else:
                results = GeneratedsSuper.tzoff_pattern.search(input_data)
                if results is not None:
                    tzoff_parts = results.group(2).split(':')
                    tzoff = int(tzoff_parts[0]) * 60 + int(tzoff_parts[1])
                    if results.group(1) == '-':
                        tzoff *= -1
                    tz = GeneratedsSuper._FixedOffsetTZ(
                        tzoff, results.group(0))
                    input_data = input_data[:-6]
            if len(input_data.split('.')) > 1:
                dt = datetime_.datetime.strptime(
                    input_data, '%Y-%m-%dT%H:%M:%S.%f')
            else:
                dt = datetime_.datetime.strptime(
                    input_data, '%Y-%m-%dT%H:%M:%S')
            dt = dt.replace(tzinfo=tz)
            return dt
        def gds_validate_date(self, input_data, node, input_name=''):
            return input_data
        def gds_format_date(self, input_data, input_name=''):
            _svalue = '%04d-%02d-%02d' % (
                input_data.year,
                input_data.month,
                input_data.day,
            )
            try:
                if input_data.tzinfo is not None:
                    tzoff = input_data.tzinfo.utcoffset(input_data)
                    if tzoff is not None:
                        total_seconds = tzoff.seconds + (86400 * tzoff.days)
                        if total_seconds == 0:
                            _svalue += 'Z'
                        else:
                            if total_seconds < 0:
                                _svalue += '-'
                                total_seconds *= -1
                            else:
                                _svalue += '+'
                            hours = total_seconds // 3600
                            minutes = (total_seconds - (hours * 3600)) // 60
                            _svalue += '{0:02d}:{1:02d}'.format(hours, minutes)
            except AttributeError:
                pass
            return _svalue
        @classmethod
        def gds_parse_date(cls, input_data):
            tz = None
            if input_data[-1] == 'Z':
                tz = GeneratedsSuper._FixedOffsetTZ(0, 'UTC')
                input_data = input_data[:-1]
            else:
                results = GeneratedsSuper.tzoff_pattern.search(input_data)
                if results is not None:
                    tzoff_parts = results.group(2).split(':')
                    tzoff = int(tzoff_parts[0]) * 60 + int(tzoff_parts[1])
                    if results.group(1) == '-':
                        tzoff *= -1
                    tz = GeneratedsSuper._FixedOffsetTZ(
                        tzoff, results.group(0))
                    input_data = input_data[:-6]
            dt = datetime_.datetime.strptime(input_data, '%Y-%m-%d')
            dt = dt.replace(tzinfo=tz)
            return dt.date()
        def gds_validate_time(self, input_data, node, input_name=''):
            return input_data
        def gds_format_time(self, input_data, input_name=''):
            if input_data.microsecond == 0:
                _svalue = '%02d:%02d:%02d' % (
                    input_data.hour,
                    input_data.minute,
                    input_data.second,
                )
            else:
                _svalue = '%02d:%02d:%02d.%s' % (
                    input_data.hour,
                    input_data.minute,
                    input_data.second,
                    ('%f' % (float(input_data.microsecond) / 1000000))[2:],
                )
            if input_data.tzinfo is not None:
                tzoff = input_data.tzinfo.utcoffset(input_data)
                if tzoff is not None:
                    total_seconds = tzoff.seconds + (86400 * tzoff.days)
                    if total_seconds == 0:
                        _svalue += 'Z'
                    else:
                        if total_seconds < 0:
                            _svalue += '-'
                            total_seconds *= -1
                        else:
                            _svalue += '+'
                        hours = total_seconds // 3600
                        minutes = (total_seconds - (hours * 3600)) // 60
                        _svalue += '{0:02d}:{1:02d}'.format(hours, minutes)
            return _svalue
        @classmethod
        def gds_parse_time(cls, input_data):
            tz = None
            if input_data[-1] == 'Z':
                tz = GeneratedsSuper._FixedOffsetTZ(0, 'UTC')
                input_data = input_data[:-1]
            else:
                results = GeneratedsSuper.tzoff_pattern.search(input_data)
                if results is not None:
                    tzoff_parts = results.group(2).split(':')
                    tzoff = int(tzoff_parts[0]) * 60 + int(tzoff_parts[1])
                    if results.group(1) == '-':
                        tzoff *= -1
                    tz = GeneratedsSuper._FixedOffsetTZ(
                        tzoff, results.group(0))
                    input_data = input_data[:-6]
            if len(input_data.split('.')) > 1:
                dt = datetime_.datetime.strptime(input_data, '%H:%M:%S.%f')
            else:
                dt = datetime_.datetime.strptime(input_data, '%H:%M:%S')
            dt = dt.replace(tzinfo=tz)
            return dt.time()
        def gds_str_lower(self, instring):
            return instring.lower()
        def get_path_(self, node):
            path_list = []
            self.get_path_list_(node, path_list)
            path_list.reverse()
            path = '/'.join(path_list)
            return path
        Tag_strip_pattern_ = re_.compile(r'\{.*\}')
        def get_path_list_(self, node, path_list):
            if node is None:
                return
            tag = GeneratedsSuper.Tag_strip_pattern_.sub('', node.tag)
            if tag:
                path_list.append(tag)
            self.get_path_list_(node.getparent(), path_list)
        def get_class_obj_(self, node, default_class=None):
            class_obj1 = default_class
            if 'xsi' in node.nsmap:
                classname = node.get('{%s}type' % node.nsmap['xsi'])
                if classname is not None:
                    names = classname.split(':')
                    if len(names) == 2:
                        classname = names[1]
                    class_obj2 = globals().get(classname)
                    if class_obj2 is not None:
                        class_obj1 = class_obj2
            return class_obj1
        def gds_build_any(self, node, type_name=None):
            return None
        @classmethod
        def gds_reverse_node_mapping(cls, mapping):
            return dict(((v, k) for k, v in mapping.iteritems()))


#
# If you have installed IPython you can uncomment and use the following.
# IPython is available from http://ipython.scipy.org/.
#

## from IPython.Shell import IPShellEmbed
## args = ''
## ipshell = IPShellEmbed(args,
##     banner = 'Dropping into IPython',
##     exit_msg = 'Leaving Interpreter, back to program.')

# Then use the following line where and when you want to drop into the
# IPython shell:
#    ipshell('<some message> -- Entering ipshell.\nHit Ctrl-D to exit')

#
# Globals
#

ExternalEncoding = 'ascii'
Tag_pattern_ = re_.compile(r'({.*})?(.*)')
String_cleanup_pat_ = re_.compile(r"[\n\r\s]+")
Namespace_extract_pat_ = re_.compile(r'{(.*)}(.*)')

#
# Support/utility functions.
#


def showIndent(outfile, level, pretty_print=True):
    if pretty_print:
        for idx in range(level):
            outfile.write('    ')


def quote_xml(inStr):
    if not inStr:
        return ''
    s1 = (isinstance(inStr, basestring) and inStr or
          '%s' % inStr)
    s1 = s1.replace('&', '&amp;')
    s1 = s1.replace('<', '&lt;')
    s1 = s1.replace('>', '&gt;')
    return s1


def quote_attrib(inStr):
    s1 = (isinstance(inStr, basestring) and inStr or
          '%s' % inStr)
    s1 = s1.replace('&', '&amp;')
    s1 = s1.replace('<', '&lt;')
    s1 = s1.replace('>', '&gt;')
    if '"' in s1:
        if "'" in s1:
            s1 = '"%s"' % s1.replace('"', "&quot;")
        else:
            s1 = "'%s'" % s1
    else:
        s1 = '"%s"' % s1
    return s1


def quote_python(inStr):
    s1 = inStr
    if s1.find("'") == -1:
        if s1.find('\n') == -1:
            return "'%s'" % s1
        else:
            return "'''%s'''" % s1
    else:
        if s1.find('"') != -1:
            s1 = s1.replace('"', '\\"')
        if s1.find('\n') == -1:
            return '"%s"' % s1
        else:
            return '"""%s"""' % s1


def get_all_text_(node):
    if node.text is not None:
        text = node.text
    else:
        text = ''
    for child in node:
        if child.tail is not None:
            text += child.tail
    return text


def find_attr_value_(attr_name, node):
    attrs = node.attrib
    attr_parts = attr_name.split(':')
    value = None
    if len(attr_parts) == 1:
        value = attrs.get(attr_name)
    elif len(attr_parts) == 2:
        prefix, name = attr_parts
        namespace = node.nsmap.get(prefix)
        if namespace is not None:
            value = attrs.get('{%s}%s' % (namespace, name, ))
    return value


class GDSParseError(Exception):
    pass


def raise_parse_error(node, msg):
    if XMLParser_import_library == XMLParser_import_lxml:
        msg = '%s (element %s/line %d)' % (
            msg, node.tag, node.sourceline, )
    else:
        msg = '%s (element %s)' % (msg, node.tag, )
    raise GDSParseError(msg)


class MixedContainer:
    # Constants for category:
    CategoryNone = 0
    CategoryText = 1
    CategorySimple = 2
    CategoryComplex = 3
    # Constants for content_type:
    TypeNone = 0
    TypeText = 1
    TypeString = 2
    TypeInteger = 3
    TypeFloat = 4
    TypeDecimal = 5
    TypeDouble = 6
    TypeBoolean = 7
    TypeBase64 = 8
    def __init__(self, category, content_type, name, value):
        self.category = category
        self.content_type = content_type
        self.name = name
        self.value = value
    def getCategory(self):
        return self.category
    def getContenttype(self, content_type):
        return self.content_type
    def getValue(self):
        return self.value
    def getName(self):
        return self.name
    def export(self, outfile, level, name, namespace, pretty_print=True):
        if self.category == MixedContainer.CategoryText:
            # Prevent exporting empty content as empty lines.
            if self.value.strip():
                outfile.write(self.value)
        elif self.category == MixedContainer.CategorySimple:
            self.exportSimple(outfile, level, name)
        else:    # category == MixedContainer.CategoryComplex
            self.value.export(outfile, level, namespace, name, pretty_print)
    def exportSimple(self, outfile, level, name):
        if self.content_type == MixedContainer.TypeString:
            outfile.write('<%s>%s</%s>' % (
                self.name, self.value, self.name))
        elif self.content_type == MixedContainer.TypeInteger or \
                self.content_type == MixedContainer.TypeBoolean:
            outfile.write('<%s>%d</%s>' % (
                self.name, self.value, self.name))
        elif self.content_type == MixedContainer.TypeFloat or \
                self.content_type == MixedContainer.TypeDecimal:
            outfile.write('<%s>%f</%s>' % (
                self.name, self.value, self.name))
        elif self.content_type == MixedContainer.TypeDouble:
            outfile.write('<%s>%g</%s>' % (
                self.name, self.value, self.name))
        elif self.content_type == MixedContainer.TypeBase64:
            outfile.write('<%s>%s</%s>' % (
                self.name, base64.b64encode(self.value), self.name))
    def to_etree(self, element):
        if self.category == MixedContainer.CategoryText:
            # Prevent exporting empty content as empty lines.
            if self.value.strip():
                if len(element) > 0:
                    if element[-1].tail is None:
                        element[-1].tail = self.value
                    else:
                        element[-1].tail += self.value
                else:
                    if element.text is None:
                        element.text = self.value
                    else:
                        element.text += self.value
        elif self.category == MixedContainer.CategorySimple:
            subelement = etree_.SubElement(element, '%s' % self.name)
            subelement.text = self.to_etree_simple()
        else:    # category == MixedContainer.CategoryComplex
            self.value.to_etree(element)
    def to_etree_simple(self):
        if self.content_type == MixedContainer.TypeString:
            text = self.value
        elif (self.content_type == MixedContainer.TypeInteger or
                self.content_type == MixedContainer.TypeBoolean):
            text = '%d' % self.value
        elif (self.content_type == MixedContainer.TypeFloat or
                self.content_type == MixedContainer.TypeDecimal):
            text = '%f' % self.value
        elif self.content_type == MixedContainer.TypeDouble:
            text = '%g' % self.value
        elif self.content_type == MixedContainer.TypeBase64:
            text = '%s' % base64.b64encode(self.value)
        return text
    def exportLiteral(self, outfile, level, name):
        if self.category == MixedContainer.CategoryText:
            showIndent(outfile, level)
            outfile.write(
                'model_.MixedContainer(%d, %d, "%s", "%s"),\n' % (
                    self.category, self.content_type, self.name, self.value))
        elif self.category == MixedContainer.CategorySimple:
            showIndent(outfile, level)
            outfile.write(
                'model_.MixedContainer(%d, %d, "%s", "%s"),\n' % (
                    self.category, self.content_type, self.name, self.value))
        else:    # category == MixedContainer.CategoryComplex
            showIndent(outfile, level)
            outfile.write(
                'model_.MixedContainer(%d, %d, "%s",\n' % (
                    self.category, self.content_type, self.name,))
            self.value.exportLiteral(outfile, level + 1)
            showIndent(outfile, level)
            outfile.write(')\n')


class MemberSpec_(object):
    def __init__(self, name='', data_type='', container=0):
        self.name = name
        self.data_type = data_type
        self.container = container
    def set_name(self, name): self.name = name
    def get_name(self): return self.name
    def set_data_type(self, data_type): self.data_type = data_type
    def get_data_type_chain(self): return self.data_type
    def get_data_type(self):
        if isinstance(self.data_type, list):
            if len(self.data_type) > 0:
                return self.data_type[-1]
            else:
                return 'xs:string'
        else:
            return self.data_type
    def set_container(self, container): self.container = container
    def get_container(self): return self.container


def _cast(typ, value):
    if typ is None or value is None:
        return value
    return typ(value)

#
# Data representation classes.
#


class ArrayDimension(GeneratedsSuper):
    """This feature is not implemented in HDF5. This attribute should be
    ignored (and deleted as soon as possible)."""
    member_data_items_ = {
        'DimSize': MemberSpec_('DimSize', 'xs:string', 0),
        'DimPerm': MemberSpec_('DimPerm', 'xs:string', 0),
    }
    subclass = None
    superclass = None
    def __init__(self, DimSize='0', DimPerm='0'):
        self.original_tagname_ = None
        self.DimSize = _cast(None, DimSize)
        self.DimPerm = _cast(None, DimPerm)
    def factory(*args_, **kwargs_):
        if ArrayDimension.subclass:
            return ArrayDimension.subclass(*args_, **kwargs_)
        else:
            return ArrayDimension(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_DimSize(self): return self.DimSize
    def set_DimSize(self, DimSize): self.DimSize = DimSize
    def get_DimPerm(self): return self.DimPerm
    def set_DimPerm(self, DimPerm): self.DimPerm = DimPerm
    def hasContent_(self):
        if (

        ):
            return True
        else:
            return False
    def export(self, outfile, level, namespace_='hdf5:', name_='ArrayDimension', namespacedef_='xmlns:hdf5="http://hdfgroup.org/HDF5/XML/schema/HDF5-File"', pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.original_tagname_ is not None:
            name_ = self.original_tagname_
        showIndent(outfile, level, pretty_print)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = set()
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='ArrayDimension')
        if self.hasContent_():
            outfile.write('>%s' % (eol_, ))
            self.exportChildren(outfile, level + 1, namespace_='hdf5:', name_='ArrayDimension', pretty_print=pretty_print)
            outfile.write('</%s%s>%s' % (namespace_, name_, eol_))
        else:
            outfile.write('/>%s' % (eol_, ))
    def exportAttributes(self, outfile, level, already_processed, namespace_='hdf5:', name_='ArrayDimension'):
        if self.DimSize is not None and 'DimSize' not in already_processed:
            already_processed.add('DimSize')
            outfile.write(' DimSize=%s' % (self.gds_format_string(quote_attrib(self.DimSize).encode(ExternalEncoding), input_name='DimSize'), ))
        if self.DimPerm is not None and 'DimPerm' not in already_processed:
            already_processed.add('DimPerm')
            outfile.write(' DimPerm=%s' % (self.gds_format_string(quote_attrib(self.DimPerm).encode(ExternalEncoding), input_name='DimPerm'), ))
    def exportChildren(self, outfile, level, namespace_='hdf5:', name_='ArrayDimension', fromsubclass_=False, pretty_print=True):
        pass
    def to_etree(self, parent_element=None, name_='ArrayDimension', mapping_=None):
        if parent_element is None:
            element = etree_.Element('{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        else:
            element = etree_.SubElement(parent_element, '{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        if self.DimSize is not None:
            element.set('DimSize', self.gds_format_string(self.DimSize))
        if self.DimPerm is not None:
            element.set('DimPerm', self.gds_format_string(self.DimPerm))
        if mapping_ is not None:
            mapping_[self] = element
        return element
    def exportLiteral(self, outfile, level, name_='ArrayDimension'):
        level += 1
        already_processed = set()
        self.exportLiteralAttributes(outfile, level, already_processed, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, already_processed, name_):
        if self.DimSize is not None and 'DimSize' not in already_processed:
            already_processed.add('DimSize')
            showIndent(outfile, level)
            outfile.write('DimSize="%s",\n' % (self.DimSize,))
        if self.DimPerm is not None and 'DimPerm' not in already_processed:
            already_processed.add('DimPerm')
            showIndent(outfile, level)
            outfile.write('DimPerm="%s",\n' % (self.DimPerm,))
    def exportLiteralChildren(self, outfile, level, name_):
        pass
    def build(self, node):
        already_processed = set()
        self.buildAttributes(node, node.attrib, already_processed)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
        return self
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('DimSize', node)
        if value is not None and 'DimSize' not in already_processed:
            already_processed.add('DimSize')
            self.DimSize = value
        value = find_attr_value_('DimPerm', node)
        if value is not None and 'DimPerm' not in already_processed:
            already_processed.add('DimPerm')
            self.DimPerm = value
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        pass
# end class ArrayDimension


class ArrayType(GeneratedsSuper):
    member_data_items_ = {
        'Ndims': MemberSpec_('Ndims', 'xs:string', 0),
        'ArrayDimension': MemberSpec_('ArrayDimension', 'ArrayDimension', 1),
        'DataType': MemberSpec_('DataType', 'DataType', 0),
    }
    subclass = None
    superclass = None
    def __init__(self, Ndims=None, ArrayDimension=None, DataType=None):
        self.original_tagname_ = None
        self.Ndims = _cast(None, Ndims)
        if ArrayDimension is None:
            self.ArrayDimension = []
        else:
            self.ArrayDimension = ArrayDimension
        self.DataType = DataType
    def factory(*args_, **kwargs_):
        if ArrayType.subclass:
            return ArrayType.subclass(*args_, **kwargs_)
        else:
            return ArrayType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_ArrayDimension(self): return self.ArrayDimension
    def set_ArrayDimension(self, ArrayDimension): self.ArrayDimension = ArrayDimension
    def add_ArrayDimension(self, value): self.ArrayDimension.append(value)
    def insert_ArrayDimension(self, index, value): self.ArrayDimension[index] = value
    def get_DataType(self): return self.DataType
    def set_DataType(self, DataType): self.DataType = DataType
    def get_Ndims(self): return self.Ndims
    def set_Ndims(self, Ndims): self.Ndims = Ndims
    def hasContent_(self):
        if (
            self.ArrayDimension or
            self.DataType is not None
        ):
            return True
        else:
            return False
    def export(self, outfile, level, namespace_='hdf5:', name_='ArrayType', namespacedef_='xmlns:hdf5="http://hdfgroup.org/HDF5/XML/schema/HDF5-File"', pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.original_tagname_ is not None:
            name_ = self.original_tagname_
        showIndent(outfile, level, pretty_print)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = set()
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='ArrayType')
        if self.hasContent_():
            outfile.write('>%s' % (eol_, ))
            self.exportChildren(outfile, level + 1, namespace_='hdf5:', name_='ArrayType', pretty_print=pretty_print)
            showIndent(outfile, level, pretty_print)
            outfile.write('</%s%s>%s' % (namespace_, name_, eol_))
        else:
            outfile.write('/>%s' % (eol_, ))
    def exportAttributes(self, outfile, level, already_processed, namespace_='hdf5:', name_='ArrayType'):
        if self.Ndims is not None and 'Ndims' not in already_processed:
            already_processed.add('Ndims')
            outfile.write(' Ndims=%s' % (self.gds_format_string(quote_attrib(self.Ndims).encode(ExternalEncoding), input_name='Ndims'), ))
    def exportChildren(self, outfile, level, namespace_='hdf5:', name_='ArrayType', fromsubclass_=False, pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        for ArrayDimension_ in self.ArrayDimension:
            ArrayDimension_.export(outfile, level, namespace_='hdf5:', name_='ArrayDimension', pretty_print=pretty_print)
        if self.DataType is not None:
            self.DataType.export(outfile, level, namespace_='hdf5:', name_='DataType', pretty_print=pretty_print)
    def to_etree(self, parent_element=None, name_='ArrayType', mapping_=None):
        if parent_element is None:
            element = etree_.Element('{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        else:
            element = etree_.SubElement(parent_element, '{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        if self.Ndims is not None:
            element.set('Ndims', self.gds_format_string(self.Ndims))
        for ArrayDimension_ in self.ArrayDimension:
            ArrayDimension_.to_etree(element, name_='ArrayDimension', mapping_=mapping_)
        if self.DataType is not None:
            DataType_ = self.DataType
            DataType_.to_etree(element, name_='DataType', mapping_=mapping_)
        if mapping_ is not None:
            mapping_[self] = element
        return element
    def exportLiteral(self, outfile, level, name_='ArrayType'):
        level += 1
        already_processed = set()
        self.exportLiteralAttributes(outfile, level, already_processed, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, already_processed, name_):
        if self.Ndims is not None and 'Ndims' not in already_processed:
            already_processed.add('Ndims')
            showIndent(outfile, level)
            outfile.write('Ndims="%s",\n' % (self.Ndims,))
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('ArrayDimension=[\n')
        level += 1
        for ArrayDimension_ in self.ArrayDimension:
            showIndent(outfile, level)
            outfile.write('model_.ArrayDimension(\n')
            ArrayDimension_.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
        if self.DataType is not None:
            showIndent(outfile, level)
            outfile.write('DataType=model_.DataType(\n')
            self.DataType.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
    def build(self, node):
        already_processed = set()
        self.buildAttributes(node, node.attrib, already_processed)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
        return self
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('Ndims', node)
        if value is not None and 'Ndims' not in already_processed:
            already_processed.add('Ndims')
            self.Ndims = value
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'ArrayDimension':
            obj_ = ArrayDimension.factory()
            obj_.build(child_)
            self.ArrayDimension.append(obj_)
            obj_.original_tagname_ = 'ArrayDimension'
        elif nodeName_ == 'DataType':
            obj_ = DataType.factory()
            obj_.build(child_)
            self.DataType = obj_
            obj_.original_tagname_ = 'DataType'
# end class ArrayType


class AtomicType(GeneratedsSuper):
    member_data_items_ = {
        'IntegerType': MemberSpec_('IntegerType', 'IntegerType', 0),
        'FloatType': MemberSpec_('FloatType', 'FloatType', 0),
        'StringType': MemberSpec_('StringType', 'StringType', 0),
        'TimeType': MemberSpec_('TimeType', 'TimeType', 0),
        'BitfieldType': MemberSpec_('BitfieldType', 'BitfieldType', 0),
        'OpaqueType': MemberSpec_('OpaqueType', 'OpaqueType', 0),
        'ReferenceType': MemberSpec_('ReferenceType', 'ReferenceType', 0),
        'EnumType': MemberSpec_('EnumType', 'EnumType', 0),
    }
    subclass = None
    superclass = None
    def __init__(self, IntegerType=None, FloatType=None, StringType=None, TimeType=None, BitfieldType=None, OpaqueType=None, ReferenceType=None, EnumType=None):
        self.original_tagname_ = None
        self.IntegerType = IntegerType
        self.FloatType = FloatType
        self.StringType = StringType
        self.TimeType = TimeType
        self.BitfieldType = BitfieldType
        self.OpaqueType = OpaqueType
        self.ReferenceType = ReferenceType
        self.EnumType = EnumType
    def factory(*args_, **kwargs_):
        if AtomicType.subclass:
            return AtomicType.subclass(*args_, **kwargs_)
        else:
            return AtomicType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_IntegerType(self): return self.IntegerType
    def set_IntegerType(self, IntegerType): self.IntegerType = IntegerType
    def get_FloatType(self): return self.FloatType
    def set_FloatType(self, FloatType): self.FloatType = FloatType
    def get_StringType(self): return self.StringType
    def set_StringType(self, StringType): self.StringType = StringType
    def get_TimeType(self): return self.TimeType
    def set_TimeType(self, TimeType): self.TimeType = TimeType
    def get_BitfieldType(self): return self.BitfieldType
    def set_BitfieldType(self, BitfieldType): self.BitfieldType = BitfieldType
    def get_OpaqueType(self): return self.OpaqueType
    def set_OpaqueType(self, OpaqueType): self.OpaqueType = OpaqueType
    def get_ReferenceType(self): return self.ReferenceType
    def set_ReferenceType(self, ReferenceType): self.ReferenceType = ReferenceType
    def get_EnumType(self): return self.EnumType
    def set_EnumType(self, EnumType): self.EnumType = EnumType
    def hasContent_(self):
        if (
            self.IntegerType is not None or
            self.FloatType is not None or
            self.StringType is not None or
            self.TimeType is not None or
            self.BitfieldType is not None or
            self.OpaqueType is not None or
            self.ReferenceType is not None or
            self.EnumType is not None
        ):
            return True
        else:
            return False
    def export(self, outfile, level, namespace_='hdf5:', name_='AtomicType', namespacedef_='xmlns:hdf5="http://hdfgroup.org/HDF5/XML/schema/HDF5-File"', pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.original_tagname_ is not None:
            name_ = self.original_tagname_
        showIndent(outfile, level, pretty_print)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = set()
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='AtomicType')
        if self.hasContent_():
            outfile.write('>%s' % (eol_, ))
            self.exportChildren(outfile, level + 1, namespace_='hdf5:', name_='AtomicType', pretty_print=pretty_print)
            showIndent(outfile, level, pretty_print)
            outfile.write('</%s%s>%s' % (namespace_, name_, eol_))
        else:
            outfile.write('/>%s' % (eol_, ))
    def exportAttributes(self, outfile, level, already_processed, namespace_='hdf5:', name_='AtomicType'):
        pass
    def exportChildren(self, outfile, level, namespace_='hdf5:', name_='AtomicType', fromsubclass_=False, pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.IntegerType is not None:
            self.IntegerType.export(outfile, level, namespace_='hdf5:', name_='IntegerType', pretty_print=pretty_print)
        if self.FloatType is not None:
            self.FloatType.export(outfile, level, namespace_='hdf5:', name_='FloatType', pretty_print=pretty_print)
        if self.StringType is not None:
            self.StringType.export(outfile, level, namespace_='hdf5:', name_='StringType', pretty_print=pretty_print)
        if self.TimeType is not None:
            self.TimeType.export(outfile, level, namespace_='hdf5:', name_='TimeType', pretty_print=pretty_print)
        if self.BitfieldType is not None:
            self.BitfieldType.export(outfile, level, namespace_='hdf5:', name_='BitfieldType', pretty_print=pretty_print)
        if self.OpaqueType is not None:
            self.OpaqueType.export(outfile, level, namespace_='hdf5:', name_='OpaqueType', pretty_print=pretty_print)
        if self.ReferenceType is not None:
            self.ReferenceType.export(outfile, level, namespace_='hdf5:', name_='ReferenceType', pretty_print=pretty_print)
        if self.EnumType is not None:
            self.EnumType.export(outfile, level, namespace_='hdf5:', name_='EnumType', pretty_print=pretty_print)
    def to_etree(self, parent_element=None, name_='AtomicType', mapping_=None):
        if parent_element is None:
            element = etree_.Element('{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        else:
            element = etree_.SubElement(parent_element, '{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        if self.IntegerType is not None:
            IntegerType_ = self.IntegerType
            IntegerType_.to_etree(element, name_='IntegerType', mapping_=mapping_)
        if self.FloatType is not None:
            FloatType_ = self.FloatType
            FloatType_.to_etree(element, name_='FloatType', mapping_=mapping_)
        if self.StringType is not None:
            StringType_ = self.StringType
            StringType_.to_etree(element, name_='StringType', mapping_=mapping_)
        if self.TimeType is not None:
            TimeType_ = self.TimeType
            TimeType_.to_etree(element, name_='TimeType', mapping_=mapping_)
        if self.BitfieldType is not None:
            BitfieldType_ = self.BitfieldType
            BitfieldType_.to_etree(element, name_='BitfieldType', mapping_=mapping_)
        if self.OpaqueType is not None:
            OpaqueType_ = self.OpaqueType
            OpaqueType_.to_etree(element, name_='OpaqueType', mapping_=mapping_)
        if self.ReferenceType is not None:
            ReferenceType_ = self.ReferenceType
            ReferenceType_.to_etree(element, name_='ReferenceType', mapping_=mapping_)
        if self.EnumType is not None:
            EnumType_ = self.EnumType
            EnumType_.to_etree(element, name_='EnumType', mapping_=mapping_)
        if mapping_ is not None:
            mapping_[self] = element
        return element
    def exportLiteral(self, outfile, level, name_='AtomicType'):
        level += 1
        already_processed = set()
        self.exportLiteralAttributes(outfile, level, already_processed, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, already_processed, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        if self.IntegerType is not None:
            showIndent(outfile, level)
            outfile.write('IntegerType=model_.IntegerType(\n')
            self.IntegerType.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.FloatType is not None:
            showIndent(outfile, level)
            outfile.write('FloatType=model_.FloatType(\n')
            self.FloatType.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.StringType is not None:
            showIndent(outfile, level)
            outfile.write('StringType=model_.StringType(\n')
            self.StringType.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.TimeType is not None:
            showIndent(outfile, level)
            outfile.write('TimeType=model_.TimeType(\n')
            self.TimeType.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.BitfieldType is not None:
            showIndent(outfile, level)
            outfile.write('BitfieldType=model_.BitfieldType(\n')
            self.BitfieldType.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.OpaqueType is not None:
            showIndent(outfile, level)
            outfile.write('OpaqueType=model_.OpaqueType(\n')
            self.OpaqueType.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.ReferenceType is not None:
            showIndent(outfile, level)
            outfile.write('ReferenceType=model_.ReferenceType(\n')
            self.ReferenceType.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.EnumType is not None:
            showIndent(outfile, level)
            outfile.write('EnumType=model_.EnumType(\n')
            self.EnumType.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
    def build(self, node):
        already_processed = set()
        self.buildAttributes(node, node.attrib, already_processed)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
        return self
    def buildAttributes(self, node, attrs, already_processed):
        pass
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'IntegerType':
            obj_ = IntegerType.factory()
            obj_.build(child_)
            self.IntegerType = obj_
            obj_.original_tagname_ = 'IntegerType'
        elif nodeName_ == 'FloatType':
            obj_ = FloatType.factory()
            obj_.build(child_)
            self.FloatType = obj_
            obj_.original_tagname_ = 'FloatType'
        elif nodeName_ == 'StringType':
            obj_ = StringType.factory()
            obj_.build(child_)
            self.StringType = obj_
            obj_.original_tagname_ = 'StringType'
        elif nodeName_ == 'TimeType':
            obj_ = TimeType.factory()
            obj_.build(child_)
            self.TimeType = obj_
            obj_.original_tagname_ = 'TimeType'
        elif nodeName_ == 'BitfieldType':
            obj_ = BitfieldType.factory()
            obj_.build(child_)
            self.BitfieldType = obj_
            obj_.original_tagname_ = 'BitfieldType'
        elif nodeName_ == 'OpaqueType':
            obj_ = OpaqueType.factory()
            obj_.build(child_)
            self.OpaqueType = obj_
            obj_.original_tagname_ = 'OpaqueType'
        elif nodeName_ == 'ReferenceType':
            obj_ = ReferenceType.factory()
            obj_.build(child_)
            self.ReferenceType = obj_
            obj_.original_tagname_ = 'ReferenceType'
        elif nodeName_ == 'EnumType':
            obj_ = EnumType.factory()
            obj_.build(child_)
            self.EnumType = obj_
            obj_.original_tagname_ = 'EnumType'
# end class AtomicType


class Attribute(GeneratedsSuper):
    member_data_items_ = {
        'Name': MemberSpec_('Name', 'xs:string', 0),
        'Dataspace': MemberSpec_('Dataspace', 'Dataspace', 0),
        'DataType': MemberSpec_('DataType', 'DataType', 0),
        'Data': MemberSpec_('Data', 'Data', 0),
    }
    subclass = None
    superclass = None
    def __init__(self, Name=None, Dataspace=None, DataType=None, Data=None):
        self.original_tagname_ = None
        self.Name = _cast(None, Name)
        self.Dataspace = Dataspace
        self.DataType = DataType
        self.Data = Data
    def factory(*args_, **kwargs_):
        if Attribute.subclass:
            return Attribute.subclass(*args_, **kwargs_)
        else:
            return Attribute(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_Dataspace(self): return self.Dataspace
    def set_Dataspace(self, Dataspace): self.Dataspace = Dataspace
    def get_DataType(self): return self.DataType
    def set_DataType(self, DataType): self.DataType = DataType
    def get_Data(self): return self.Data
    def set_Data(self, Data): self.Data = Data
    def get_Name(self): return self.Name
    def set_Name(self, Name): self.Name = Name
    def hasContent_(self):
        if (
            self.Dataspace is not None or
            self.DataType is not None or
            self.Data is not None
        ):
            return True
        else:
            return False
    def export(self, outfile, level, namespace_='hdf5:', name_='Attribute', namespacedef_='xmlns:hdf5="http://hdfgroup.org/HDF5/XML/schema/HDF5-File"', pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.original_tagname_ is not None:
            name_ = self.original_tagname_
        showIndent(outfile, level, pretty_print)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = set()
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='Attribute')
        if self.hasContent_():
            outfile.write('>%s' % (eol_, ))
            self.exportChildren(outfile, level + 1, namespace_='hdf5:', name_='Attribute', pretty_print=pretty_print)
            showIndent(outfile, level, pretty_print)
            outfile.write('</%s%s>%s' % (namespace_, name_, eol_))
        else:
            outfile.write('/>%s' % (eol_, ))
    def exportAttributes(self, outfile, level, already_processed, namespace_='hdf5:', name_='Attribute'):
        if self.Name is not None and 'Name' not in already_processed:
            already_processed.add('Name')
            outfile.write(' Name=%s' % (self.gds_format_string(quote_attrib(self.Name).encode(ExternalEncoding), input_name='Name'), ))
    def exportChildren(self, outfile, level, namespace_='hdf5:', name_='Attribute', fromsubclass_=False, pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.Dataspace is not None:
            self.Dataspace.export(outfile, level, namespace_='hdf5:', name_='Dataspace', pretty_print=pretty_print)
        if self.DataType is not None:
            self.DataType.export(outfile, level, namespace_='hdf5:', name_='DataType', pretty_print=pretty_print)
        if self.Data is not None:
            self.Data.export(outfile, level, namespace_='hdf5:', name_='Data', pretty_print=pretty_print)
    def to_etree(self, parent_element=None, name_='Attribute', mapping_=None):
        if parent_element is None:
            element = etree_.Element('{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        else:
            element = etree_.SubElement(parent_element, '{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        if self.Name is not None:
            element.set('Name', self.gds_format_string(self.Name))
        if self.Dataspace is not None:
            Dataspace_ = self.Dataspace
            Dataspace_.to_etree(element, name_='Dataspace', mapping_=mapping_)
        if self.DataType is not None:
            DataType_ = self.DataType
            DataType_.to_etree(element, name_='DataType', mapping_=mapping_)
        if self.Data is not None:
            Data_ = self.Data
            Data_.to_etree(element, name_='Data', mapping_=mapping_)
        if mapping_ is not None:
            mapping_[self] = element
        return element
    def exportLiteral(self, outfile, level, name_='Attribute'):
        level += 1
        already_processed = set()
        self.exportLiteralAttributes(outfile, level, already_processed, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, already_processed, name_):
        if self.Name is not None and 'Name' not in already_processed:
            already_processed.add('Name')
            showIndent(outfile, level)
            outfile.write('Name="%s",\n' % (self.Name,))
    def exportLiteralChildren(self, outfile, level, name_):
        if self.Dataspace is not None:
            showIndent(outfile, level)
            outfile.write('Dataspace=model_.Dataspace(\n')
            self.Dataspace.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.DataType is not None:
            showIndent(outfile, level)
            outfile.write('DataType=model_.DataType(\n')
            self.DataType.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.Data is not None:
            showIndent(outfile, level)
            outfile.write('Data=model_.Data(\n')
            self.Data.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
    def build(self, node):
        already_processed = set()
        self.buildAttributes(node, node.attrib, already_processed)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
        return self
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('Name', node)
        if value is not None and 'Name' not in already_processed:
            already_processed.add('Name')
            self.Name = value
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'Dataspace':
            obj_ = Dataspace.factory()
            obj_.build(child_)
            self.Dataspace = obj_
            obj_.original_tagname_ = 'Dataspace'
        elif nodeName_ == 'DataType':
            obj_ = DataType.factory()
            obj_.build(child_)
            self.DataType = obj_
            obj_.original_tagname_ = 'DataType'
        elif nodeName_ == 'Data':
            obj_ = Data.factory()
            obj_.build(child_)
            self.Data = obj_
            obj_.original_tagname_ = 'Data'
# end class Attribute


class BitfieldType(GeneratedsSuper):
    member_data_items_ = {
        'Size': MemberSpec_('Size', 'xs:NMTOKEN', 0),
        'ByteOrder': MemberSpec_('ByteOrder', 'xs:NMTOKEN', 0),
    }
    subclass = None
    superclass = None
    def __init__(self, Size=None, ByteOrder=None):
        self.original_tagname_ = None
        self.Size = _cast(None, Size)
        self.ByteOrder = _cast(None, ByteOrder)
    def factory(*args_, **kwargs_):
        if BitfieldType.subclass:
            return BitfieldType.subclass(*args_, **kwargs_)
        else:
            return BitfieldType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_Size(self): return self.Size
    def set_Size(self, Size): self.Size = Size
    def get_ByteOrder(self): return self.ByteOrder
    def set_ByteOrder(self, ByteOrder): self.ByteOrder = ByteOrder
    def hasContent_(self):
        if (

        ):
            return True
        else:
            return False
    def export(self, outfile, level, namespace_='hdf5:', name_='BitfieldType', namespacedef_='xmlns:hdf5="http://hdfgroup.org/HDF5/XML/schema/HDF5-File"', pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.original_tagname_ is not None:
            name_ = self.original_tagname_
        showIndent(outfile, level, pretty_print)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = set()
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='BitfieldType')
        if self.hasContent_():
            outfile.write('>%s' % (eol_, ))
            self.exportChildren(outfile, level + 1, namespace_='hdf5:', name_='BitfieldType', pretty_print=pretty_print)
            outfile.write('</%s%s>%s' % (namespace_, name_, eol_))
        else:
            outfile.write('/>%s' % (eol_, ))
    def exportAttributes(self, outfile, level, already_processed, namespace_='hdf5:', name_='BitfieldType'):
        if self.Size is not None and 'Size' not in already_processed:
            already_processed.add('Size')
            outfile.write(' Size=%s' % (self.gds_format_string(quote_attrib(self.Size).encode(ExternalEncoding), input_name='Size'), ))
        if self.ByteOrder is not None and 'ByteOrder' not in already_processed:
            already_processed.add('ByteOrder')
            outfile.write(' ByteOrder=%s' % (self.gds_format_string(quote_attrib(self.ByteOrder).encode(ExternalEncoding), input_name='ByteOrder'), ))
    def exportChildren(self, outfile, level, namespace_='hdf5:', name_='BitfieldType', fromsubclass_=False, pretty_print=True):
        pass
    def to_etree(self, parent_element=None, name_='BitfieldType', mapping_=None):
        if parent_element is None:
            element = etree_.Element('{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        else:
            element = etree_.SubElement(parent_element, '{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        if self.Size is not None:
            element.set('Size', self.gds_format_string(self.Size))
        if self.ByteOrder is not None:
            element.set('ByteOrder', self.gds_format_string(self.ByteOrder))
        if mapping_ is not None:
            mapping_[self] = element
        return element
    def exportLiteral(self, outfile, level, name_='BitfieldType'):
        level += 1
        already_processed = set()
        self.exportLiteralAttributes(outfile, level, already_processed, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, already_processed, name_):
        if self.Size is not None and 'Size' not in already_processed:
            already_processed.add('Size')
            showIndent(outfile, level)
            outfile.write('Size="%s",\n' % (self.Size,))
        if self.ByteOrder is not None and 'ByteOrder' not in already_processed:
            already_processed.add('ByteOrder')
            showIndent(outfile, level)
            outfile.write('ByteOrder="%s",\n' % (self.ByteOrder,))
    def exportLiteralChildren(self, outfile, level, name_):
        pass
    def build(self, node):
        already_processed = set()
        self.buildAttributes(node, node.attrib, already_processed)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
        return self
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('Size', node)
        if value is not None and 'Size' not in already_processed:
            already_processed.add('Size')
            self.Size = value
        value = find_attr_value_('ByteOrder', node)
        if value is not None and 'ByteOrder' not in already_processed:
            already_processed.add('ByteOrder')
            self.ByteOrder = value
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        pass
# end class BitfieldType


class ChunkDimension(GeneratedsSuper):
    member_data_items_ = {
        'DimSize': MemberSpec_('DimSize', 'xs:string', 0),
    }
    subclass = None
    superclass = None
    def __init__(self, DimSize='0'):
        self.original_tagname_ = None
        self.DimSize = _cast(None, DimSize)
    def factory(*args_, **kwargs_):
        if ChunkDimension.subclass:
            return ChunkDimension.subclass(*args_, **kwargs_)
        else:
            return ChunkDimension(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_DimSize(self): return self.DimSize
    def set_DimSize(self, DimSize): self.DimSize = DimSize
    def hasContent_(self):
        if (

        ):
            return True
        else:
            return False
    def export(self, outfile, level, namespace_='hdf5:', name_='ChunkDimension', namespacedef_='xmlns:hdf5="http://hdfgroup.org/HDF5/XML/schema/HDF5-File"', pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.original_tagname_ is not None:
            name_ = self.original_tagname_
        showIndent(outfile, level, pretty_print)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = set()
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='ChunkDimension')
        if self.hasContent_():
            outfile.write('>%s' % (eol_, ))
            self.exportChildren(outfile, level + 1, namespace_='hdf5:', name_='ChunkDimension', pretty_print=pretty_print)
            outfile.write('</%s%s>%s' % (namespace_, name_, eol_))
        else:
            outfile.write('/>%s' % (eol_, ))
    def exportAttributes(self, outfile, level, already_processed, namespace_='hdf5:', name_='ChunkDimension'):
        if self.DimSize is not None and 'DimSize' not in already_processed:
            already_processed.add('DimSize')
            outfile.write(' DimSize=%s' % (self.gds_format_string(quote_attrib(self.DimSize).encode(ExternalEncoding), input_name='DimSize'), ))
    def exportChildren(self, outfile, level, namespace_='hdf5:', name_='ChunkDimension', fromsubclass_=False, pretty_print=True):
        pass
    def to_etree(self, parent_element=None, name_='ChunkDimension', mapping_=None):
        if parent_element is None:
            element = etree_.Element('{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        else:
            element = etree_.SubElement(parent_element, '{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        if self.DimSize is not None:
            element.set('DimSize', self.gds_format_string(self.DimSize))
        if mapping_ is not None:
            mapping_[self] = element
        return element
    def exportLiteral(self, outfile, level, name_='ChunkDimension'):
        level += 1
        already_processed = set()
        self.exportLiteralAttributes(outfile, level, already_processed, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, already_processed, name_):
        if self.DimSize is not None and 'DimSize' not in already_processed:
            already_processed.add('DimSize')
            showIndent(outfile, level)
            outfile.write('DimSize="%s",\n' % (self.DimSize,))
    def exportLiteralChildren(self, outfile, level, name_):
        pass
    def build(self, node):
        already_processed = set()
        self.buildAttributes(node, node.attrib, already_processed)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
        return self
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('DimSize', node)
        if value is not None and 'DimSize' not in already_processed:
            already_processed.add('DimSize')
            self.DimSize = value
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        pass
# end class ChunkDimension


class ChunkedLayout(GeneratedsSuper):
    member_data_items_ = {
        'Ndims': MemberSpec_('Ndims', 'xs:string', 0),
        'Compression': MemberSpec_('Compression', ['Compression', 'xs:string'], 0),
        'ChunkDimension': MemberSpec_('ChunkDimension', 'ChunkDimension', 1),
        'RequiredFilter': MemberSpec_('RequiredFilter', 'RequiredFilter', 1),
    }
    subclass = None
    superclass = None
    def __init__(self, Ndims=None, Compression=None, ChunkDimension=None, RequiredFilter=None):
        self.original_tagname_ = None
        self.Ndims = _cast(None, Ndims)
        self.Compression = Compression
        if ChunkDimension is None:
            self.ChunkDimension = []
        else:
            self.ChunkDimension = ChunkDimension
        if RequiredFilter is None:
            self.RequiredFilter = []
        else:
            self.RequiredFilter = RequiredFilter
    def factory(*args_, **kwargs_):
        if ChunkedLayout.subclass:
            return ChunkedLayout.subclass(*args_, **kwargs_)
        else:
            return ChunkedLayout(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_Compression(self): return self.Compression
    def set_Compression(self, Compression): self.Compression = Compression
    def get_ChunkDimension(self): return self.ChunkDimension
    def set_ChunkDimension(self, ChunkDimension): self.ChunkDimension = ChunkDimension
    def add_ChunkDimension(self, value): self.ChunkDimension.append(value)
    def insert_ChunkDimension(self, index, value): self.ChunkDimension[index] = value
    def get_RequiredFilter(self): return self.RequiredFilter
    def set_RequiredFilter(self, RequiredFilter): self.RequiredFilter = RequiredFilter
    def add_RequiredFilter(self, value): self.RequiredFilter.append(value)
    def insert_RequiredFilter(self, index, value): self.RequiredFilter[index] = value
    def get_Ndims(self): return self.Ndims
    def set_Ndims(self, Ndims): self.Ndims = Ndims
    def hasContent_(self):
        if (
            self.Compression is not None or
            self.ChunkDimension or
            self.RequiredFilter
        ):
            return True
        else:
            return False
    def export(self, outfile, level, namespace_='hdf5:', name_='ChunkedLayout', namespacedef_='xmlns:hdf5="http://hdfgroup.org/HDF5/XML/schema/HDF5-File"', pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.original_tagname_ is not None:
            name_ = self.original_tagname_
        showIndent(outfile, level, pretty_print)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = set()
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='ChunkedLayout')
        if self.hasContent_():
            outfile.write('>%s' % (eol_, ))
            self.exportChildren(outfile, level + 1, namespace_='hdf5:', name_='ChunkedLayout', pretty_print=pretty_print)
            showIndent(outfile, level, pretty_print)
            outfile.write('</%s%s>%s' % (namespace_, name_, eol_))
        else:
            outfile.write('/>%s' % (eol_, ))
    def exportAttributes(self, outfile, level, already_processed, namespace_='hdf5:', name_='ChunkedLayout'):
        if self.Ndims is not None and 'Ndims' not in already_processed:
            already_processed.add('Ndims')
            outfile.write(' Ndims=%s' % (self.gds_format_string(quote_attrib(self.Ndims).encode(ExternalEncoding), input_name='Ndims'), ))
    def exportChildren(self, outfile, level, namespace_='hdf5:', name_='ChunkedLayout', fromsubclass_=False, pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.Compression is not None:
            showIndent(outfile, level, pretty_print)
            outfile.write('<%sCompression>%s</%sCompression>%s' % (namespace_, self.gds_format_string(quote_xml(self.Compression).encode(ExternalEncoding), input_name='Compression'), namespace_, eol_))
        for ChunkDimension_ in self.ChunkDimension:
            ChunkDimension_.export(outfile, level, namespace_='hdf5:', name_='ChunkDimension', pretty_print=pretty_print)
        for RequiredFilter_ in self.RequiredFilter:
            RequiredFilter_.export(outfile, level, namespace_='hdf5:', name_='RequiredFilter', pretty_print=pretty_print)
    def to_etree(self, parent_element=None, name_='ChunkedLayout', mapping_=None):
        if parent_element is None:
            element = etree_.Element('{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        else:
            element = etree_.SubElement(parent_element, '{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        if self.Ndims is not None:
            element.set('Ndims', self.gds_format_string(self.Ndims))
        if self.Compression is not None:
            Compression_ = self.Compression
            etree_.SubElement(element, '{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}Compression').text = self.gds_format_string(Compression_)
        for ChunkDimension_ in self.ChunkDimension:
            ChunkDimension_.to_etree(element, name_='ChunkDimension', mapping_=mapping_)
        for RequiredFilter_ in self.RequiredFilter:
            RequiredFilter_.to_etree(element, name_='RequiredFilter', mapping_=mapping_)
        if mapping_ is not None:
            mapping_[self] = element
        return element
    def exportLiteral(self, outfile, level, name_='ChunkedLayout'):
        level += 1
        already_processed = set()
        self.exportLiteralAttributes(outfile, level, already_processed, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, already_processed, name_):
        if self.Ndims is not None and 'Ndims' not in already_processed:
            already_processed.add('Ndims')
            showIndent(outfile, level)
            outfile.write('Ndims="%s",\n' % (self.Ndims,))
    def exportLiteralChildren(self, outfile, level, name_):
        if self.Compression is not None:
            showIndent(outfile, level)
            outfile.write('Compression=%s,\n' % quote_python(self.Compression).encode(ExternalEncoding))
        showIndent(outfile, level)
        outfile.write('ChunkDimension=[\n')
        level += 1
        for ChunkDimension_ in self.ChunkDimension:
            showIndent(outfile, level)
            outfile.write('model_.ChunkDimension(\n')
            ChunkDimension_.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
        showIndent(outfile, level)
        outfile.write('RequiredFilter=[\n')
        level += 1
        for RequiredFilter_ in self.RequiredFilter:
            showIndent(outfile, level)
            outfile.write('model_.RequiredFilter(\n')
            RequiredFilter_.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
    def build(self, node):
        already_processed = set()
        self.buildAttributes(node, node.attrib, already_processed)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
        return self
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('Ndims', node)
        if value is not None and 'Ndims' not in already_processed:
            already_processed.add('Ndims')
            self.Ndims = value
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'Compression':
            Compression_ = child_.text
            Compression_ = self.gds_validate_string(Compression_, node, 'Compression')
            self.Compression = Compression_
        elif nodeName_ == 'ChunkDimension':
            obj_ = ChunkDimension.factory()
            obj_.build(child_)
            self.ChunkDimension.append(obj_)
            obj_.original_tagname_ = 'ChunkDimension'
        elif nodeName_ == 'RequiredFilter':
            obj_ = RequiredFilter.factory()
            obj_.build(child_)
            self.RequiredFilter.append(obj_)
            obj_.original_tagname_ = 'RequiredFilter'
# end class ChunkedLayout


class Compression(GeneratedsSuper):
    """This element is denigrated. Compression is one of the required
    filters"""
    member_data_items_ = {
    }
    subclass = None
    superclass = None
    def __init__(self):
        self.original_tagname_ = None
    def factory(*args_, **kwargs_):
        if Compression.subclass:
            return Compression.subclass(*args_, **kwargs_)
        else:
            return Compression(*args_, **kwargs_)
    factory = staticmethod(factory)
    def hasContent_(self):
        if (

        ):
            return True
        else:
            return False
    def export(self, outfile, level, namespace_='hdf5:', name_='Compression', namespacedef_='xmlns:hdf5="http://hdfgroup.org/HDF5/XML/schema/HDF5-File"', pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.original_tagname_ is not None:
            name_ = self.original_tagname_
        showIndent(outfile, level, pretty_print)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = set()
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='Compression')
        if self.hasContent_():
            outfile.write('>%s' % (eol_, ))
            self.exportChildren(outfile, level + 1, namespace_='hdf5:', name_='Compression', pretty_print=pretty_print)
            outfile.write('</%s%s>%s' % (namespace_, name_, eol_))
        else:
            outfile.write('/>%s' % (eol_, ))
    def exportAttributes(self, outfile, level, already_processed, namespace_='hdf5:', name_='Compression'):
        pass
    def exportChildren(self, outfile, level, namespace_='hdf5:', name_='Compression', fromsubclass_=False, pretty_print=True):
        pass
    def to_etree(self, parent_element=None, name_='Compression', mapping_=None):
        if parent_element is None:
            element = etree_.Element('{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        else:
            element = etree_.SubElement(parent_element, '{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        if mapping_ is not None:
            mapping_[self] = element
        return element
    def exportLiteral(self, outfile, level, name_='Compression'):
        level += 1
        already_processed = set()
        self.exportLiteralAttributes(outfile, level, already_processed, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, already_processed, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        pass
    def build(self, node):
        already_processed = set()
        self.buildAttributes(node, node.attrib, already_processed)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
        return self
    def buildAttributes(self, node, attrs, already_processed):
        pass
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        pass
# end class Compression


class CompactLayout(GeneratedsSuper):
    member_data_items_ = {
    }
    subclass = None
    superclass = None
    def __init__(self):
        self.original_tagname_ = None
    def factory(*args_, **kwargs_):
        if CompactLayout.subclass:
            return CompactLayout.subclass(*args_, **kwargs_)
        else:
            return CompactLayout(*args_, **kwargs_)
    factory = staticmethod(factory)
    def hasContent_(self):
        if (

        ):
            return True
        else:
            return False
    def export(self, outfile, level, namespace_='hdf5:', name_='CompactLayout', namespacedef_='xmlns:hdf5="http://hdfgroup.org/HDF5/XML/schema/HDF5-File"', pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.original_tagname_ is not None:
            name_ = self.original_tagname_
        showIndent(outfile, level, pretty_print)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = set()
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='CompactLayout')
        if self.hasContent_():
            outfile.write('>%s' % (eol_, ))
            self.exportChildren(outfile, level + 1, namespace_='hdf5:', name_='CompactLayout', pretty_print=pretty_print)
            outfile.write('</%s%s>%s' % (namespace_, name_, eol_))
        else:
            outfile.write('/>%s' % (eol_, ))
    def exportAttributes(self, outfile, level, already_processed, namespace_='hdf5:', name_='CompactLayout'):
        pass
    def exportChildren(self, outfile, level, namespace_='hdf5:', name_='CompactLayout', fromsubclass_=False, pretty_print=True):
        pass
    def to_etree(self, parent_element=None, name_='CompactLayout', mapping_=None):
        if parent_element is None:
            element = etree_.Element('{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        else:
            element = etree_.SubElement(parent_element, '{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        if mapping_ is not None:
            mapping_[self] = element
        return element
    def exportLiteral(self, outfile, level, name_='CompactLayout'):
        level += 1
        already_processed = set()
        self.exportLiteralAttributes(outfile, level, already_processed, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, already_processed, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        pass
    def build(self, node):
        already_processed = set()
        self.buildAttributes(node, node.attrib, already_processed)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
        return self
    def buildAttributes(self, node, attrs, already_processed):
        pass
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        pass
# end class CompactLayout


class ComplexDataspace(GeneratedsSuper):
    """This option is not implemented."""
    member_data_items_ = {
    }
    subclass = None
    superclass = None
    def __init__(self):
        self.original_tagname_ = None
    def factory(*args_, **kwargs_):
        if ComplexDataspace.subclass:
            return ComplexDataspace.subclass(*args_, **kwargs_)
        else:
            return ComplexDataspace(*args_, **kwargs_)
    factory = staticmethod(factory)
    def hasContent_(self):
        if (

        ):
            return True
        else:
            return False
    def export(self, outfile, level, namespace_='hdf5:', name_='ComplexDataspace', namespacedef_='xmlns:hdf5="http://hdfgroup.org/HDF5/XML/schema/HDF5-File"', pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.original_tagname_ is not None:
            name_ = self.original_tagname_
        showIndent(outfile, level, pretty_print)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = set()
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='ComplexDataspace')
        if self.hasContent_():
            outfile.write('>%s' % (eol_, ))
            self.exportChildren(outfile, level + 1, namespace_='hdf5:', name_='ComplexDataspace', pretty_print=pretty_print)
            outfile.write('</%s%s>%s' % (namespace_, name_, eol_))
        else:
            outfile.write('/>%s' % (eol_, ))
    def exportAttributes(self, outfile, level, already_processed, namespace_='hdf5:', name_='ComplexDataspace'):
        pass
    def exportChildren(self, outfile, level, namespace_='hdf5:', name_='ComplexDataspace', fromsubclass_=False, pretty_print=True):
        pass
    def to_etree(self, parent_element=None, name_='ComplexDataspace', mapping_=None):
        if parent_element is None:
            element = etree_.Element('{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        else:
            element = etree_.SubElement(parent_element, '{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        if mapping_ is not None:
            mapping_[self] = element
        return element
    def exportLiteral(self, outfile, level, name_='ComplexDataspace'):
        level += 1
        already_processed = set()
        self.exportLiteralAttributes(outfile, level, already_processed, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, already_processed, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        pass
    def build(self, node):
        already_processed = set()
        self.buildAttributes(node, node.attrib, already_processed)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
        return self
    def buildAttributes(self, node, attrs, already_processed):
        pass
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        pass
# end class ComplexDataspace


class CompoundType(GeneratedsSuper):
    member_data_items_ = {
        'Field': MemberSpec_('Field', 'Field', 1),
    }
    subclass = None
    superclass = None
    def __init__(self, Field=None):
        self.original_tagname_ = None
        if Field is None:
            self.Field = []
        else:
            self.Field = Field
    def factory(*args_, **kwargs_):
        if CompoundType.subclass:
            return CompoundType.subclass(*args_, **kwargs_)
        else:
            return CompoundType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_Field(self): return self.Field
    def set_Field(self, Field): self.Field = Field
    def add_Field(self, value): self.Field.append(value)
    def insert_Field(self, index, value): self.Field[index] = value
    def hasContent_(self):
        if (
            self.Field
        ):
            return True
        else:
            return False
    def export(self, outfile, level, namespace_='hdf5:', name_='CompoundType', namespacedef_='xmlns:hdf5="http://hdfgroup.org/HDF5/XML/schema/HDF5-File"', pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.original_tagname_ is not None:
            name_ = self.original_tagname_
        showIndent(outfile, level, pretty_print)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = set()
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='CompoundType')
        if self.hasContent_():
            outfile.write('>%s' % (eol_, ))
            self.exportChildren(outfile, level + 1, namespace_='hdf5:', name_='CompoundType', pretty_print=pretty_print)
            showIndent(outfile, level, pretty_print)
            outfile.write('</%s%s>%s' % (namespace_, name_, eol_))
        else:
            outfile.write('/>%s' % (eol_, ))
    def exportAttributes(self, outfile, level, already_processed, namespace_='hdf5:', name_='CompoundType'):
        pass
    def exportChildren(self, outfile, level, namespace_='hdf5:', name_='CompoundType', fromsubclass_=False, pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        for Field_ in self.Field:
            Field_.export(outfile, level, namespace_='hdf5:', name_='Field', pretty_print=pretty_print)
    def to_etree(self, parent_element=None, name_='CompoundType', mapping_=None):
        if parent_element is None:
            element = etree_.Element('{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        else:
            element = etree_.SubElement(parent_element, '{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        for Field_ in self.Field:
            Field_.to_etree(element, name_='Field', mapping_=mapping_)
        if mapping_ is not None:
            mapping_[self] = element
        return element
    def exportLiteral(self, outfile, level, name_='CompoundType'):
        level += 1
        already_processed = set()
        self.exportLiteralAttributes(outfile, level, already_processed, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, already_processed, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('Field=[\n')
        level += 1
        for Field_ in self.Field:
            showIndent(outfile, level)
            outfile.write('model_.Field(\n')
            Field_.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
    def build(self, node):
        already_processed = set()
        self.buildAttributes(node, node.attrib, already_processed)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
        return self
    def buildAttributes(self, node, attrs, already_processed):
        pass
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'Field':
            obj_ = Field.factory()
            obj_.build(child_)
            self.Field.append(obj_)
            obj_.original_tagname_ = 'Field'
# end class CompoundType


class ContiguousLayout(GeneratedsSuper):
    member_data_items_ = {
    }
    subclass = None
    superclass = None
    def __init__(self):
        self.original_tagname_ = None
    def factory(*args_, **kwargs_):
        if ContiguousLayout.subclass:
            return ContiguousLayout.subclass(*args_, **kwargs_)
        else:
            return ContiguousLayout(*args_, **kwargs_)
    factory = staticmethod(factory)
    def hasContent_(self):
        if (

        ):
            return True
        else:
            return False
    def export(self, outfile, level, namespace_='hdf5:', name_='ContiguousLayout', namespacedef_='xmlns:hdf5="http://hdfgroup.org/HDF5/XML/schema/HDF5-File"', pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.original_tagname_ is not None:
            name_ = self.original_tagname_
        showIndent(outfile, level, pretty_print)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = set()
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='ContiguousLayout')
        if self.hasContent_():
            outfile.write('>%s' % (eol_, ))
            self.exportChildren(outfile, level + 1, namespace_='hdf5:', name_='ContiguousLayout', pretty_print=pretty_print)
            outfile.write('</%s%s>%s' % (namespace_, name_, eol_))
        else:
            outfile.write('/>%s' % (eol_, ))
    def exportAttributes(self, outfile, level, already_processed, namespace_='hdf5:', name_='ContiguousLayout'):
        pass
    def exportChildren(self, outfile, level, namespace_='hdf5:', name_='ContiguousLayout', fromsubclass_=False, pretty_print=True):
        pass
    def to_etree(self, parent_element=None, name_='ContiguousLayout', mapping_=None):
        if parent_element is None:
            element = etree_.Element('{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        else:
            element = etree_.SubElement(parent_element, '{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        if mapping_ is not None:
            mapping_[self] = element
        return element
    def exportLiteral(self, outfile, level, name_='ContiguousLayout'):
        level += 1
        already_processed = set()
        self.exportLiteralAttributes(outfile, level, already_processed, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, already_processed, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        pass
    def build(self, node):
        already_processed = set()
        self.buildAttributes(node, node.attrib, already_processed)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
        return self
    def buildAttributes(self, node, attrs, already_processed):
        pass
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        pass
# end class ContiguousLayout


class Data(GeneratedsSuper):
    member_data_items_ = {
        'NativeHDF5': MemberSpec_('NativeHDF5', 'NativeHDF5', 0),
        'DataFromFile': MemberSpec_('DataFromFile', 'xs:string', 0),
        'NoData': MemberSpec_('NoData', 'NoData', 0),
    }
    subclass = None
    superclass = None
    def __init__(self, NativeHDF5=None, DataFromFile=None, NoData=None):
        self.original_tagname_ = None
        self.NativeHDF5 = NativeHDF5
        self.DataFromFile = DataFromFile
        self.NoData = NoData
    def factory(*args_, **kwargs_):
        if Data.subclass:
            return Data.subclass(*args_, **kwargs_)
        else:
            return Data(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_NativeHDF5(self): return self.NativeHDF5
    def set_NativeHDF5(self, NativeHDF5): self.NativeHDF5 = NativeHDF5
    def get_DataFromFile(self): return self.DataFromFile
    def set_DataFromFile(self, DataFromFile): self.DataFromFile = DataFromFile
    def get_NoData(self): return self.NoData
    def set_NoData(self, NoData): self.NoData = NoData
    def hasContent_(self):
        if (
            self.NativeHDF5 is not None or
            self.DataFromFile is not None or
            self.NoData is not None
        ):
            return True
        else:
            return False
    def export(self, outfile, level, namespace_='hdf5:', name_='Data', namespacedef_='xmlns:hdf5="http://hdfgroup.org/HDF5/XML/schema/HDF5-File"', pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.original_tagname_ is not None:
            name_ = self.original_tagname_
        showIndent(outfile, level, pretty_print)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = set()
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='Data')
        if self.hasContent_():
            outfile.write('>%s' % (eol_, ))
            self.exportChildren(outfile, level + 1, namespace_='hdf5:', name_='Data', pretty_print=pretty_print)
            showIndent(outfile, level, pretty_print)
            outfile.write('</%s%s>%s' % (namespace_, name_, eol_))
        else:
            outfile.write('/>%s' % (eol_, ))
    def exportAttributes(self, outfile, level, already_processed, namespace_='hdf5:', name_='Data'):
        pass
    def exportChildren(self, outfile, level, namespace_='hdf5:', name_='Data', fromsubclass_=False, pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.NativeHDF5 is not None:
            self.NativeHDF5.export(outfile, level, namespace_='hdf5:', name_='NativeHDF5', pretty_print=pretty_print)
        if self.DataFromFile is not None:
            showIndent(outfile, level, pretty_print)
            outfile.write('<%sDataFromFile>%s</%sDataFromFile>%s' % ('hdf5:', self.gds_format_string(quote_xml(self.DataFromFile).encode(ExternalEncoding), input_name='DataFromFile'), 'hdf5:', eol_))
        if self.NoData is not None:
            self.NoData.export(outfile, level, namespace_='hdf5:', name_='NoData', pretty_print=pretty_print)
    def to_etree(self, parent_element=None, name_='Data', mapping_=None):
        if parent_element is None:
            element = etree_.Element('{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        else:
            element = etree_.SubElement(parent_element, '{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        if self.NativeHDF5 is not None:
            NativeHDF5_ = self.NativeHDF5
            NativeHDF5_.to_etree(element, name_='NativeHDF5', mapping_=mapping_)
        if self.DataFromFile is not None:
            DataFromFile_ = self.DataFromFile
            etree_.SubElement(element, '{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}DataFromFile').text = self.gds_format_string(DataFromFile_)
        if self.NoData is not None:
            NoData_ = self.NoData
            NoData_.to_etree(element, name_='NoData', mapping_=mapping_)
        if mapping_ is not None:
            mapping_[self] = element
        return element
    def exportLiteral(self, outfile, level, name_='Data'):
        level += 1
        already_processed = set()
        self.exportLiteralAttributes(outfile, level, already_processed, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, already_processed, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        if self.NativeHDF5 is not None:
            showIndent(outfile, level)
            outfile.write('NativeHDF5=model_.NativeHDF5(\n')
            self.NativeHDF5.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.DataFromFile is not None:
            showIndent(outfile, level)
            outfile.write('DataFromFile=%s,\n' % quote_python(self.DataFromFile).encode(ExternalEncoding))
        if self.NoData is not None:
            showIndent(outfile, level)
            outfile.write('NoData=model_.NoData(\n')
            self.NoData.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
    def build(self, node):
        already_processed = set()
        self.buildAttributes(node, node.attrib, already_processed)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
        return self
    def buildAttributes(self, node, attrs, already_processed):
        pass
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'NativeHDF5':
            obj_ = NativeHDF5.factory()
            obj_.build(child_)
            self.NativeHDF5 = obj_
            obj_.original_tagname_ = 'NativeHDF5'
        elif nodeName_ == 'DataFromFile':
            DataFromFile_ = child_.text
            DataFromFile_ = self.gds_validate_string(DataFromFile_, node, 'DataFromFile')
            self.DataFromFile = DataFromFile_
        elif nodeName_ == 'NoData':
            obj_ = NoData.factory()
            obj_.build(child_)
            self.NoData = obj_
            obj_.original_tagname_ = 'NoData'
# end class Data


class DataType(GeneratedsSuper):
    member_data_items_ = {
        'AtomicType': MemberSpec_('AtomicType', 'AtomicType', 0),
        'CompoundType': MemberSpec_('CompoundType', 'CompoundType', 0),
        'VLType': MemberSpec_('VLType', 'VLType', 0),
        'ArrayType': MemberSpec_('ArrayType', 'ArrayType', 0),
    }
    subclass = None
    superclass = None
    def __init__(self, AtomicType=None, CompoundType=None, VLType=None, ArrayType=None):
        self.original_tagname_ = None
        self.AtomicType = AtomicType
        self.CompoundType = CompoundType
        self.VLType = VLType
        self.ArrayType = ArrayType
    def factory(*args_, **kwargs_):
        if DataType.subclass:
            return DataType.subclass(*args_, **kwargs_)
        else:
            return DataType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_AtomicType(self): return self.AtomicType
    def set_AtomicType(self, AtomicType): self.AtomicType = AtomicType
    def get_CompoundType(self): return self.CompoundType
    def set_CompoundType(self, CompoundType): self.CompoundType = CompoundType
    def get_VLType(self): return self.VLType
    def set_VLType(self, VLType): self.VLType = VLType
    def get_ArrayType(self): return self.ArrayType
    def set_ArrayType(self, ArrayType): self.ArrayType = ArrayType
    def hasContent_(self):
        if (
            self.AtomicType is not None or
            self.CompoundType is not None or
            self.VLType is not None or
            self.ArrayType is not None
        ):
            return True
        else:
            return False
    def export(self, outfile, level, namespace_='hdf5:', name_='DataType', namespacedef_='xmlns:hdf5="http://hdfgroup.org/HDF5/XML/schema/HDF5-File"', pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.original_tagname_ is not None:
            name_ = self.original_tagname_
        showIndent(outfile, level, pretty_print)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = set()
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='DataType')
        if self.hasContent_():
            outfile.write('>%s' % (eol_, ))
            self.exportChildren(outfile, level + 1, namespace_='hdf5:', name_='DataType', pretty_print=pretty_print)
            showIndent(outfile, level, pretty_print)
            outfile.write('</%s%s>%s' % (namespace_, name_, eol_))
        else:
            outfile.write('/>%s' % (eol_, ))
    def exportAttributes(self, outfile, level, already_processed, namespace_='hdf5:', name_='DataType'):
        pass
    def exportChildren(self, outfile, level, namespace_='hdf5:', name_='DataType', fromsubclass_=False, pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.AtomicType is not None:
            self.AtomicType.export(outfile, level, namespace_='hdf5:', name_='AtomicType', pretty_print=pretty_print)
        if self.CompoundType is not None:
            self.CompoundType.export(outfile, level, namespace_='hdf5:', name_='CompoundType', pretty_print=pretty_print)
        if self.VLType is not None:
            self.VLType.export(outfile, level, namespace_='hdf5:', name_='VLType', pretty_print=pretty_print)
        if self.ArrayType is not None:
            self.ArrayType.export(outfile, level, namespace_='hdf5:', name_='ArrayType', pretty_print=pretty_print)
    def to_etree(self, parent_element=None, name_='DataType', mapping_=None):
        if parent_element is None:
            element = etree_.Element('{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        else:
            element = etree_.SubElement(parent_element, '{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        if self.AtomicType is not None:
            AtomicType_ = self.AtomicType
            AtomicType_.to_etree(element, name_='AtomicType', mapping_=mapping_)
        if self.CompoundType is not None:
            CompoundType_ = self.CompoundType
            CompoundType_.to_etree(element, name_='CompoundType', mapping_=mapping_)
        if self.VLType is not None:
            VLType_ = self.VLType
            VLType_.to_etree(element, name_='VLType', mapping_=mapping_)
        if self.ArrayType is not None:
            ArrayType_ = self.ArrayType
            ArrayType_.to_etree(element, name_='ArrayType', mapping_=mapping_)
        if mapping_ is not None:
            mapping_[self] = element
        return element
    def exportLiteral(self, outfile, level, name_='DataType'):
        level += 1
        already_processed = set()
        self.exportLiteralAttributes(outfile, level, already_processed, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, already_processed, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        if self.AtomicType is not None:
            showIndent(outfile, level)
            outfile.write('AtomicType=model_.AtomicType(\n')
            self.AtomicType.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.CompoundType is not None:
            showIndent(outfile, level)
            outfile.write('CompoundType=model_.CompoundType(\n')
            self.CompoundType.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.VLType is not None:
            showIndent(outfile, level)
            outfile.write('VLType=model_.VLType(\n')
            self.VLType.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.ArrayType is not None:
            showIndent(outfile, level)
            outfile.write('ArrayType=model_.ArrayType(\n')
            self.ArrayType.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
    def build(self, node):
        already_processed = set()
        self.buildAttributes(node, node.attrib, already_processed)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
        return self
    def buildAttributes(self, node, attrs, already_processed):
        pass
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'AtomicType':
            obj_ = AtomicType.factory()
            obj_.build(child_)
            self.AtomicType = obj_
            obj_.original_tagname_ = 'AtomicType'
        elif nodeName_ == 'CompoundType':
            obj_ = CompoundType.factory()
            obj_.build(child_)
            self.CompoundType = obj_
            obj_.original_tagname_ = 'CompoundType'
        elif nodeName_ == 'VLType':
            obj_ = VLType.factory()
            obj_.build(child_)
            self.VLType = obj_
            obj_.original_tagname_ = 'VLType'
        elif nodeName_ == 'ArrayType':
            obj_ = ArrayType.factory()
            obj_.build(child_)
            self.ArrayType = obj_
            obj_.original_tagname_ = 'ArrayType'
# end class DataType


class Dataset(GeneratedsSuper):
    member_data_items_ = {
        'OBJ-XID': MemberSpec_('OBJ-XID', 'xs:string', 0),
        'H5ParentPaths': MemberSpec_('H5ParentPaths', 'xs:string', 0),
        'Parents': MemberSpec_('Parents', 'xs:string', 0),
        'Name': MemberSpec_('Name', 'xs:string', 0),
        'H5Path': MemberSpec_('H5Path', 'xs:string', 0),
        'DatasetPtr': MemberSpec_('DatasetPtr', 'DatasetPtr', 0),
        'StorageLayout': MemberSpec_('StorageLayout', 'StorageLayout', 0),
        'FillValueInfo': MemberSpec_('FillValueInfo', 'FillValueInfo', 0),
        'Dataspace': MemberSpec_('Dataspace', 'Dataspace', 0),
        'DataType': MemberSpec_('DataType', 'DataType', 0),
        'NamedDataTypePtr': MemberSpec_('NamedDataTypePtr', 'NamedDataTypePtr', 0),
        'Attribute': MemberSpec_('Attribute', 'Attribute', 1),
        'Data': MemberSpec_('Data', 'Data', 0),
    }
    subclass = None
    superclass = None
    def __init__(self, OBJ_XID=None, H5ParentPaths=None, Parents=None, Name=None, H5Path=None, DatasetPtr=None, StorageLayout=None, FillValueInfo=None, Dataspace=None, DataType=None, NamedDataTypePtr=None, Attribute=None, Data=None):
        self.original_tagname_ = None
        self.OBJ_XID = _cast(None, OBJ_XID)
        self.H5ParentPaths = _cast(None, H5ParentPaths)
        self.Parents = _cast(None, Parents)
        self.Name = _cast(None, Name)
        self.H5Path = _cast(None, H5Path)
        self.DatasetPtr = DatasetPtr
        self.StorageLayout = StorageLayout
        self.FillValueInfo = FillValueInfo
        self.Dataspace = Dataspace
        self.DataType = DataType
        self.NamedDataTypePtr = NamedDataTypePtr
        if Attribute is None:
            self.Attribute = []
        else:
            self.Attribute = Attribute
        self.Data = Data
    def factory(*args_, **kwargs_):
        if Dataset.subclass:
            return Dataset.subclass(*args_, **kwargs_)
        else:
            return Dataset(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_DatasetPtr(self): return self.DatasetPtr
    def set_DatasetPtr(self, DatasetPtr): self.DatasetPtr = DatasetPtr
    def get_StorageLayout(self): return self.StorageLayout
    def set_StorageLayout(self, StorageLayout): self.StorageLayout = StorageLayout
    def get_FillValueInfo(self): return self.FillValueInfo
    def set_FillValueInfo(self, FillValueInfo): self.FillValueInfo = FillValueInfo
    def get_Dataspace(self): return self.Dataspace
    def set_Dataspace(self, Dataspace): self.Dataspace = Dataspace
    def get_DataType(self): return self.DataType
    def set_DataType(self, DataType): self.DataType = DataType
    def get_NamedDataTypePtr(self): return self.NamedDataTypePtr
    def set_NamedDataTypePtr(self, NamedDataTypePtr): self.NamedDataTypePtr = NamedDataTypePtr
    def get_Attribute(self): return self.Attribute
    def set_Attribute(self, Attribute): self.Attribute = Attribute
    def add_Attribute(self, value): self.Attribute.append(value)
    def insert_Attribute(self, index, value): self.Attribute[index] = value
    def get_Data(self): return self.Data
    def set_Data(self, Data): self.Data = Data
    def get_OBJ_XID(self): return self.OBJ_XID
    def set_OBJ_XID(self, OBJ_XID): self.OBJ_XID = OBJ_XID
    def get_H5ParentPaths(self): return self.H5ParentPaths
    def set_H5ParentPaths(self, H5ParentPaths): self.H5ParentPaths = H5ParentPaths
    def get_Parents(self): return self.Parents
    def set_Parents(self, Parents): self.Parents = Parents
    def get_Name(self): return self.Name
    def set_Name(self, Name): self.Name = Name
    def get_H5Path(self): return self.H5Path
    def set_H5Path(self, H5Path): self.H5Path = H5Path
    def hasContent_(self):
        if (
            self.DatasetPtr is not None or
            self.StorageLayout is not None or
            self.FillValueInfo is not None or
            self.Dataspace is not None or
            self.DataType is not None or
            self.NamedDataTypePtr is not None or
            self.Attribute or
            self.Data is not None
        ):
            return True
        else:
            return False
    def export(self, outfile, level, namespace_='hdf5:', name_='Dataset', namespacedef_='xmlns:hdf5="http://hdfgroup.org/HDF5/XML/schema/HDF5-File"', pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.original_tagname_ is not None:
            name_ = self.original_tagname_
        showIndent(outfile, level, pretty_print)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = set()
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='Dataset')
        if self.hasContent_():
            outfile.write('>%s' % (eol_, ))
            self.exportChildren(outfile, level + 1, namespace_='hdf5:', name_='Dataset', pretty_print=pretty_print)
            showIndent(outfile, level, pretty_print)
            outfile.write('</%s%s>%s' % (namespace_, name_, eol_))
        else:
            outfile.write('/>%s' % (eol_, ))
    def exportAttributes(self, outfile, level, already_processed, namespace_='hdf5:', name_='Dataset'):
        if self.OBJ_XID is not None and 'OBJ_XID' not in already_processed:
            already_processed.add('OBJ_XID')
            outfile.write(' OBJ-XID=%s' % (self.gds_format_string(quote_attrib(self.OBJ_XID).encode(ExternalEncoding), input_name='OBJ-XID'), ))
        if self.H5ParentPaths is not None and 'H5ParentPaths' not in already_processed:
            already_processed.add('H5ParentPaths')
            outfile.write(' H5ParentPaths=%s' % (self.gds_format_string(quote_attrib(self.H5ParentPaths).encode(ExternalEncoding), input_name='H5ParentPaths'), ))
        if self.Parents is not None and 'Parents' not in already_processed:
            already_processed.add('Parents')
            outfile.write(' Parents=%s' % (self.gds_format_string(quote_attrib(self.Parents).encode(ExternalEncoding), input_name='Parents'), ))
        if self.Name is not None and 'Name' not in already_processed:
            already_processed.add('Name')
            outfile.write(' Name=%s' % (self.gds_format_string(quote_attrib(self.Name).encode(ExternalEncoding), input_name='Name'), ))
        if self.H5Path is not None and 'H5Path' not in already_processed:
            already_processed.add('H5Path')
            outfile.write(' H5Path=%s' % (self.gds_format_string(quote_attrib(self.H5Path).encode(ExternalEncoding), input_name='H5Path'), ))
    def exportChildren(self, outfile, level, namespace_='hdf5:', name_='Dataset', fromsubclass_=False, pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.DatasetPtr is not None:
            self.DatasetPtr.export(outfile, level, namespace_='hdf5:', name_='DatasetPtr', pretty_print=pretty_print)
        if self.StorageLayout is not None:
            self.StorageLayout.export(outfile, level, namespace_='hdf5:', name_='StorageLayout', pretty_print=pretty_print)
        if self.FillValueInfo is not None:
            self.FillValueInfo.export(outfile, level, namespace_='hdf5:', name_='FillValueInfo', pretty_print=pretty_print)
        if self.Dataspace is not None:
            self.Dataspace.export(outfile, level, namespace_='hdf5:', name_='Dataspace', pretty_print=pretty_print)
        if self.DataType is not None:
            self.DataType.export(outfile, level, namespace_='hdf5:', name_='DataType', pretty_print=pretty_print)
        if self.NamedDataTypePtr is not None:
            self.NamedDataTypePtr.export(outfile, level, namespace_='hdf5:', name_='NamedDataTypePtr', pretty_print=pretty_print)
        for Attribute_ in self.Attribute:
            Attribute_.export(outfile, level, namespace_='hdf5:', name_='Attribute', pretty_print=pretty_print)
        if self.Data is not None:
            self.Data.export(outfile, level, namespace_='hdf5:', name_='Data', pretty_print=pretty_print)
    def to_etree(self, parent_element=None, name_='Dataset', mapping_=None):
        if parent_element is None:
            element = etree_.Element('{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        else:
            element = etree_.SubElement(parent_element, '{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        if self.OBJ_XID is not None:
            element.set('OBJ-XID', self.gds_format_string(self.OBJ_XID))
        if self.H5ParentPaths is not None:
            element.set('H5ParentPaths', self.gds_format_string(self.H5ParentPaths))
        if self.Parents is not None:
            element.set('Parents', self.gds_format_string(self.Parents))
        if self.Name is not None:
            element.set('Name', self.gds_format_string(self.Name))
        if self.H5Path is not None:
            element.set('H5Path', self.gds_format_string(self.H5Path))
        if self.DatasetPtr is not None:
            DatasetPtr_ = self.DatasetPtr
            DatasetPtr_.to_etree(element, name_='DatasetPtr', mapping_=mapping_)
        if self.StorageLayout is not None:
            StorageLayout_ = self.StorageLayout
            StorageLayout_.to_etree(element, name_='StorageLayout', mapping_=mapping_)
        if self.FillValueInfo is not None:
            FillValueInfo_ = self.FillValueInfo
            FillValueInfo_.to_etree(element, name_='FillValueInfo', mapping_=mapping_)
        if self.Dataspace is not None:
            Dataspace_ = self.Dataspace
            Dataspace_.to_etree(element, name_='Dataspace', mapping_=mapping_)
        if self.DataType is not None:
            DataType_ = self.DataType
            DataType_.to_etree(element, name_='DataType', mapping_=mapping_)
        if self.NamedDataTypePtr is not None:
            NamedDataTypePtr_ = self.NamedDataTypePtr
            NamedDataTypePtr_.to_etree(element, name_='NamedDataTypePtr', mapping_=mapping_)
        for Attribute_ in self.Attribute:
            Attribute_.to_etree(element, name_='Attribute', mapping_=mapping_)
        if self.Data is not None:
            Data_ = self.Data
            Data_.to_etree(element, name_='Data', mapping_=mapping_)
        if mapping_ is not None:
            mapping_[self] = element
        return element
    def exportLiteral(self, outfile, level, name_='Dataset'):
        level += 1
        already_processed = set()
        self.exportLiteralAttributes(outfile, level, already_processed, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, already_processed, name_):
        if self.OBJ_XID is not None and 'OBJ_XID' not in already_processed:
            already_processed.add('OBJ_XID')
            showIndent(outfile, level)
            outfile.write('OBJ_XID="%s",\n' % (self.OBJ_XID,))
        if self.H5ParentPaths is not None and 'H5ParentPaths' not in already_processed:
            already_processed.add('H5ParentPaths')
            showIndent(outfile, level)
            outfile.write('H5ParentPaths="%s",\n' % (self.H5ParentPaths,))
        if self.Parents is not None and 'Parents' not in already_processed:
            already_processed.add('Parents')
            showIndent(outfile, level)
            outfile.write('Parents="%s",\n' % (self.Parents,))
        if self.Name is not None and 'Name' not in already_processed:
            already_processed.add('Name')
            showIndent(outfile, level)
            outfile.write('Name="%s",\n' % (self.Name,))
        if self.H5Path is not None and 'H5Path' not in already_processed:
            already_processed.add('H5Path')
            showIndent(outfile, level)
            outfile.write('H5Path="%s",\n' % (self.H5Path,))
    def exportLiteralChildren(self, outfile, level, name_):
        if self.DatasetPtr is not None:
            showIndent(outfile, level)
            outfile.write('DatasetPtr=model_.DatasetPtr(\n')
            self.DatasetPtr.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.StorageLayout is not None:
            showIndent(outfile, level)
            outfile.write('StorageLayout=model_.StorageLayout(\n')
            self.StorageLayout.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.FillValueInfo is not None:
            showIndent(outfile, level)
            outfile.write('FillValueInfo=model_.FillValueInfo(\n')
            self.FillValueInfo.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.Dataspace is not None:
            showIndent(outfile, level)
            outfile.write('Dataspace=model_.Dataspace(\n')
            self.Dataspace.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.DataType is not None:
            showIndent(outfile, level)
            outfile.write('DataType=model_.DataType(\n')
            self.DataType.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.NamedDataTypePtr is not None:
            showIndent(outfile, level)
            outfile.write('NamedDataTypePtr=model_.NamedDataTypePtr(\n')
            self.NamedDataTypePtr.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        showIndent(outfile, level)
        outfile.write('Attribute=[\n')
        level += 1
        for Attribute_ in self.Attribute:
            showIndent(outfile, level)
            outfile.write('model_.Attribute(\n')
            Attribute_.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
        if self.Data is not None:
            showIndent(outfile, level)
            outfile.write('Data=model_.Data(\n')
            self.Data.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
    def build(self, node):
        already_processed = set()
        self.buildAttributes(node, node.attrib, already_processed)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
        return self
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('OBJ-XID', node)
        if value is not None and 'OBJ-XID' not in already_processed:
            already_processed.add('OBJ-XID')
            self.OBJ_XID = value
        value = find_attr_value_('H5ParentPaths', node)
        if value is not None and 'H5ParentPaths' not in already_processed:
            already_processed.add('H5ParentPaths')
            self.H5ParentPaths = value
        value = find_attr_value_('Parents', node)
        if value is not None and 'Parents' not in already_processed:
            already_processed.add('Parents')
            self.Parents = value
        value = find_attr_value_('Name', node)
        if value is not None and 'Name' not in already_processed:
            already_processed.add('Name')
            self.Name = value
        value = find_attr_value_('H5Path', node)
        if value is not None and 'H5Path' not in already_processed:
            already_processed.add('H5Path')
            self.H5Path = value
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'DatasetPtr':
            obj_ = DatasetPtr.factory()
            obj_.build(child_)
            self.DatasetPtr = obj_
            obj_.original_tagname_ = 'DatasetPtr'
        elif nodeName_ == 'StorageLayout':
            obj_ = StorageLayout.factory()
            obj_.build(child_)
            self.StorageLayout = obj_
            obj_.original_tagname_ = 'StorageLayout'
        elif nodeName_ == 'FillValueInfo':
            obj_ = FillValueInfo.factory()
            obj_.build(child_)
            self.FillValueInfo = obj_
            obj_.original_tagname_ = 'FillValueInfo'
        elif nodeName_ == 'Dataspace':
            obj_ = Dataspace.factory()
            obj_.build(child_)
            self.Dataspace = obj_
            obj_.original_tagname_ = 'Dataspace'
        elif nodeName_ == 'DataType':
            obj_ = DataType.factory()
            obj_.build(child_)
            self.DataType = obj_
            obj_.original_tagname_ = 'DataType'
        elif nodeName_ == 'NamedDataTypePtr':
            obj_ = NamedDataTypePtr.factory()
            obj_.build(child_)
            self.NamedDataTypePtr = obj_
            obj_.original_tagname_ = 'NamedDataTypePtr'
        elif nodeName_ == 'Attribute':
            obj_ = Attribute.factory()
            obj_.build(child_)
            self.Attribute.append(obj_)
            obj_.original_tagname_ = 'Attribute'
        elif nodeName_ == 'Data':
            obj_ = Data.factory()
            obj_.build(child_)
            self.Data = obj_
            obj_.original_tagname_ = 'Data'
# end class Dataset


class DatasetPtr(GeneratedsSuper):
    member_data_items_ = {
        'OBJ-XID': MemberSpec_('OBJ-XID', 'xs:string', 0),
        'H5Path': MemberSpec_('H5Path', 'xs:string', 0),
    }
    subclass = None
    superclass = None
    def __init__(self, OBJ_XID=None, H5Path=None):
        self.original_tagname_ = None
        self.OBJ_XID = _cast(None, OBJ_XID)
        self.H5Path = _cast(None, H5Path)
    def factory(*args_, **kwargs_):
        if DatasetPtr.subclass:
            return DatasetPtr.subclass(*args_, **kwargs_)
        else:
            return DatasetPtr(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_OBJ_XID(self): return self.OBJ_XID
    def set_OBJ_XID(self, OBJ_XID): self.OBJ_XID = OBJ_XID
    def get_H5Path(self): return self.H5Path
    def set_H5Path(self, H5Path): self.H5Path = H5Path
    def hasContent_(self):
        if (

        ):
            return True
        else:
            return False
    def export(self, outfile, level, namespace_='hdf5:', name_='DatasetPtr', namespacedef_='xmlns:hdf5="http://hdfgroup.org/HDF5/XML/schema/HDF5-File"', pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.original_tagname_ is not None:
            name_ = self.original_tagname_
        showIndent(outfile, level, pretty_print)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = set()
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='DatasetPtr')
        if self.hasContent_():
            outfile.write('>%s' % (eol_, ))
            self.exportChildren(outfile, level + 1, namespace_='hdf5:', name_='DatasetPtr', pretty_print=pretty_print)
            outfile.write('</%s%s>%s' % (namespace_, name_, eol_))
        else:
            outfile.write('/>%s' % (eol_, ))
    def exportAttributes(self, outfile, level, already_processed, namespace_='hdf5:', name_='DatasetPtr'):
        if self.OBJ_XID is not None and 'OBJ_XID' not in already_processed:
            already_processed.add('OBJ_XID')
            outfile.write(' OBJ-XID=%s' % (self.gds_format_string(quote_attrib(self.OBJ_XID).encode(ExternalEncoding), input_name='OBJ-XID'), ))
        if self.H5Path is not None and 'H5Path' not in already_processed:
            already_processed.add('H5Path')
            outfile.write(' H5Path=%s' % (self.gds_format_string(quote_attrib(self.H5Path).encode(ExternalEncoding), input_name='H5Path'), ))
    def exportChildren(self, outfile, level, namespace_='hdf5:', name_='DatasetPtr', fromsubclass_=False, pretty_print=True):
        pass
    def to_etree(self, parent_element=None, name_='DatasetPtr', mapping_=None):
        if parent_element is None:
            element = etree_.Element('{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        else:
            element = etree_.SubElement(parent_element, '{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        if self.OBJ_XID is not None:
            element.set('OBJ-XID', self.gds_format_string(self.OBJ_XID))
        if self.H5Path is not None:
            element.set('H5Path', self.gds_format_string(self.H5Path))
        if mapping_ is not None:
            mapping_[self] = element
        return element
    def exportLiteral(self, outfile, level, name_='DatasetPtr'):
        level += 1
        already_processed = set()
        self.exportLiteralAttributes(outfile, level, already_processed, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, already_processed, name_):
        if self.OBJ_XID is not None and 'OBJ_XID' not in already_processed:
            already_processed.add('OBJ_XID')
            showIndent(outfile, level)
            outfile.write('OBJ_XID="%s",\n' % (self.OBJ_XID,))
        if self.H5Path is not None and 'H5Path' not in already_processed:
            already_processed.add('H5Path')
            showIndent(outfile, level)
            outfile.write('H5Path="%s",\n' % (self.H5Path,))
    def exportLiteralChildren(self, outfile, level, name_):
        pass
    def build(self, node):
        already_processed = set()
        self.buildAttributes(node, node.attrib, already_processed)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
        return self
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('OBJ-XID', node)
        if value is not None and 'OBJ-XID' not in already_processed:
            already_processed.add('OBJ-XID')
            self.OBJ_XID = value
        value = find_attr_value_('H5Path', node)
        if value is not None and 'H5Path' not in already_processed:
            already_processed.add('H5Path')
            self.H5Path = value
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        pass
# end class DatasetPtr


class Dataspace(GeneratedsSuper):
    member_data_items_ = {
        'ScalarDataspace': MemberSpec_('ScalarDataspace', 'ScalarDataspace', 0),
        'SimpleDataspace': MemberSpec_('SimpleDataspace', 'SimpleDataspace', 0),
        'ComplexDataspace': MemberSpec_('ComplexDataspace', 'ComplexDataspace', 0),
    }
    subclass = None
    superclass = None
    def __init__(self, ScalarDataspace=None, SimpleDataspace=None, ComplexDataspace=None):
        self.original_tagname_ = None
        self.ScalarDataspace = ScalarDataspace
        self.SimpleDataspace = SimpleDataspace
        self.ComplexDataspace = ComplexDataspace
    def factory(*args_, **kwargs_):
        if Dataspace.subclass:
            return Dataspace.subclass(*args_, **kwargs_)
        else:
            return Dataspace(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_ScalarDataspace(self): return self.ScalarDataspace
    def set_ScalarDataspace(self, ScalarDataspace): self.ScalarDataspace = ScalarDataspace
    def get_SimpleDataspace(self): return self.SimpleDataspace
    def set_SimpleDataspace(self, SimpleDataspace): self.SimpleDataspace = SimpleDataspace
    def get_ComplexDataspace(self): return self.ComplexDataspace
    def set_ComplexDataspace(self, ComplexDataspace): self.ComplexDataspace = ComplexDataspace
    def hasContent_(self):
        if (
            self.ScalarDataspace is not None or
            self.SimpleDataspace is not None or
            self.ComplexDataspace is not None
        ):
            return True
        else:
            return False
    def export(self, outfile, level, namespace_='hdf5:', name_='Dataspace', namespacedef_='xmlns:hdf5="http://hdfgroup.org/HDF5/XML/schema/HDF5-File"', pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.original_tagname_ is not None:
            name_ = self.original_tagname_
        showIndent(outfile, level, pretty_print)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = set()
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='Dataspace')
        if self.hasContent_():
            outfile.write('>%s' % (eol_, ))
            self.exportChildren(outfile, level + 1, namespace_='hdf5:', name_='Dataspace', pretty_print=pretty_print)
            showIndent(outfile, level, pretty_print)
            outfile.write('</%s%s>%s' % (namespace_, name_, eol_))
        else:
            outfile.write('/>%s' % (eol_, ))
    def exportAttributes(self, outfile, level, already_processed, namespace_='hdf5:', name_='Dataspace'):
        pass
    def exportChildren(self, outfile, level, namespace_='hdf5:', name_='Dataspace', fromsubclass_=False, pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.ScalarDataspace is not None:
            self.ScalarDataspace.export(outfile, level, namespace_='hdf5:', name_='ScalarDataspace', pretty_print=pretty_print)
        if self.SimpleDataspace is not None:
            self.SimpleDataspace.export(outfile, level, namespace_='hdf5:', name_='SimpleDataspace', pretty_print=pretty_print)
        if self.ComplexDataspace is not None:
            self.ComplexDataspace.export(outfile, level, namespace_='hdf5:', name_='ComplexDataspace', pretty_print=pretty_print)
    def to_etree(self, parent_element=None, name_='Dataspace', mapping_=None):
        if parent_element is None:
            element = etree_.Element('{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        else:
            element = etree_.SubElement(parent_element, '{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        if self.ScalarDataspace is not None:
            ScalarDataspace_ = self.ScalarDataspace
            ScalarDataspace_.to_etree(element, name_='ScalarDataspace', mapping_=mapping_)
        if self.SimpleDataspace is not None:
            SimpleDataspace_ = self.SimpleDataspace
            SimpleDataspace_.to_etree(element, name_='SimpleDataspace', mapping_=mapping_)
        if self.ComplexDataspace is not None:
            ComplexDataspace_ = self.ComplexDataspace
            ComplexDataspace_.to_etree(element, name_='ComplexDataspace', mapping_=mapping_)
        if mapping_ is not None:
            mapping_[self] = element
        return element
    def exportLiteral(self, outfile, level, name_='Dataspace'):
        level += 1
        already_processed = set()
        self.exportLiteralAttributes(outfile, level, already_processed, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, already_processed, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        if self.ScalarDataspace is not None:
            showIndent(outfile, level)
            outfile.write('ScalarDataspace=model_.ScalarDataspace(\n')
            self.ScalarDataspace.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.SimpleDataspace is not None:
            showIndent(outfile, level)
            outfile.write('SimpleDataspace=model_.SimpleDataspace(\n')
            self.SimpleDataspace.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.ComplexDataspace is not None:
            showIndent(outfile, level)
            outfile.write('ComplexDataspace=model_.ComplexDataspace(\n')
            self.ComplexDataspace.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
    def build(self, node):
        already_processed = set()
        self.buildAttributes(node, node.attrib, already_processed)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
        return self
    def buildAttributes(self, node, attrs, already_processed):
        pass
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'ScalarDataspace':
            obj_ = ScalarDataspace.factory()
            obj_.build(child_)
            self.ScalarDataspace = obj_
            obj_.original_tagname_ = 'ScalarDataspace'
        elif nodeName_ == 'SimpleDataspace':
            obj_ = SimpleDataspace.factory()
            obj_.build(child_)
            self.SimpleDataspace = obj_
            obj_.original_tagname_ = 'SimpleDataspace'
        elif nodeName_ == 'ComplexDataspace':
            obj_ = ComplexDataspace.factory()
            obj_.build(child_)
            self.ComplexDataspace = obj_
            obj_.original_tagname_ = 'ComplexDataspace'
# end class Dataspace


class Dimension(GeneratedsSuper):
    member_data_items_ = {
        'MaxDimSize': MemberSpec_('MaxDimSize', 'xs:string', 0),
        'DimSize': MemberSpec_('DimSize', 'xs:string', 0),
    }
    subclass = None
    superclass = None
    def __init__(self, MaxDimSize=None, DimSize='0'):
        self.original_tagname_ = None
        self.MaxDimSize = _cast(None, MaxDimSize)
        self.DimSize = _cast(None, DimSize)
    def factory(*args_, **kwargs_):
        if Dimension.subclass:
            return Dimension.subclass(*args_, **kwargs_)
        else:
            return Dimension(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_MaxDimSize(self): return self.MaxDimSize
    def set_MaxDimSize(self, MaxDimSize): self.MaxDimSize = MaxDimSize
    def get_DimSize(self): return self.DimSize
    def set_DimSize(self, DimSize): self.DimSize = DimSize
    def hasContent_(self):
        if (

        ):
            return True
        else:
            return False
    def export(self, outfile, level, namespace_='hdf5:', name_='Dimension', namespacedef_='xmlns:hdf5="http://hdfgroup.org/HDF5/XML/schema/HDF5-File"', pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.original_tagname_ is not None:
            name_ = self.original_tagname_
        showIndent(outfile, level, pretty_print)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = set()
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='Dimension')
        if self.hasContent_():
            outfile.write('>%s' % (eol_, ))
            self.exportChildren(outfile, level + 1, namespace_='hdf5:', name_='Dimension', pretty_print=pretty_print)
            outfile.write('</%s%s>%s' % (namespace_, name_, eol_))
        else:
            outfile.write('/>%s' % (eol_, ))
    def exportAttributes(self, outfile, level, already_processed, namespace_='hdf5:', name_='Dimension'):
        if self.MaxDimSize is not None and 'MaxDimSize' not in already_processed:
            already_processed.add('MaxDimSize')
            outfile.write(' MaxDimSize=%s' % (self.gds_format_string(quote_attrib(self.MaxDimSize).encode(ExternalEncoding), input_name='MaxDimSize'), ))
        if self.DimSize is not None and 'DimSize' not in already_processed:
            already_processed.add('DimSize')
            outfile.write(' DimSize=%s' % (self.gds_format_string(quote_attrib(self.DimSize).encode(ExternalEncoding), input_name='DimSize'), ))
    def exportChildren(self, outfile, level, namespace_='hdf5:', name_='Dimension', fromsubclass_=False, pretty_print=True):
        pass
    def to_etree(self, parent_element=None, name_='Dimension', mapping_=None):
        if parent_element is None:
            element = etree_.Element('{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        else:
            element = etree_.SubElement(parent_element, '{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        if self.MaxDimSize is not None:
            element.set('MaxDimSize', self.gds_format_string(self.MaxDimSize))
        if self.DimSize is not None:
            element.set('DimSize', self.gds_format_string(self.DimSize))
        if mapping_ is not None:
            mapping_[self] = element
        return element
    def exportLiteral(self, outfile, level, name_='Dimension'):
        level += 1
        already_processed = set()
        self.exportLiteralAttributes(outfile, level, already_processed, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, already_processed, name_):
        if self.MaxDimSize is not None and 'MaxDimSize' not in already_processed:
            already_processed.add('MaxDimSize')
            showIndent(outfile, level)
            outfile.write('MaxDimSize="%s",\n' % (self.MaxDimSize,))
        if self.DimSize is not None and 'DimSize' not in already_processed:
            already_processed.add('DimSize')
            showIndent(outfile, level)
            outfile.write('DimSize="%s",\n' % (self.DimSize,))
    def exportLiteralChildren(self, outfile, level, name_):
        pass
    def build(self, node):
        already_processed = set()
        self.buildAttributes(node, node.attrib, already_processed)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
        return self
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('MaxDimSize', node)
        if value is not None and 'MaxDimSize' not in already_processed:
            already_processed.add('MaxDimSize')
            self.MaxDimSize = value
        value = find_attr_value_('DimSize', node)
        if value is not None and 'DimSize' not in already_processed:
            already_processed.add('DimSize')
            self.DimSize = value
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        pass
# end class Dimension


class EnumType(GeneratedsSuper):
    member_data_items_ = {
        'Nelems': MemberSpec_('Nelems', 'xs:string', 0),
        'DataType': MemberSpec_('DataType', 'DataType', 1),
        'EnumElement': MemberSpec_('EnumElement', 'xs:string', 1),
        'EnumValue': MemberSpec_('EnumValue', 'xs:string', 1),
    }
    subclass = None
    superclass = None
    def __init__(self, Nelems=None, DataType=None, EnumElement=None, EnumValue=None):
        self.original_tagname_ = None
        self.Nelems = _cast(None, Nelems)
        if DataType is None:
            self.DataType = []
        else:
            self.DataType = DataType
        if EnumElement is None:
            self.EnumElement = []
        else:
            self.EnumElement = EnumElement
        if EnumValue is None:
            self.EnumValue = []
        else:
            self.EnumValue = EnumValue
    def factory(*args_, **kwargs_):
        if EnumType.subclass:
            return EnumType.subclass(*args_, **kwargs_)
        else:
            return EnumType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_DataType(self): return self.DataType
    def set_DataType(self, DataType): self.DataType = DataType
    def add_DataType(self, value): self.DataType.append(value)
    def insert_DataType(self, index, value): self.DataType[index] = value
    def get_EnumElement(self): return self.EnumElement
    def set_EnumElement(self, EnumElement): self.EnumElement = EnumElement
    def add_EnumElement(self, value): self.EnumElement.append(value)
    def insert_EnumElement(self, index, value): self.EnumElement[index] = value
    def get_EnumValue(self): return self.EnumValue
    def set_EnumValue(self, EnumValue): self.EnumValue = EnumValue
    def add_EnumValue(self, value): self.EnumValue.append(value)
    def insert_EnumValue(self, index, value): self.EnumValue[index] = value
    def get_Nelems(self): return self.Nelems
    def set_Nelems(self, Nelems): self.Nelems = Nelems
    def hasContent_(self):
        if (
            self.DataType or
            self.EnumElement or
            self.EnumValue
        ):
            return True
        else:
            return False
    def export(self, outfile, level, namespace_='hdf5:', name_='EnumType', namespacedef_='xmlns:hdf5="http://hdfgroup.org/HDF5/XML/schema/HDF5-File"', pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.original_tagname_ is not None:
            name_ = self.original_tagname_
        showIndent(outfile, level, pretty_print)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = set()
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='EnumType')
        if self.hasContent_():
            outfile.write('>%s' % (eol_, ))
            self.exportChildren(outfile, level + 1, namespace_='hdf5:', name_='EnumType', pretty_print=pretty_print)
            showIndent(outfile, level, pretty_print)
            outfile.write('</%s%s>%s' % (namespace_, name_, eol_))
        else:
            outfile.write('/>%s' % (eol_, ))
    def exportAttributes(self, outfile, level, already_processed, namespace_='hdf5:', name_='EnumType'):
        if self.Nelems is not None and 'Nelems' not in already_processed:
            already_processed.add('Nelems')
            outfile.write(' Nelems=%s' % (self.gds_format_string(quote_attrib(self.Nelems).encode(ExternalEncoding), input_name='Nelems'), ))
    def exportChildren(self, outfile, level, namespace_='hdf5:', name_='EnumType', fromsubclass_=False, pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        for DataType_ in self.DataType:
            DataType_.export(outfile, level, namespace_='hdf5:', name_='DataType', pretty_print=pretty_print)
        for EnumElement_ in self.EnumElement:
            showIndent(outfile, level, pretty_print)
            outfile.write('<%sEnumElement>%s</%sEnumElement>%s' % (namespace_, self.gds_format_string(quote_xml(EnumElement_).encode(ExternalEncoding), input_name='EnumElement'), namespace_, eol_))
        for EnumValue_ in self.EnumValue:
            showIndent(outfile, level, pretty_print)
            outfile.write('<%sEnumValue>%s</%sEnumValue>%s' % (namespace_, self.gds_format_string(quote_xml(EnumValue_).encode(ExternalEncoding), input_name='EnumValue'), namespace_, eol_))
    def to_etree(self, parent_element=None, name_='EnumType', mapping_=None):
        if parent_element is None:
            element = etree_.Element('{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        else:
            element = etree_.SubElement(parent_element, '{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        if self.Nelems is not None:
            element.set('Nelems', self.gds_format_string(self.Nelems))
        for DataType_ in self.DataType:
            DataType_.to_etree(element, name_='DataType', mapping_=mapping_)
        for EnumElement_ in self.EnumElement:
            etree_.SubElement(element, '{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}EnumElement').text = self.gds_format_string(EnumElement_)
        for EnumValue_ in self.EnumValue:
            etree_.SubElement(element, '{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}EnumValue').text = self.gds_format_string(EnumValue_)
        if mapping_ is not None:
            mapping_[self] = element
        return element
    def exportLiteral(self, outfile, level, name_='EnumType'):
        level += 1
        already_processed = set()
        self.exportLiteralAttributes(outfile, level, already_processed, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, already_processed, name_):
        if self.Nelems is not None and 'Nelems' not in already_processed:
            already_processed.add('Nelems')
            showIndent(outfile, level)
            outfile.write('Nelems="%s",\n' % (self.Nelems,))
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('DataType=[\n')
        level += 1
        for DataType_ in self.DataType:
            showIndent(outfile, level)
            outfile.write('model_.DataType(\n')
            DataType_.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
        showIndent(outfile, level)
        outfile.write('EnumElement=[\n')
        level += 1
        for EnumElement_ in self.EnumElement:
            showIndent(outfile, level)
            outfile.write('%s,\n' % quote_python(EnumElement_).encode(ExternalEncoding))
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
        showIndent(outfile, level)
        outfile.write('EnumValue=[\n')
        level += 1
        for EnumValue_ in self.EnumValue:
            showIndent(outfile, level)
            outfile.write('%s,\n' % quote_python(EnumValue_).encode(ExternalEncoding))
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
    def build(self, node):
        already_processed = set()
        self.buildAttributes(node, node.attrib, already_processed)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
        return self
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('Nelems', node)
        if value is not None and 'Nelems' not in already_processed:
            already_processed.add('Nelems')
            self.Nelems = value
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'DataType':
            obj_ = DataType.factory()
            obj_.build(child_)
            self.DataType.append(obj_)
            obj_.original_tagname_ = 'DataType'
        elif nodeName_ == 'EnumElement':
            EnumElement_ = child_.text
            EnumElement_ = self.gds_validate_string(EnumElement_, node, 'EnumElement')
            self.EnumElement.append(EnumElement_)
        elif nodeName_ == 'EnumValue':
            EnumValue_ = child_.text
            EnumValue_ = self.gds_validate_string(EnumValue_, node, 'EnumValue')
            self.EnumValue.append(EnumValue_)
# end class EnumType


class ExternalFileInfo(GeneratedsSuper):
    member_data_items_ = {
        'ExternalFileOffset': MemberSpec_('ExternalFileOffset', 'xs:string', 0),
        'ExternalFileSize': MemberSpec_('ExternalFileSize', 'xs:string', 0),
        'FileName': MemberSpec_('FileName', 'xs:string', 0),
    }
    subclass = None
    superclass = None
    def __init__(self, ExternalFileOffset=None, ExternalFileSize=None, FileName=None):
        self.original_tagname_ = None
        self.ExternalFileOffset = _cast(None, ExternalFileOffset)
        self.ExternalFileSize = _cast(None, ExternalFileSize)
        self.FileName = _cast(None, FileName)
    def factory(*args_, **kwargs_):
        if ExternalFileInfo.subclass:
            return ExternalFileInfo.subclass(*args_, **kwargs_)
        else:
            return ExternalFileInfo(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_ExternalFileOffset(self): return self.ExternalFileOffset
    def set_ExternalFileOffset(self, ExternalFileOffset): self.ExternalFileOffset = ExternalFileOffset
    def get_ExternalFileSize(self): return self.ExternalFileSize
    def set_ExternalFileSize(self, ExternalFileSize): self.ExternalFileSize = ExternalFileSize
    def get_FileName(self): return self.FileName
    def set_FileName(self, FileName): self.FileName = FileName
    def hasContent_(self):
        if (

        ):
            return True
        else:
            return False
    def export(self, outfile, level, namespace_='hdf5:', name_='ExternalFileInfo', namespacedef_='xmlns:hdf5="http://hdfgroup.org/HDF5/XML/schema/HDF5-File"', pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.original_tagname_ is not None:
            name_ = self.original_tagname_
        showIndent(outfile, level, pretty_print)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = set()
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='ExternalFileInfo')
        if self.hasContent_():
            outfile.write('>%s' % (eol_, ))
            self.exportChildren(outfile, level + 1, namespace_='hdf5:', name_='ExternalFileInfo', pretty_print=pretty_print)
            outfile.write('</%s%s>%s' % (namespace_, name_, eol_))
        else:
            outfile.write('/>%s' % (eol_, ))
    def exportAttributes(self, outfile, level, already_processed, namespace_='hdf5:', name_='ExternalFileInfo'):
        if self.ExternalFileOffset is not None and 'ExternalFileOffset' not in already_processed:
            already_processed.add('ExternalFileOffset')
            outfile.write(' ExternalFileOffset=%s' % (self.gds_format_string(quote_attrib(self.ExternalFileOffset).encode(ExternalEncoding), input_name='ExternalFileOffset'), ))
        if self.ExternalFileSize is not None and 'ExternalFileSize' not in already_processed:
            already_processed.add('ExternalFileSize')
            outfile.write(' ExternalFileSize=%s' % (self.gds_format_string(quote_attrib(self.ExternalFileSize).encode(ExternalEncoding), input_name='ExternalFileSize'), ))
        if self.FileName is not None and 'FileName' not in already_processed:
            already_processed.add('FileName')
            outfile.write(' FileName=%s' % (self.gds_format_string(quote_attrib(self.FileName).encode(ExternalEncoding), input_name='FileName'), ))
    def exportChildren(self, outfile, level, namespace_='hdf5:', name_='ExternalFileInfo', fromsubclass_=False, pretty_print=True):
        pass
    def to_etree(self, parent_element=None, name_='ExternalFileInfo', mapping_=None):
        if parent_element is None:
            element = etree_.Element('{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        else:
            element = etree_.SubElement(parent_element, '{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        if self.ExternalFileOffset is not None:
            element.set('ExternalFileOffset', self.gds_format_string(self.ExternalFileOffset))
        if self.ExternalFileSize is not None:
            element.set('ExternalFileSize', self.gds_format_string(self.ExternalFileSize))
        if self.FileName is not None:
            element.set('FileName', self.gds_format_string(self.FileName))
        if mapping_ is not None:
            mapping_[self] = element
        return element
    def exportLiteral(self, outfile, level, name_='ExternalFileInfo'):
        level += 1
        already_processed = set()
        self.exportLiteralAttributes(outfile, level, already_processed, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, already_processed, name_):
        if self.ExternalFileOffset is not None and 'ExternalFileOffset' not in already_processed:
            already_processed.add('ExternalFileOffset')
            showIndent(outfile, level)
            outfile.write('ExternalFileOffset="%s",\n' % (self.ExternalFileOffset,))
        if self.ExternalFileSize is not None and 'ExternalFileSize' not in already_processed:
            already_processed.add('ExternalFileSize')
            showIndent(outfile, level)
            outfile.write('ExternalFileSize="%s",\n' % (self.ExternalFileSize,))
        if self.FileName is not None and 'FileName' not in already_processed:
            already_processed.add('FileName')
            showIndent(outfile, level)
            outfile.write('FileName="%s",\n' % (self.FileName,))
    def exportLiteralChildren(self, outfile, level, name_):
        pass
    def build(self, node):
        already_processed = set()
        self.buildAttributes(node, node.attrib, already_processed)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
        return self
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('ExternalFileOffset', node)
        if value is not None and 'ExternalFileOffset' not in already_processed:
            already_processed.add('ExternalFileOffset')
            self.ExternalFileOffset = value
        value = find_attr_value_('ExternalFileSize', node)
        if value is not None and 'ExternalFileSize' not in already_processed:
            already_processed.add('ExternalFileSize')
            self.ExternalFileSize = value
        value = find_attr_value_('FileName', node)
        if value is not None and 'FileName' not in already_processed:
            already_processed.add('FileName')
            self.FileName = value
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        pass
# end class ExternalFileInfo


class ExternalLayout(GeneratedsSuper):
    member_data_items_ = {
        'ExternalFileInfo': MemberSpec_('ExternalFileInfo', 'ExternalFileInfo', 1),
    }
    subclass = None
    superclass = None
    def __init__(self, ExternalFileInfo=None):
        self.original_tagname_ = None
        if ExternalFileInfo is None:
            self.ExternalFileInfo = []
        else:
            self.ExternalFileInfo = ExternalFileInfo
    def factory(*args_, **kwargs_):
        if ExternalLayout.subclass:
            return ExternalLayout.subclass(*args_, **kwargs_)
        else:
            return ExternalLayout(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_ExternalFileInfo(self): return self.ExternalFileInfo
    def set_ExternalFileInfo(self, ExternalFileInfo): self.ExternalFileInfo = ExternalFileInfo
    def add_ExternalFileInfo(self, value): self.ExternalFileInfo.append(value)
    def insert_ExternalFileInfo(self, index, value): self.ExternalFileInfo[index] = value
    def hasContent_(self):
        if (
            self.ExternalFileInfo
        ):
            return True
        else:
            return False
    def export(self, outfile, level, namespace_='hdf5:', name_='ExternalLayout', namespacedef_='xmlns:hdf5="http://hdfgroup.org/HDF5/XML/schema/HDF5-File"', pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.original_tagname_ is not None:
            name_ = self.original_tagname_
        showIndent(outfile, level, pretty_print)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = set()
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='ExternalLayout')
        if self.hasContent_():
            outfile.write('>%s' % (eol_, ))
            self.exportChildren(outfile, level + 1, namespace_='hdf5:', name_='ExternalLayout', pretty_print=pretty_print)
            showIndent(outfile, level, pretty_print)
            outfile.write('</%s%s>%s' % (namespace_, name_, eol_))
        else:
            outfile.write('/>%s' % (eol_, ))
    def exportAttributes(self, outfile, level, already_processed, namespace_='hdf5:', name_='ExternalLayout'):
        pass
    def exportChildren(self, outfile, level, namespace_='hdf5:', name_='ExternalLayout', fromsubclass_=False, pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        for ExternalFileInfo_ in self.ExternalFileInfo:
            ExternalFileInfo_.export(outfile, level, namespace_='hdf5:', name_='ExternalFileInfo', pretty_print=pretty_print)
    def to_etree(self, parent_element=None, name_='ExternalLayout', mapping_=None):
        if parent_element is None:
            element = etree_.Element('{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        else:
            element = etree_.SubElement(parent_element, '{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        for ExternalFileInfo_ in self.ExternalFileInfo:
            ExternalFileInfo_.to_etree(element, name_='ExternalFileInfo', mapping_=mapping_)
        if mapping_ is not None:
            mapping_[self] = element
        return element
    def exportLiteral(self, outfile, level, name_='ExternalLayout'):
        level += 1
        already_processed = set()
        self.exportLiteralAttributes(outfile, level, already_processed, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, already_processed, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('ExternalFileInfo=[\n')
        level += 1
        for ExternalFileInfo_ in self.ExternalFileInfo:
            showIndent(outfile, level)
            outfile.write('model_.ExternalFileInfo(\n')
            ExternalFileInfo_.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
    def build(self, node):
        already_processed = set()
        self.buildAttributes(node, node.attrib, already_processed)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
        return self
    def buildAttributes(self, node, attrs, already_processed):
        pass
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'ExternalFileInfo':
            obj_ = ExternalFileInfo.factory()
            obj_.build(child_)
            self.ExternalFileInfo.append(obj_)
            obj_.original_tagname_ = 'ExternalFileInfo'
# end class ExternalLayout


class Field(GeneratedsSuper):
    member_data_items_ = {
        'FieldName': MemberSpec_('FieldName', 'xs:string', 0),
        'DataType': MemberSpec_('DataType', 'DataType', 0),
    }
    subclass = None
    superclass = None
    def __init__(self, FieldName=None, DataType=None):
        self.original_tagname_ = None
        self.FieldName = _cast(None, FieldName)
        self.DataType = DataType
    def factory(*args_, **kwargs_):
        if Field.subclass:
            return Field.subclass(*args_, **kwargs_)
        else:
            return Field(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_DataType(self): return self.DataType
    def set_DataType(self, DataType): self.DataType = DataType
    def get_FieldName(self): return self.FieldName
    def set_FieldName(self, FieldName): self.FieldName = FieldName
    def hasContent_(self):
        if (
            self.DataType is not None
        ):
            return True
        else:
            return False
    def export(self, outfile, level, namespace_='hdf5:', name_='Field', namespacedef_='xmlns:hdf5="http://hdfgroup.org/HDF5/XML/schema/HDF5-File"', pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.original_tagname_ is not None:
            name_ = self.original_tagname_
        showIndent(outfile, level, pretty_print)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = set()
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='Field')
        if self.hasContent_():
            outfile.write('>%s' % (eol_, ))
            self.exportChildren(outfile, level + 1, namespace_='hdf5:', name_='Field', pretty_print=pretty_print)
            showIndent(outfile, level, pretty_print)
            outfile.write('</%s%s>%s' % (namespace_, name_, eol_))
        else:
            outfile.write('/>%s' % (eol_, ))
    def exportAttributes(self, outfile, level, already_processed, namespace_='hdf5:', name_='Field'):
        if self.FieldName is not None and 'FieldName' not in already_processed:
            already_processed.add('FieldName')
            outfile.write(' FieldName=%s' % (self.gds_format_string(quote_attrib(self.FieldName).encode(ExternalEncoding), input_name='FieldName'), ))
    def exportChildren(self, outfile, level, namespace_='hdf5:', name_='Field', fromsubclass_=False, pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.DataType is not None:
            self.DataType.export(outfile, level, namespace_='hdf5:', name_='DataType', pretty_print=pretty_print)
    def to_etree(self, parent_element=None, name_='Field', mapping_=None):
        if parent_element is None:
            element = etree_.Element('{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        else:
            element = etree_.SubElement(parent_element, '{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        if self.FieldName is not None:
            element.set('FieldName', self.gds_format_string(self.FieldName))
        if self.DataType is not None:
            DataType_ = self.DataType
            DataType_.to_etree(element, name_='DataType', mapping_=mapping_)
        if mapping_ is not None:
            mapping_[self] = element
        return element
    def exportLiteral(self, outfile, level, name_='Field'):
        level += 1
        already_processed = set()
        self.exportLiteralAttributes(outfile, level, already_processed, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, already_processed, name_):
        if self.FieldName is not None and 'FieldName' not in already_processed:
            already_processed.add('FieldName')
            showIndent(outfile, level)
            outfile.write('FieldName="%s",\n' % (self.FieldName,))
    def exportLiteralChildren(self, outfile, level, name_):
        if self.DataType is not None:
            showIndent(outfile, level)
            outfile.write('DataType=model_.DataType(\n')
            self.DataType.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
    def build(self, node):
        already_processed = set()
        self.buildAttributes(node, node.attrib, already_processed)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
        return self
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('FieldName', node)
        if value is not None and 'FieldName' not in already_processed:
            already_processed.add('FieldName')
            self.FieldName = value
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'DataType':
            obj_ = DataType.factory()
            obj_.build(child_)
            self.DataType = obj_
            obj_.original_tagname_ = 'DataType'
# end class Field


class FloatType(GeneratedsSuper):
    member_data_items_ = {
        'ExponentBits': MemberSpec_('ExponentBits', 'xs:string', 0),
        'MantissaLocation': MemberSpec_('MantissaLocation', 'xs:string', 0),
        'ExponentLocation': MemberSpec_('ExponentLocation', 'xs:string', 0),
        'MantissaBits': MemberSpec_('MantissaBits', 'xs:string', 0),
        'SignBitLocation': MemberSpec_('SignBitLocation', 'xs:string', 0),
        'ByteOrder': MemberSpec_('ByteOrder', 'xs:NMTOKEN', 0),
        'Size': MemberSpec_('Size', 'xs:NMTOKEN', 0),
    }
    subclass = None
    superclass = None
    def __init__(self, ExponentBits=None, MantissaLocation=None, ExponentLocation=None, MantissaBits=None, SignBitLocation=None, ByteOrder=None, Size=None):
        self.original_tagname_ = None
        self.ExponentBits = _cast(None, ExponentBits)
        self.MantissaLocation = _cast(None, MantissaLocation)
        self.ExponentLocation = _cast(None, ExponentLocation)
        self.MantissaBits = _cast(None, MantissaBits)
        self.SignBitLocation = _cast(None, SignBitLocation)
        self.ByteOrder = _cast(None, ByteOrder)
        self.Size = _cast(None, Size)
    def factory(*args_, **kwargs_):
        if FloatType.subclass:
            return FloatType.subclass(*args_, **kwargs_)
        else:
            return FloatType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_ExponentBits(self): return self.ExponentBits
    def set_ExponentBits(self, ExponentBits): self.ExponentBits = ExponentBits
    def get_MantissaLocation(self): return self.MantissaLocation
    def set_MantissaLocation(self, MantissaLocation): self.MantissaLocation = MantissaLocation
    def get_ExponentLocation(self): return self.ExponentLocation
    def set_ExponentLocation(self, ExponentLocation): self.ExponentLocation = ExponentLocation
    def get_MantissaBits(self): return self.MantissaBits
    def set_MantissaBits(self, MantissaBits): self.MantissaBits = MantissaBits
    def get_SignBitLocation(self): return self.SignBitLocation
    def set_SignBitLocation(self, SignBitLocation): self.SignBitLocation = SignBitLocation
    def get_ByteOrder(self): return self.ByteOrder
    def set_ByteOrder(self, ByteOrder): self.ByteOrder = ByteOrder
    def get_Size(self): return self.Size
    def set_Size(self, Size): self.Size = Size
    def hasContent_(self):
        if (

        ):
            return True
        else:
            return False
    def export(self, outfile, level, namespace_='hdf5:', name_='FloatType', namespacedef_='xmlns:hdf5="http://hdfgroup.org/HDF5/XML/schema/HDF5-File"', pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.original_tagname_ is not None:
            name_ = self.original_tagname_
        showIndent(outfile, level, pretty_print)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = set()
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='FloatType')
        if self.hasContent_():
            outfile.write('>%s' % (eol_, ))
            self.exportChildren(outfile, level + 1, namespace_='hdf5:', name_='FloatType', pretty_print=pretty_print)
            outfile.write('</%s%s>%s' % (namespace_, name_, eol_))
        else:
            outfile.write('/>%s' % (eol_, ))
    def exportAttributes(self, outfile, level, already_processed, namespace_='hdf5:', name_='FloatType'):
        if self.ExponentBits is not None and 'ExponentBits' not in already_processed:
            already_processed.add('ExponentBits')
            outfile.write(' ExponentBits=%s' % (self.gds_format_string(quote_attrib(self.ExponentBits).encode(ExternalEncoding), input_name='ExponentBits'), ))
        if self.MantissaLocation is not None and 'MantissaLocation' not in already_processed:
            already_processed.add('MantissaLocation')
            outfile.write(' MantissaLocation=%s' % (self.gds_format_string(quote_attrib(self.MantissaLocation).encode(ExternalEncoding), input_name='MantissaLocation'), ))
        if self.ExponentLocation is not None and 'ExponentLocation' not in already_processed:
            already_processed.add('ExponentLocation')
            outfile.write(' ExponentLocation=%s' % (self.gds_format_string(quote_attrib(self.ExponentLocation).encode(ExternalEncoding), input_name='ExponentLocation'), ))
        if self.MantissaBits is not None and 'MantissaBits' not in already_processed:
            already_processed.add('MantissaBits')
            outfile.write(' MantissaBits=%s' % (self.gds_format_string(quote_attrib(self.MantissaBits).encode(ExternalEncoding), input_name='MantissaBits'), ))
        if self.SignBitLocation is not None and 'SignBitLocation' not in already_processed:
            already_processed.add('SignBitLocation')
            outfile.write(' SignBitLocation=%s' % (self.gds_format_string(quote_attrib(self.SignBitLocation).encode(ExternalEncoding), input_name='SignBitLocation'), ))
        if self.ByteOrder is not None and 'ByteOrder' not in already_processed:
            already_processed.add('ByteOrder')
            outfile.write(' ByteOrder=%s' % (self.gds_format_string(quote_attrib(self.ByteOrder).encode(ExternalEncoding), input_name='ByteOrder'), ))
        if self.Size is not None and 'Size' not in already_processed:
            already_processed.add('Size')
            outfile.write(' Size=%s' % (self.gds_format_string(quote_attrib(self.Size).encode(ExternalEncoding), input_name='Size'), ))
    def exportChildren(self, outfile, level, namespace_='hdf5:', name_='FloatType', fromsubclass_=False, pretty_print=True):
        pass
    def to_etree(self, parent_element=None, name_='FloatType', mapping_=None):
        if parent_element is None:
            element = etree_.Element('{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        else:
            element = etree_.SubElement(parent_element, '{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        if self.ExponentBits is not None:
            element.set('ExponentBits', self.gds_format_string(self.ExponentBits))
        if self.MantissaLocation is not None:
            element.set('MantissaLocation', self.gds_format_string(self.MantissaLocation))
        if self.ExponentLocation is not None:
            element.set('ExponentLocation', self.gds_format_string(self.ExponentLocation))
        if self.MantissaBits is not None:
            element.set('MantissaBits', self.gds_format_string(self.MantissaBits))
        if self.SignBitLocation is not None:
            element.set('SignBitLocation', self.gds_format_string(self.SignBitLocation))
        if self.ByteOrder is not None:
            element.set('ByteOrder', self.gds_format_string(self.ByteOrder))
        if self.Size is not None:
            element.set('Size', self.gds_format_string(self.Size))
        if mapping_ is not None:
            mapping_[self] = element
        return element
    def exportLiteral(self, outfile, level, name_='FloatType'):
        level += 1
        already_processed = set()
        self.exportLiteralAttributes(outfile, level, already_processed, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, already_processed, name_):
        if self.ExponentBits is not None and 'ExponentBits' not in already_processed:
            already_processed.add('ExponentBits')
            showIndent(outfile, level)
            outfile.write('ExponentBits="%s",\n' % (self.ExponentBits,))
        if self.MantissaLocation is not None and 'MantissaLocation' not in already_processed:
            already_processed.add('MantissaLocation')
            showIndent(outfile, level)
            outfile.write('MantissaLocation="%s",\n' % (self.MantissaLocation,))
        if self.ExponentLocation is not None and 'ExponentLocation' not in already_processed:
            already_processed.add('ExponentLocation')
            showIndent(outfile, level)
            outfile.write('ExponentLocation="%s",\n' % (self.ExponentLocation,))
        if self.MantissaBits is not None and 'MantissaBits' not in already_processed:
            already_processed.add('MantissaBits')
            showIndent(outfile, level)
            outfile.write('MantissaBits="%s",\n' % (self.MantissaBits,))
        if self.SignBitLocation is not None and 'SignBitLocation' not in already_processed:
            already_processed.add('SignBitLocation')
            showIndent(outfile, level)
            outfile.write('SignBitLocation="%s",\n' % (self.SignBitLocation,))
        if self.ByteOrder is not None and 'ByteOrder' not in already_processed:
            already_processed.add('ByteOrder')
            showIndent(outfile, level)
            outfile.write('ByteOrder="%s",\n' % (self.ByteOrder,))
        if self.Size is not None and 'Size' not in already_processed:
            already_processed.add('Size')
            showIndent(outfile, level)
            outfile.write('Size="%s",\n' % (self.Size,))
    def exportLiteralChildren(self, outfile, level, name_):
        pass
    def build(self, node):
        already_processed = set()
        self.buildAttributes(node, node.attrib, already_processed)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
        return self
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('ExponentBits', node)
        if value is not None and 'ExponentBits' not in already_processed:
            already_processed.add('ExponentBits')
            self.ExponentBits = value
        value = find_attr_value_('MantissaLocation', node)
        if value is not None and 'MantissaLocation' not in already_processed:
            already_processed.add('MantissaLocation')
            self.MantissaLocation = value
        value = find_attr_value_('ExponentLocation', node)
        if value is not None and 'ExponentLocation' not in already_processed:
            already_processed.add('ExponentLocation')
            self.ExponentLocation = value
        value = find_attr_value_('MantissaBits', node)
        if value is not None and 'MantissaBits' not in already_processed:
            already_processed.add('MantissaBits')
            self.MantissaBits = value
        value = find_attr_value_('SignBitLocation', node)
        if value is not None and 'SignBitLocation' not in already_processed:
            already_processed.add('SignBitLocation')
            self.SignBitLocation = value
        value = find_attr_value_('ByteOrder', node)
        if value is not None and 'ByteOrder' not in already_processed:
            already_processed.add('ByteOrder')
            self.ByteOrder = value
        value = find_attr_value_('Size', node)
        if value is not None and 'Size' not in already_processed:
            already_processed.add('Size')
            self.Size = value
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        pass
# end class FloatType


class Group(GeneratedsSuper):
    member_data_items_ = {
        'OBJ-XID': MemberSpec_('OBJ-XID', 'xs:string', 0),
        'H5ParentPaths': MemberSpec_('H5ParentPaths', 'xs:string', 0),
        'Parents': MemberSpec_('Parents', 'xs:string', 0),
        'Name': MemberSpec_('Name', 'xs:string', 0),
        'H5Path': MemberSpec_('H5Path', 'xs:string', 0),
        'GroupPtr': MemberSpec_('GroupPtr', 'GroupPtr', 0),
        'Attribute': MemberSpec_('Attribute', 'Attribute', 1),
        'Group': MemberSpec_('Group', 'Group', 1),
        'Dataset': MemberSpec_('Dataset', 'Dataset', 1),
        'NamedDataType': MemberSpec_('NamedDataType', 'NamedDataType', 1),
        'SoftLink': MemberSpec_('SoftLink', 'SoftLink', 1),
    }
    subclass = None
    superclass = None
    def __init__(self, OBJ_XID=None, H5ParentPaths=None, Parents=None, Name=None, H5Path=None, GroupPtr=None, Attribute=None, Group=None, Dataset=None, NamedDataType=None, SoftLink=None):
        self.original_tagname_ = None
        self.OBJ_XID = _cast(None, OBJ_XID)
        self.H5ParentPaths = _cast(None, H5ParentPaths)
        self.Parents = _cast(None, Parents)
        self.Name = _cast(None, Name)
        self.H5Path = _cast(None, H5Path)
        self.GroupPtr = GroupPtr
        if Attribute is None:
            self.Attribute = []
        else:
            self.Attribute = Attribute
        if Group is None:
            self.Group = []
        else:
            self.Group = Group
        if Dataset is None:
            self.Dataset = []
        else:
            self.Dataset = Dataset
        if NamedDataType is None:
            self.NamedDataType = []
        else:
            self.NamedDataType = NamedDataType
        if SoftLink is None:
            self.SoftLink = []
        else:
            self.SoftLink = SoftLink
    def factory(*args_, **kwargs_):
        if Group.subclass:
            return Group.subclass(*args_, **kwargs_)
        else:
            return Group(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_GroupPtr(self): return self.GroupPtr
    def set_GroupPtr(self, GroupPtr): self.GroupPtr = GroupPtr
    def get_Attribute(self): return self.Attribute
    def set_Attribute(self, Attribute): self.Attribute = Attribute
    def add_Attribute(self, value): self.Attribute.append(value)
    def insert_Attribute(self, index, value): self.Attribute[index] = value
    def get_Group(self): return self.Group
    def set_Group(self, Group): self.Group = Group
    def add_Group(self, value): self.Group.append(value)
    def insert_Group(self, index, value): self.Group[index] = value
    def get_Dataset(self): return self.Dataset
    def set_Dataset(self, Dataset): self.Dataset = Dataset
    def add_Dataset(self, value): self.Dataset.append(value)
    def insert_Dataset(self, index, value): self.Dataset[index] = value
    def get_NamedDataType(self): return self.NamedDataType
    def set_NamedDataType(self, NamedDataType): self.NamedDataType = NamedDataType
    def add_NamedDataType(self, value): self.NamedDataType.append(value)
    def insert_NamedDataType(self, index, value): self.NamedDataType[index] = value
    def get_SoftLink(self): return self.SoftLink
    def set_SoftLink(self, SoftLink): self.SoftLink = SoftLink
    def add_SoftLink(self, value): self.SoftLink.append(value)
    def insert_SoftLink(self, index, value): self.SoftLink[index] = value
    def get_OBJ_XID(self): return self.OBJ_XID
    def set_OBJ_XID(self, OBJ_XID): self.OBJ_XID = OBJ_XID
    def get_H5ParentPaths(self): return self.H5ParentPaths
    def set_H5ParentPaths(self, H5ParentPaths): self.H5ParentPaths = H5ParentPaths
    def get_Parents(self): return self.Parents
    def set_Parents(self, Parents): self.Parents = Parents
    def get_Name(self): return self.Name
    def set_Name(self, Name): self.Name = Name
    def get_H5Path(self): return self.H5Path
    def set_H5Path(self, H5Path): self.H5Path = H5Path
    def hasContent_(self):
        if (
            self.GroupPtr is not None or
            self.Attribute or
            self.Group or
            self.Dataset or
            self.NamedDataType or
            self.SoftLink
        ):
            return True
        else:
            return False
    def export(self, outfile, level, namespace_='hdf5:', name_='Group', namespacedef_='xmlns:hdf5="http://hdfgroup.org/HDF5/XML/schema/HDF5-File"', pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.original_tagname_ is not None:
            name_ = self.original_tagname_
        showIndent(outfile, level, pretty_print)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = set()
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='Group')
        if self.hasContent_():
            outfile.write('>%s' % (eol_, ))
            self.exportChildren(outfile, level + 1, namespace_='hdf5:', name_='Group', pretty_print=pretty_print)
            showIndent(outfile, level, pretty_print)
            outfile.write('</%s%s>%s' % (namespace_, name_, eol_))
        else:
            outfile.write('/>%s' % (eol_, ))
    def exportAttributes(self, outfile, level, already_processed, namespace_='hdf5:', name_='Group'):
        if self.OBJ_XID is not None and 'OBJ_XID' not in already_processed:
            already_processed.add('OBJ_XID')
            outfile.write(' OBJ-XID=%s' % (self.gds_format_string(quote_attrib(self.OBJ_XID).encode(ExternalEncoding), input_name='OBJ-XID'), ))
        if self.H5ParentPaths is not None and 'H5ParentPaths' not in already_processed:
            already_processed.add('H5ParentPaths')
            outfile.write(' H5ParentPaths=%s' % (self.gds_format_string(quote_attrib(self.H5ParentPaths).encode(ExternalEncoding), input_name='H5ParentPaths'), ))
        if self.Parents is not None and 'Parents' not in already_processed:
            already_processed.add('Parents')
            outfile.write(' Parents=%s' % (self.gds_format_string(quote_attrib(self.Parents).encode(ExternalEncoding), input_name='Parents'), ))
        if self.Name is not None and 'Name' not in already_processed:
            already_processed.add('Name')
            outfile.write(' Name=%s' % (self.gds_format_string(quote_attrib(self.Name).encode(ExternalEncoding), input_name='Name'), ))
        if self.H5Path is not None and 'H5Path' not in already_processed:
            already_processed.add('H5Path')
            outfile.write(' H5Path=%s' % (self.gds_format_string(quote_attrib(self.H5Path).encode(ExternalEncoding), input_name='H5Path'), ))
    def exportChildren(self, outfile, level, namespace_='hdf5:', name_='Group', fromsubclass_=False, pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.GroupPtr is not None:
            self.GroupPtr.export(outfile, level, namespace_='hdf5:', name_='GroupPtr', pretty_print=pretty_print)
        for Attribute_ in self.Attribute:
            Attribute_.export(outfile, level, namespace_='hdf5:', name_='Attribute', pretty_print=pretty_print)
        for Group_ in self.Group:
            Group_.export(outfile, level, namespace_='hdf5:', name_='Group', pretty_print=pretty_print)
        for Dataset_ in self.Dataset:
            Dataset_.export(outfile, level, namespace_='hdf5:', name_='Dataset', pretty_print=pretty_print)
        for NamedDataType_ in self.NamedDataType:
            NamedDataType_.export(outfile, level, namespace_='hdf5:', name_='NamedDataType', pretty_print=pretty_print)
        for SoftLink_ in self.SoftLink:
            SoftLink_.export(outfile, level, namespace_='hdf5:', name_='SoftLink', pretty_print=pretty_print)
    def to_etree(self, parent_element=None, name_='Group', mapping_=None):
        if parent_element is None:
            element = etree_.Element('{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        else:
            element = etree_.SubElement(parent_element, '{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        if self.OBJ_XID is not None:
            element.set('OBJ-XID', self.gds_format_string(self.OBJ_XID))
        if self.H5ParentPaths is not None:
            element.set('H5ParentPaths', self.gds_format_string(self.H5ParentPaths))
        if self.Parents is not None:
            element.set('Parents', self.gds_format_string(self.Parents))
        if self.Name is not None:
            element.set('Name', self.gds_format_string(self.Name))
        if self.H5Path is not None:
            element.set('H5Path', self.gds_format_string(self.H5Path))
        if self.GroupPtr is not None:
            GroupPtr_ = self.GroupPtr
            GroupPtr_.to_etree(element, name_='GroupPtr', mapping_=mapping_)
        for Attribute_ in self.Attribute:
            Attribute_.to_etree(element, name_='Attribute', mapping_=mapping_)
        for Group_ in self.Group:
            Group_.to_etree(element, name_='Group', mapping_=mapping_)
        for Dataset_ in self.Dataset:
            Dataset_.to_etree(element, name_='Dataset', mapping_=mapping_)
        for NamedDataType_ in self.NamedDataType:
            NamedDataType_.to_etree(element, name_='NamedDataType', mapping_=mapping_)
        for SoftLink_ in self.SoftLink:
            SoftLink_.to_etree(element, name_='SoftLink', mapping_=mapping_)
        if mapping_ is not None:
            mapping_[self] = element
        return element
    def exportLiteral(self, outfile, level, name_='Group'):
        level += 1
        already_processed = set()
        self.exportLiteralAttributes(outfile, level, already_processed, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, already_processed, name_):
        if self.OBJ_XID is not None and 'OBJ_XID' not in already_processed:
            already_processed.add('OBJ_XID')
            showIndent(outfile, level)
            outfile.write('OBJ_XID="%s",\n' % (self.OBJ_XID,))
        if self.H5ParentPaths is not None and 'H5ParentPaths' not in already_processed:
            already_processed.add('H5ParentPaths')
            showIndent(outfile, level)
            outfile.write('H5ParentPaths="%s",\n' % (self.H5ParentPaths,))
        if self.Parents is not None and 'Parents' not in already_processed:
            already_processed.add('Parents')
            showIndent(outfile, level)
            outfile.write('Parents="%s",\n' % (self.Parents,))
        if self.Name is not None and 'Name' not in already_processed:
            already_processed.add('Name')
            showIndent(outfile, level)
            outfile.write('Name="%s",\n' % (self.Name,))
        if self.H5Path is not None and 'H5Path' not in already_processed:
            already_processed.add('H5Path')
            showIndent(outfile, level)
            outfile.write('H5Path="%s",\n' % (self.H5Path,))
    def exportLiteralChildren(self, outfile, level, name_):
        if self.GroupPtr is not None:
            showIndent(outfile, level)
            outfile.write('GroupPtr=model_.GroupPtr(\n')
            self.GroupPtr.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        showIndent(outfile, level)
        outfile.write('Attribute=[\n')
        level += 1
        for Attribute_ in self.Attribute:
            showIndent(outfile, level)
            outfile.write('model_.Attribute(\n')
            Attribute_.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
        showIndent(outfile, level)
        outfile.write('Group=[\n')
        level += 1
        for Group_ in self.Group:
            showIndent(outfile, level)
            outfile.write('model_.Group(\n')
            Group_.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
        showIndent(outfile, level)
        outfile.write('Dataset=[\n')
        level += 1
        for Dataset_ in self.Dataset:
            showIndent(outfile, level)
            outfile.write('model_.Dataset(\n')
            Dataset_.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
        showIndent(outfile, level)
        outfile.write('NamedDataType=[\n')
        level += 1
        for NamedDataType_ in self.NamedDataType:
            showIndent(outfile, level)
            outfile.write('model_.NamedDataType(\n')
            NamedDataType_.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
        showIndent(outfile, level)
        outfile.write('SoftLink=[\n')
        level += 1
        for SoftLink_ in self.SoftLink:
            showIndent(outfile, level)
            outfile.write('model_.SoftLink(\n')
            SoftLink_.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
    def build(self, node):
        already_processed = set()
        self.buildAttributes(node, node.attrib, already_processed)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
        return self
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('OBJ-XID', node)
        if value is not None and 'OBJ-XID' not in already_processed:
            already_processed.add('OBJ-XID')
            self.OBJ_XID = value
        value = find_attr_value_('H5ParentPaths', node)
        if value is not None and 'H5ParentPaths' not in already_processed:
            already_processed.add('H5ParentPaths')
            self.H5ParentPaths = value
        value = find_attr_value_('Parents', node)
        if value is not None and 'Parents' not in already_processed:
            already_processed.add('Parents')
            self.Parents = value
        value = find_attr_value_('Name', node)
        if value is not None and 'Name' not in already_processed:
            already_processed.add('Name')
            self.Name = value
        value = find_attr_value_('H5Path', node)
        if value is not None and 'H5Path' not in already_processed:
            already_processed.add('H5Path')
            self.H5Path = value
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'GroupPtr':
            obj_ = GroupPtr.factory()
            obj_.build(child_)
            self.GroupPtr = obj_
            obj_.original_tagname_ = 'GroupPtr'
        elif nodeName_ == 'Attribute':
            obj_ = Attribute.factory()
            obj_.build(child_)
            self.Attribute.append(obj_)
            obj_.original_tagname_ = 'Attribute'
        elif nodeName_ == 'Group':
            obj_ = Group.factory()
            obj_.build(child_)
            self.Group.append(obj_)
            obj_.original_tagname_ = 'Group'
        elif nodeName_ == 'Dataset':
            obj_ = Dataset.factory()
            obj_.build(child_)
            self.Dataset.append(obj_)
            obj_.original_tagname_ = 'Dataset'
        elif nodeName_ == 'NamedDataType':
            obj_ = NamedDataType.factory()
            obj_.build(child_)
            self.NamedDataType.append(obj_)
            obj_.original_tagname_ = 'NamedDataType'
        elif nodeName_ == 'SoftLink':
            obj_ = SoftLink.factory()
            obj_.build(child_)
            self.SoftLink.append(obj_)
            obj_.original_tagname_ = 'SoftLink'
# end class Group


class GroupPtr(GeneratedsSuper):
    member_data_items_ = {
        'OBJ-XID': MemberSpec_('OBJ-XID', 'xs:string', 0),
        'Parents': MemberSpec_('Parents', 'xs:string', 0),
        'H5ParentPaths': MemberSpec_('H5ParentPaths', 'xs:string', 0),
        'H5Path': MemberSpec_('H5Path', 'xs:string', 0),
    }
    subclass = None
    superclass = None
    def __init__(self, OBJ_XID=None, Parents=None, H5ParentPaths=None, H5Path=None):
        self.original_tagname_ = None
        self.OBJ_XID = _cast(None, OBJ_XID)
        self.Parents = _cast(None, Parents)
        self.H5ParentPaths = _cast(None, H5ParentPaths)
        self.H5Path = _cast(None, H5Path)
    def factory(*args_, **kwargs_):
        if GroupPtr.subclass:
            return GroupPtr.subclass(*args_, **kwargs_)
        else:
            return GroupPtr(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_OBJ_XID(self): return self.OBJ_XID
    def set_OBJ_XID(self, OBJ_XID): self.OBJ_XID = OBJ_XID
    def get_Parents(self): return self.Parents
    def set_Parents(self, Parents): self.Parents = Parents
    def get_H5ParentPaths(self): return self.H5ParentPaths
    def set_H5ParentPaths(self, H5ParentPaths): self.H5ParentPaths = H5ParentPaths
    def get_H5Path(self): return self.H5Path
    def set_H5Path(self, H5Path): self.H5Path = H5Path
    def hasContent_(self):
        if (

        ):
            return True
        else:
            return False
    def export(self, outfile, level, namespace_='hdf5:', name_='GroupPtr', namespacedef_='xmlns:hdf5="http://hdfgroup.org/HDF5/XML/schema/HDF5-File"', pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.original_tagname_ is not None:
            name_ = self.original_tagname_
        showIndent(outfile, level, pretty_print)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = set()
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='GroupPtr')
        if self.hasContent_():
            outfile.write('>%s' % (eol_, ))
            self.exportChildren(outfile, level + 1, namespace_='hdf5:', name_='GroupPtr', pretty_print=pretty_print)
            outfile.write('</%s%s>%s' % (namespace_, name_, eol_))
        else:
            outfile.write('/>%s' % (eol_, ))
    def exportAttributes(self, outfile, level, already_processed, namespace_='hdf5:', name_='GroupPtr'):
        if self.OBJ_XID is not None and 'OBJ_XID' not in already_processed:
            already_processed.add('OBJ_XID')
            outfile.write(' OBJ-XID=%s' % (self.gds_format_string(quote_attrib(self.OBJ_XID).encode(ExternalEncoding), input_name='OBJ-XID'), ))
        if self.Parents is not None and 'Parents' not in already_processed:
            already_processed.add('Parents')
            outfile.write(' Parents=%s' % (self.gds_format_string(quote_attrib(self.Parents).encode(ExternalEncoding), input_name='Parents'), ))
        if self.H5ParentPaths is not None and 'H5ParentPaths' not in already_processed:
            already_processed.add('H5ParentPaths')
            outfile.write(' H5ParentPaths=%s' % (self.gds_format_string(quote_attrib(self.H5ParentPaths).encode(ExternalEncoding), input_name='H5ParentPaths'), ))
        if self.H5Path is not None and 'H5Path' not in already_processed:
            already_processed.add('H5Path')
            outfile.write(' H5Path=%s' % (self.gds_format_string(quote_attrib(self.H5Path).encode(ExternalEncoding), input_name='H5Path'), ))
    def exportChildren(self, outfile, level, namespace_='hdf5:', name_='GroupPtr', fromsubclass_=False, pretty_print=True):
        pass
    def to_etree(self, parent_element=None, name_='GroupPtr', mapping_=None):
        if parent_element is None:
            element = etree_.Element('{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        else:
            element = etree_.SubElement(parent_element, '{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        if self.OBJ_XID is not None:
            element.set('OBJ-XID', self.gds_format_string(self.OBJ_XID))
        if self.Parents is not None:
            element.set('Parents', self.gds_format_string(self.Parents))
        if self.H5ParentPaths is not None:
            element.set('H5ParentPaths', self.gds_format_string(self.H5ParentPaths))
        if self.H5Path is not None:
            element.set('H5Path', self.gds_format_string(self.H5Path))
        if mapping_ is not None:
            mapping_[self] = element
        return element
    def exportLiteral(self, outfile, level, name_='GroupPtr'):
        level += 1
        already_processed = set()
        self.exportLiteralAttributes(outfile, level, already_processed, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, already_processed, name_):
        if self.OBJ_XID is not None and 'OBJ_XID' not in already_processed:
            already_processed.add('OBJ_XID')
            showIndent(outfile, level)
            outfile.write('OBJ_XID="%s",\n' % (self.OBJ_XID,))
        if self.Parents is not None and 'Parents' not in already_processed:
            already_processed.add('Parents')
            showIndent(outfile, level)
            outfile.write('Parents="%s",\n' % (self.Parents,))
        if self.H5ParentPaths is not None and 'H5ParentPaths' not in already_processed:
            already_processed.add('H5ParentPaths')
            showIndent(outfile, level)
            outfile.write('H5ParentPaths="%s",\n' % (self.H5ParentPaths,))
        if self.H5Path is not None and 'H5Path' not in already_processed:
            already_processed.add('H5Path')
            showIndent(outfile, level)
            outfile.write('H5Path="%s",\n' % (self.H5Path,))
    def exportLiteralChildren(self, outfile, level, name_):
        pass
    def build(self, node):
        already_processed = set()
        self.buildAttributes(node, node.attrib, already_processed)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
        return self
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('OBJ-XID', node)
        if value is not None and 'OBJ-XID' not in already_processed:
            already_processed.add('OBJ-XID')
            self.OBJ_XID = value
        value = find_attr_value_('Parents', node)
        if value is not None and 'Parents' not in already_processed:
            already_processed.add('Parents')
            self.Parents = value
        value = find_attr_value_('H5ParentPaths', node)
        if value is not None and 'H5ParentPaths' not in already_processed:
            already_processed.add('H5ParentPaths')
            self.H5ParentPaths = value
        value = find_attr_value_('H5Path', node)
        if value is not None and 'H5Path' not in already_processed:
            already_processed.add('H5Path')
            self.H5Path = value
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        pass
# end class GroupPtr


class HDF5_File(GeneratedsSuper):
    member_data_items_ = {
        'UserBlock': MemberSpec_('UserBlock', 'xs:string', 0),
        'SuperBlock': MemberSpec_('SuperBlock', 'SuperBlock', 0),
        'RootGroup': MemberSpec_('RootGroup', 'RootGroup', 0),
    }
    subclass = None
    superclass = None
    def __init__(self, UserBlock=None, SuperBlock=None, RootGroup=None):
        self.original_tagname_ = None
        self.UserBlock = UserBlock
        self.SuperBlock = SuperBlock
        self.RootGroup = RootGroup
    def factory(*args_, **kwargs_):
        if HDF5_File.subclass:
            return HDF5_File.subclass(*args_, **kwargs_)
        else:
            return HDF5_File(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_UserBlock(self): return self.UserBlock
    def set_UserBlock(self, UserBlock): self.UserBlock = UserBlock
    def get_SuperBlock(self): return self.SuperBlock
    def set_SuperBlock(self, SuperBlock): self.SuperBlock = SuperBlock
    def get_RootGroup(self): return self.RootGroup
    def set_RootGroup(self, RootGroup): self.RootGroup = RootGroup
    def hasContent_(self):
        if (
            self.UserBlock is not None or
            self.SuperBlock is not None or
            self.RootGroup is not None
        ):
            return True
        else:
            return False
    def export(self, outfile, level, namespace_='hdf5:', name_='HDF5-File', namespacedef_='xmlns:hdf5="http://hdfgroup.org/HDF5/XML/schema/HDF5-File"', pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.original_tagname_ is not None:
            name_ = self.original_tagname_
        showIndent(outfile, level, pretty_print)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = set()
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='HDF5-File')
        if self.hasContent_():
            outfile.write('>%s' % (eol_, ))
            self.exportChildren(outfile, level + 1, namespace_='hdf5:', name_='HDF5-File', pretty_print=pretty_print)
            showIndent(outfile, level, pretty_print)
            outfile.write('</%s%s>%s' % (namespace_, name_, eol_))
        else:
            outfile.write('/>%s' % (eol_, ))
    def exportAttributes(self, outfile, level, already_processed, namespace_='hdf5:', name_='HDF5-File'):
        pass
    def exportChildren(self, outfile, level, namespace_='hdf5:', name_='HDF5-File', fromsubclass_=False, pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.UserBlock is not None:
            showIndent(outfile, level, pretty_print)
            outfile.write('<%sUserBlock>%s</%sUserBlock>%s' % (namespace_, self.gds_format_string(quote_xml(self.UserBlock).encode(ExternalEncoding), input_name='UserBlock'), namespace_, eol_))
        if self.SuperBlock is not None:
            self.SuperBlock.export(outfile, level, namespace_='hdf5:', name_='SuperBlock', pretty_print=pretty_print)
        if self.RootGroup is not None:
            self.RootGroup.export(outfile, level, namespace_='hdf5:', name_='RootGroup', pretty_print=pretty_print)
    def to_etree(self, parent_element=None, name_='HDF5-File', mapping_=None):
        if parent_element is None:
            element = etree_.Element('{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        else:
            element = etree_.SubElement(parent_element, '{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        if self.UserBlock is not None:
            UserBlock_ = self.UserBlock
            etree_.SubElement(element, '{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}UserBlock').text = self.gds_format_string(UserBlock_)
        if self.SuperBlock is not None:
            SuperBlock_ = self.SuperBlock
            SuperBlock_.to_etree(element, name_='SuperBlock', mapping_=mapping_)
        if self.RootGroup is not None:
            RootGroup_ = self.RootGroup
            RootGroup_.to_etree(element, name_='RootGroup', mapping_=mapping_)
        if mapping_ is not None:
            mapping_[self] = element
        return element
    def exportLiteral(self, outfile, level, name_='HDF5-File'):
        level += 1
        already_processed = set()
        self.exportLiteralAttributes(outfile, level, already_processed, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, already_processed, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        if self.UserBlock is not None:
            showIndent(outfile, level)
            outfile.write('UserBlock=%s,\n' % quote_python(self.UserBlock).encode(ExternalEncoding))
        if self.SuperBlock is not None:
            showIndent(outfile, level)
            outfile.write('SuperBlock=model_.SuperBlock(\n')
            self.SuperBlock.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.RootGroup is not None:
            showIndent(outfile, level)
            outfile.write('RootGroup=model_.RootGroup(\n')
            self.RootGroup.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
    def build(self, node):
        already_processed = set()
        self.buildAttributes(node, node.attrib, already_processed)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
        return self
    def buildAttributes(self, node, attrs, already_processed):
        pass
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'UserBlock':
            UserBlock_ = child_.text
            UserBlock_ = self.gds_validate_string(UserBlock_, node, 'UserBlock')
            self.UserBlock = UserBlock_
        elif nodeName_ == 'SuperBlock':
            obj_ = SuperBlock.factory()
            obj_.build(child_)
            self.SuperBlock = obj_
            obj_.original_tagname_ = 'SuperBlock'
        elif nodeName_ == 'RootGroup':
            obj_ = RootGroup.factory()
            obj_.build(child_)
            self.RootGroup = obj_
            obj_.original_tagname_ = 'RootGroup'
# end class HDF5_File


class IntegerType(GeneratedsSuper):
    member_data_items_ = {
        'Size': MemberSpec_('Size', 'xs:NMTOKEN', 0),
        'Sign': MemberSpec_('Sign', 'xs:NMTOKEN', 0),
        'ByteOrder': MemberSpec_('ByteOrder', 'xs:NMTOKEN', 0),
    }
    subclass = None
    superclass = None
    def __init__(self, Size=None, Sign=None, ByteOrder=None):
        self.original_tagname_ = None
        self.Size = _cast(None, Size)
        self.Sign = _cast(None, Sign)
        self.ByteOrder = _cast(None, ByteOrder)
    def factory(*args_, **kwargs_):
        if IntegerType.subclass:
            return IntegerType.subclass(*args_, **kwargs_)
        else:
            return IntegerType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_Size(self): return self.Size
    def set_Size(self, Size): self.Size = Size
    def get_Sign(self): return self.Sign
    def set_Sign(self, Sign): self.Sign = Sign
    def get_ByteOrder(self): return self.ByteOrder
    def set_ByteOrder(self, ByteOrder): self.ByteOrder = ByteOrder
    def hasContent_(self):
        if (

        ):
            return True
        else:
            return False
    def export(self, outfile, level, namespace_='hdf5:', name_='IntegerType', namespacedef_='xmlns:hdf5="http://hdfgroup.org/HDF5/XML/schema/HDF5-File"', pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.original_tagname_ is not None:
            name_ = self.original_tagname_
        showIndent(outfile, level, pretty_print)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = set()
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='IntegerType')
        if self.hasContent_():
            outfile.write('>%s' % (eol_, ))
            self.exportChildren(outfile, level + 1, namespace_='hdf5:', name_='IntegerType', pretty_print=pretty_print)
            outfile.write('</%s%s>%s' % (namespace_, name_, eol_))
        else:
            outfile.write('/>%s' % (eol_, ))
    def exportAttributes(self, outfile, level, already_processed, namespace_='hdf5:', name_='IntegerType'):
        if self.Size is not None and 'Size' not in already_processed:
            already_processed.add('Size')
            outfile.write(' Size=%s' % (self.gds_format_string(quote_attrib(self.Size).encode(ExternalEncoding), input_name='Size'), ))
        if self.Sign is not None and 'Sign' not in already_processed:
            already_processed.add('Sign')
            outfile.write(' Sign=%s' % (self.gds_format_string(quote_attrib(self.Sign).encode(ExternalEncoding), input_name='Sign'), ))
        if self.ByteOrder is not None and 'ByteOrder' not in already_processed:
            already_processed.add('ByteOrder')
            outfile.write(' ByteOrder=%s' % (self.gds_format_string(quote_attrib(self.ByteOrder).encode(ExternalEncoding), input_name='ByteOrder'), ))
    def exportChildren(self, outfile, level, namespace_='hdf5:', name_='IntegerType', fromsubclass_=False, pretty_print=True):
        pass
    def to_etree(self, parent_element=None, name_='IntegerType', mapping_=None):
        if parent_element is None:
            element = etree_.Element('{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        else:
            element = etree_.SubElement(parent_element, '{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        if self.Size is not None:
            element.set('Size', self.gds_format_string(self.Size))
        if self.Sign is not None:
            element.set('Sign', self.gds_format_string(self.Sign))
        if self.ByteOrder is not None:
            element.set('ByteOrder', self.gds_format_string(self.ByteOrder))
        if mapping_ is not None:
            mapping_[self] = element
        return element
    def exportLiteral(self, outfile, level, name_='IntegerType'):
        level += 1
        already_processed = set()
        self.exportLiteralAttributes(outfile, level, already_processed, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, already_processed, name_):
        if self.Size is not None and 'Size' not in already_processed:
            already_processed.add('Size')
            showIndent(outfile, level)
            outfile.write('Size="%s",\n' % (self.Size,))
        if self.Sign is not None and 'Sign' not in already_processed:
            already_processed.add('Sign')
            showIndent(outfile, level)
            outfile.write('Sign="%s",\n' % (self.Sign,))
        if self.ByteOrder is not None and 'ByteOrder' not in already_processed:
            already_processed.add('ByteOrder')
            showIndent(outfile, level)
            outfile.write('ByteOrder="%s",\n' % (self.ByteOrder,))
    def exportLiteralChildren(self, outfile, level, name_):
        pass
    def build(self, node):
        already_processed = set()
        self.buildAttributes(node, node.attrib, already_processed)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
        return self
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('Size', node)
        if value is not None and 'Size' not in already_processed:
            already_processed.add('Size')
            self.Size = value
        value = find_attr_value_('Sign', node)
        if value is not None and 'Sign' not in already_processed:
            already_processed.add('Sign')
            self.Sign = value
        value = find_attr_value_('ByteOrder', node)
        if value is not None and 'ByteOrder' not in already_processed:
            already_processed.add('ByteOrder')
            self.ByteOrder = value
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        pass
# end class IntegerType


class NamedDataType(GeneratedsSuper):
    member_data_items_ = {
        'OBJ-XID': MemberSpec_('OBJ-XID', 'xs:string', 0),
        'H5ParentPaths': MemberSpec_('H5ParentPaths', 'xs:string', 0),
        'Parents': MemberSpec_('Parents', 'xs:string', 0),
        'Name': MemberSpec_('Name', 'xs:string', 0),
        'H5Path': MemberSpec_('H5Path', 'xs:string', 0),
        'NamedDataTypePtr': MemberSpec_('NamedDataTypePtr', 'NamedDataTypePtr', 0),
        'Attribute': MemberSpec_('Attribute', 'Attribute', 1),
        'DataType': MemberSpec_('DataType', 'DataType', 0),
    }
    subclass = None
    superclass = None
    def __init__(self, OBJ_XID=None, H5ParentPaths=None, Parents=None, Name=None, H5Path=None, NamedDataTypePtr=None, Attribute=None, DataType=None):
        self.original_tagname_ = None
        self.OBJ_XID = _cast(None, OBJ_XID)
        self.H5ParentPaths = _cast(None, H5ParentPaths)
        self.Parents = _cast(None, Parents)
        self.Name = _cast(None, Name)
        self.H5Path = _cast(None, H5Path)
        self.NamedDataTypePtr = NamedDataTypePtr
        if Attribute is None:
            self.Attribute = []
        else:
            self.Attribute = Attribute
        self.DataType = DataType
    def factory(*args_, **kwargs_):
        if NamedDataType.subclass:
            return NamedDataType.subclass(*args_, **kwargs_)
        else:
            return NamedDataType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_NamedDataTypePtr(self): return self.NamedDataTypePtr
    def set_NamedDataTypePtr(self, NamedDataTypePtr): self.NamedDataTypePtr = NamedDataTypePtr
    def get_Attribute(self): return self.Attribute
    def set_Attribute(self, Attribute): self.Attribute = Attribute
    def add_Attribute(self, value): self.Attribute.append(value)
    def insert_Attribute(self, index, value): self.Attribute[index] = value
    def get_DataType(self): return self.DataType
    def set_DataType(self, DataType): self.DataType = DataType
    def get_OBJ_XID(self): return self.OBJ_XID
    def set_OBJ_XID(self, OBJ_XID): self.OBJ_XID = OBJ_XID
    def get_H5ParentPaths(self): return self.H5ParentPaths
    def set_H5ParentPaths(self, H5ParentPaths): self.H5ParentPaths = H5ParentPaths
    def get_Parents(self): return self.Parents
    def set_Parents(self, Parents): self.Parents = Parents
    def get_Name(self): return self.Name
    def set_Name(self, Name): self.Name = Name
    def get_H5Path(self): return self.H5Path
    def set_H5Path(self, H5Path): self.H5Path = H5Path
    def hasContent_(self):
        if (
            self.NamedDataTypePtr is not None or
            self.Attribute or
            self.DataType is not None
        ):
            return True
        else:
            return False
    def export(self, outfile, level, namespace_='hdf5:', name_='NamedDataType', namespacedef_='xmlns:hdf5="http://hdfgroup.org/HDF5/XML/schema/HDF5-File"', pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.original_tagname_ is not None:
            name_ = self.original_tagname_
        showIndent(outfile, level, pretty_print)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = set()
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='NamedDataType')
        if self.hasContent_():
            outfile.write('>%s' % (eol_, ))
            self.exportChildren(outfile, level + 1, namespace_='hdf5:', name_='NamedDataType', pretty_print=pretty_print)
            showIndent(outfile, level, pretty_print)
            outfile.write('</%s%s>%s' % (namespace_, name_, eol_))
        else:
            outfile.write('/>%s' % (eol_, ))
    def exportAttributes(self, outfile, level, already_processed, namespace_='hdf5:', name_='NamedDataType'):
        if self.OBJ_XID is not None and 'OBJ_XID' not in already_processed:
            already_processed.add('OBJ_XID')
            outfile.write(' OBJ-XID=%s' % (self.gds_format_string(quote_attrib(self.OBJ_XID).encode(ExternalEncoding), input_name='OBJ-XID'), ))
        if self.H5ParentPaths is not None and 'H5ParentPaths' not in already_processed:
            already_processed.add('H5ParentPaths')
            outfile.write(' H5ParentPaths=%s' % (self.gds_format_string(quote_attrib(self.H5ParentPaths).encode(ExternalEncoding), input_name='H5ParentPaths'), ))
        if self.Parents is not None and 'Parents' not in already_processed:
            already_processed.add('Parents')
            outfile.write(' Parents=%s' % (self.gds_format_string(quote_attrib(self.Parents).encode(ExternalEncoding), input_name='Parents'), ))
        if self.Name is not None and 'Name' not in already_processed:
            already_processed.add('Name')
            outfile.write(' Name=%s' % (self.gds_format_string(quote_attrib(self.Name).encode(ExternalEncoding), input_name='Name'), ))
        if self.H5Path is not None and 'H5Path' not in already_processed:
            already_processed.add('H5Path')
            outfile.write(' H5Path=%s' % (self.gds_format_string(quote_attrib(self.H5Path).encode(ExternalEncoding), input_name='H5Path'), ))
    def exportChildren(self, outfile, level, namespace_='hdf5:', name_='NamedDataType', fromsubclass_=False, pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.NamedDataTypePtr is not None:
            self.NamedDataTypePtr.export(outfile, level, namespace_='hdf5:', name_='NamedDataTypePtr', pretty_print=pretty_print)
        for Attribute_ in self.Attribute:
            Attribute_.export(outfile, level, namespace_='hdf5:', name_='Attribute', pretty_print=pretty_print)
        if self.DataType is not None:
            self.DataType.export(outfile, level, namespace_='hdf5:', name_='DataType', pretty_print=pretty_print)
    def to_etree(self, parent_element=None, name_='NamedDataType', mapping_=None):
        if parent_element is None:
            element = etree_.Element('{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        else:
            element = etree_.SubElement(parent_element, '{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        if self.OBJ_XID is not None:
            element.set('OBJ-XID', self.gds_format_string(self.OBJ_XID))
        if self.H5ParentPaths is not None:
            element.set('H5ParentPaths', self.gds_format_string(self.H5ParentPaths))
        if self.Parents is not None:
            element.set('Parents', self.gds_format_string(self.Parents))
        if self.Name is not None:
            element.set('Name', self.gds_format_string(self.Name))
        if self.H5Path is not None:
            element.set('H5Path', self.gds_format_string(self.H5Path))
        if self.NamedDataTypePtr is not None:
            NamedDataTypePtr_ = self.NamedDataTypePtr
            NamedDataTypePtr_.to_etree(element, name_='NamedDataTypePtr', mapping_=mapping_)
        for Attribute_ in self.Attribute:
            Attribute_.to_etree(element, name_='Attribute', mapping_=mapping_)
        if self.DataType is not None:
            DataType_ = self.DataType
            DataType_.to_etree(element, name_='DataType', mapping_=mapping_)
        if mapping_ is not None:
            mapping_[self] = element
        return element
    def exportLiteral(self, outfile, level, name_='NamedDataType'):
        level += 1
        already_processed = set()
        self.exportLiteralAttributes(outfile, level, already_processed, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, already_processed, name_):
        if self.OBJ_XID is not None and 'OBJ_XID' not in already_processed:
            already_processed.add('OBJ_XID')
            showIndent(outfile, level)
            outfile.write('OBJ_XID="%s",\n' % (self.OBJ_XID,))
        if self.H5ParentPaths is not None and 'H5ParentPaths' not in already_processed:
            already_processed.add('H5ParentPaths')
            showIndent(outfile, level)
            outfile.write('H5ParentPaths="%s",\n' % (self.H5ParentPaths,))
        if self.Parents is not None and 'Parents' not in already_processed:
            already_processed.add('Parents')
            showIndent(outfile, level)
            outfile.write('Parents="%s",\n' % (self.Parents,))
        if self.Name is not None and 'Name' not in already_processed:
            already_processed.add('Name')
            showIndent(outfile, level)
            outfile.write('Name="%s",\n' % (self.Name,))
        if self.H5Path is not None and 'H5Path' not in already_processed:
            already_processed.add('H5Path')
            showIndent(outfile, level)
            outfile.write('H5Path="%s",\n' % (self.H5Path,))
    def exportLiteralChildren(self, outfile, level, name_):
        if self.NamedDataTypePtr is not None:
            showIndent(outfile, level)
            outfile.write('NamedDataTypePtr=model_.NamedDataTypePtr(\n')
            self.NamedDataTypePtr.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        showIndent(outfile, level)
        outfile.write('Attribute=[\n')
        level += 1
        for Attribute_ in self.Attribute:
            showIndent(outfile, level)
            outfile.write('model_.Attribute(\n')
            Attribute_.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
        if self.DataType is not None:
            showIndent(outfile, level)
            outfile.write('DataType=model_.DataType(\n')
            self.DataType.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
    def build(self, node):
        already_processed = set()
        self.buildAttributes(node, node.attrib, already_processed)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
        return self
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('OBJ-XID', node)
        if value is not None and 'OBJ-XID' not in already_processed:
            already_processed.add('OBJ-XID')
            self.OBJ_XID = value
        value = find_attr_value_('H5ParentPaths', node)
        if value is not None and 'H5ParentPaths' not in already_processed:
            already_processed.add('H5ParentPaths')
            self.H5ParentPaths = value
        value = find_attr_value_('Parents', node)
        if value is not None and 'Parents' not in already_processed:
            already_processed.add('Parents')
            self.Parents = value
        value = find_attr_value_('Name', node)
        if value is not None and 'Name' not in already_processed:
            already_processed.add('Name')
            self.Name = value
        value = find_attr_value_('H5Path', node)
        if value is not None and 'H5Path' not in already_processed:
            already_processed.add('H5Path')
            self.H5Path = value
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'NamedDataTypePtr':
            obj_ = NamedDataTypePtr.factory()
            obj_.build(child_)
            self.NamedDataTypePtr = obj_
            obj_.original_tagname_ = 'NamedDataTypePtr'
        elif nodeName_ == 'Attribute':
            obj_ = Attribute.factory()
            obj_.build(child_)
            self.Attribute.append(obj_)
            obj_.original_tagname_ = 'Attribute'
        elif nodeName_ == 'DataType':
            obj_ = DataType.factory()
            obj_.build(child_)
            self.DataType = obj_
            obj_.original_tagname_ = 'DataType'
# end class NamedDataType


class NamedDataTypePtr(GeneratedsSuper):
    member_data_items_ = {
        'OBJ-XID': MemberSpec_('OBJ-XID', 'xs:string', 0),
        'H5Path': MemberSpec_('H5Path', 'xs:string', 0),
    }
    subclass = None
    superclass = None
    def __init__(self, OBJ_XID=None, H5Path=None):
        self.original_tagname_ = None
        self.OBJ_XID = _cast(None, OBJ_XID)
        self.H5Path = _cast(None, H5Path)
    def factory(*args_, **kwargs_):
        if NamedDataTypePtr.subclass:
            return NamedDataTypePtr.subclass(*args_, **kwargs_)
        else:
            return NamedDataTypePtr(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_OBJ_XID(self): return self.OBJ_XID
    def set_OBJ_XID(self, OBJ_XID): self.OBJ_XID = OBJ_XID
    def get_H5Path(self): return self.H5Path
    def set_H5Path(self, H5Path): self.H5Path = H5Path
    def hasContent_(self):
        if (

        ):
            return True
        else:
            return False
    def export(self, outfile, level, namespace_='hdf5:', name_='NamedDataTypePtr', namespacedef_='xmlns:hdf5="http://hdfgroup.org/HDF5/XML/schema/HDF5-File"', pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.original_tagname_ is not None:
            name_ = self.original_tagname_
        showIndent(outfile, level, pretty_print)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = set()
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='NamedDataTypePtr')
        if self.hasContent_():
            outfile.write('>%s' % (eol_, ))
            self.exportChildren(outfile, level + 1, namespace_='hdf5:', name_='NamedDataTypePtr', pretty_print=pretty_print)
            outfile.write('</%s%s>%s' % (namespace_, name_, eol_))
        else:
            outfile.write('/>%s' % (eol_, ))
    def exportAttributes(self, outfile, level, already_processed, namespace_='hdf5:', name_='NamedDataTypePtr'):
        if self.OBJ_XID is not None and 'OBJ_XID' not in already_processed:
            already_processed.add('OBJ_XID')
            outfile.write(' OBJ-XID=%s' % (self.gds_format_string(quote_attrib(self.OBJ_XID).encode(ExternalEncoding), input_name='OBJ-XID'), ))
        if self.H5Path is not None and 'H5Path' not in already_processed:
            already_processed.add('H5Path')
            outfile.write(' H5Path=%s' % (self.gds_format_string(quote_attrib(self.H5Path).encode(ExternalEncoding), input_name='H5Path'), ))
    def exportChildren(self, outfile, level, namespace_='hdf5:', name_='NamedDataTypePtr', fromsubclass_=False, pretty_print=True):
        pass
    def to_etree(self, parent_element=None, name_='NamedDataTypePtr', mapping_=None):
        if parent_element is None:
            element = etree_.Element('{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        else:
            element = etree_.SubElement(parent_element, '{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        if self.OBJ_XID is not None:
            element.set('OBJ-XID', self.gds_format_string(self.OBJ_XID))
        if self.H5Path is not None:
            element.set('H5Path', self.gds_format_string(self.H5Path))
        if mapping_ is not None:
            mapping_[self] = element
        return element
    def exportLiteral(self, outfile, level, name_='NamedDataTypePtr'):
        level += 1
        already_processed = set()
        self.exportLiteralAttributes(outfile, level, already_processed, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, already_processed, name_):
        if self.OBJ_XID is not None and 'OBJ_XID' not in already_processed:
            already_processed.add('OBJ_XID')
            showIndent(outfile, level)
            outfile.write('OBJ_XID="%s",\n' % (self.OBJ_XID,))
        if self.H5Path is not None and 'H5Path' not in already_processed:
            already_processed.add('H5Path')
            showIndent(outfile, level)
            outfile.write('H5Path="%s",\n' % (self.H5Path,))
    def exportLiteralChildren(self, outfile, level, name_):
        pass
    def build(self, node):
        already_processed = set()
        self.buildAttributes(node, node.attrib, already_processed)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
        return self
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('OBJ-XID', node)
        if value is not None and 'OBJ-XID' not in already_processed:
            already_processed.add('OBJ-XID')
            self.OBJ_XID = value
        value = find_attr_value_('H5Path', node)
        if value is not None and 'H5Path' not in already_processed:
            already_processed.add('H5Path')
            self.H5Path = value
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        pass
# end class NamedDataTypePtr


class NativeHDF5(GeneratedsSuper):
    """This element needs to be refined to implement a structured pointer
    to a file+dataset+selection"""
    member_data_items_ = {
        'H5Path': MemberSpec_('H5Path', 'xs:string', 0),
        'stride': MemberSpec_('stride', 'xs:string', 0),
        'OBJ-XID': MemberSpec_('OBJ-XID', 'xs:string', 0),
        'start': MemberSpec_('start', 'xs:string', 0),
        'xlink_href': MemberSpec_('xlink_href', 'xs:string', 0),
        'xlink_type': MemberSpec_('xlink_type', 'xs:string', 0),
        'nelems': MemberSpec_('nelems', 'xs:string', 0),
        'H5ObjectType': MemberSpec_('H5ObjectType', 'xs:NMTOKEN', 0),
        'block': MemberSpec_('block', 'xs:string', 0),
    }
    subclass = None
    superclass = None
    def __init__(self, H5Path=None, stride=None, OBJ_XID=None, start=None, xlink_href=None, xlink_type=None, nelems=None, H5ObjectType=None, block=None):
        self.original_tagname_ = None
        self.H5Path = _cast(None, H5Path)
        self.stride = _cast(None, stride)
        self.OBJ_XID = _cast(None, OBJ_XID)
        self.start = _cast(None, start)
        self.xlink_href = _cast(None, xlink_href)
        self.xlink_type = _cast(None, xlink_type)
        self.nelems = _cast(None, nelems)
        self.H5ObjectType = _cast(None, H5ObjectType)
        self.block = _cast(None, block)
    def factory(*args_, **kwargs_):
        if NativeHDF5.subclass:
            return NativeHDF5.subclass(*args_, **kwargs_)
        else:
            return NativeHDF5(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_H5Path(self): return self.H5Path
    def set_H5Path(self, H5Path): self.H5Path = H5Path
    def get_stride(self): return self.stride
    def set_stride(self, stride): self.stride = stride
    def get_OBJ_XID(self): return self.OBJ_XID
    def set_OBJ_XID(self, OBJ_XID): self.OBJ_XID = OBJ_XID
    def get_start(self): return self.start
    def set_start(self, start): self.start = start
    def get_xlink_href(self): return self.xlink_href
    def set_xlink_href(self, xlink_href): self.xlink_href = xlink_href
    def get_xlink_type(self): return self.xlink_type
    def set_xlink_type(self, xlink_type): self.xlink_type = xlink_type
    def get_nelems(self): return self.nelems
    def set_nelems(self, nelems): self.nelems = nelems
    def get_H5ObjectType(self): return self.H5ObjectType
    def set_H5ObjectType(self, H5ObjectType): self.H5ObjectType = H5ObjectType
    def get_block(self): return self.block
    def set_block(self, block): self.block = block
    def hasContent_(self):
        if (

        ):
            return True
        else:
            return False
    def export(self, outfile, level, namespace_='hdf5:', name_='NativeHDF5', namespacedef_='xmlns:hdf5="http://hdfgroup.org/HDF5/XML/schema/HDF5-File"', pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.original_tagname_ is not None:
            name_ = self.original_tagname_
        showIndent(outfile, level, pretty_print)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = set()
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='NativeHDF5')
        if self.hasContent_():
            outfile.write('>%s' % (eol_, ))
            self.exportChildren(outfile, level + 1, namespace_='hdf5:', name_='NativeHDF5', pretty_print=pretty_print)
            outfile.write('</%s%s>%s' % (namespace_, name_, eol_))
        else:
            outfile.write('/>%s' % (eol_, ))
    def exportAttributes(self, outfile, level, already_processed, namespace_='hdf5:', name_='NativeHDF5'):
        if self.H5Path is not None and 'H5Path' not in already_processed:
            already_processed.add('H5Path')
            outfile.write(' H5Path=%s' % (self.gds_format_string(quote_attrib(self.H5Path).encode(ExternalEncoding), input_name='H5Path'), ))
        if self.stride is not None and 'stride' not in already_processed:
            already_processed.add('stride')
            outfile.write(' stride=%s' % (self.gds_format_string(quote_attrib(self.stride).encode(ExternalEncoding), input_name='stride'), ))
        if self.OBJ_XID is not None and 'OBJ_XID' not in already_processed:
            already_processed.add('OBJ_XID')
            outfile.write(' OBJ-XID=%s' % (self.gds_format_string(quote_attrib(self.OBJ_XID).encode(ExternalEncoding), input_name='OBJ-XID'), ))
        if self.start is not None and 'start' not in already_processed:
            already_processed.add('start')
            outfile.write(' start=%s' % (self.gds_format_string(quote_attrib(self.start).encode(ExternalEncoding), input_name='start'), ))
        if self.xlink_href is not None and 'xlink_href' not in already_processed:
            already_processed.add('xlink_href')
            outfile.write(' xlink_href=%s' % (self.gds_format_string(quote_attrib(self.xlink_href).encode(ExternalEncoding), input_name='xlink_href'), ))
        if self.xlink_type is not None and 'xlink_type' not in already_processed:
            already_processed.add('xlink_type')
            outfile.write(' xlink_type=%s' % (self.gds_format_string(quote_attrib(self.xlink_type).encode(ExternalEncoding), input_name='xlink_type'), ))
        if self.nelems is not None and 'nelems' not in already_processed:
            already_processed.add('nelems')
            outfile.write(' nelems=%s' % (self.gds_format_string(quote_attrib(self.nelems).encode(ExternalEncoding), input_name='nelems'), ))
        if self.H5ObjectType is not None and 'H5ObjectType' not in already_processed:
            already_processed.add('H5ObjectType')
            outfile.write(' H5ObjectType=%s' % (self.gds_format_string(quote_attrib(self.H5ObjectType).encode(ExternalEncoding), input_name='H5ObjectType'), ))
        if self.block is not None and 'block' not in already_processed:
            already_processed.add('block')
            outfile.write(' block=%s' % (self.gds_format_string(quote_attrib(self.block).encode(ExternalEncoding), input_name='block'), ))
    def exportChildren(self, outfile, level, namespace_='hdf5:', name_='NativeHDF5', fromsubclass_=False, pretty_print=True):
        pass
    def to_etree(self, parent_element=None, name_='NativeHDF5', mapping_=None):
        if parent_element is None:
            element = etree_.Element('{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        else:
            element = etree_.SubElement(parent_element, '{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        if self.H5Path is not None:
            element.set('H5Path', self.gds_format_string(self.H5Path))
        if self.stride is not None:
            element.set('stride', self.gds_format_string(self.stride))
        if self.OBJ_XID is not None:
            element.set('OBJ-XID', self.gds_format_string(self.OBJ_XID))
        if self.start is not None:
            element.set('start', self.gds_format_string(self.start))
        if self.xlink_href is not None:
            element.set('xlink_href', self.gds_format_string(self.xlink_href))
        if self.xlink_type is not None:
            element.set('xlink_type', self.gds_format_string(self.xlink_type))
        if self.nelems is not None:
            element.set('nelems', self.gds_format_string(self.nelems))
        if self.H5ObjectType is not None:
            element.set('H5ObjectType', self.gds_format_string(self.H5ObjectType))
        if self.block is not None:
            element.set('block', self.gds_format_string(self.block))
        if mapping_ is not None:
            mapping_[self] = element
        return element
    def exportLiteral(self, outfile, level, name_='NativeHDF5'):
        level += 1
        already_processed = set()
        self.exportLiteralAttributes(outfile, level, already_processed, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, already_processed, name_):
        if self.H5Path is not None and 'H5Path' not in already_processed:
            already_processed.add('H5Path')
            showIndent(outfile, level)
            outfile.write('H5Path="%s",\n' % (self.H5Path,))
        if self.stride is not None and 'stride' not in already_processed:
            already_processed.add('stride')
            showIndent(outfile, level)
            outfile.write('stride="%s",\n' % (self.stride,))
        if self.OBJ_XID is not None and 'OBJ_XID' not in already_processed:
            already_processed.add('OBJ_XID')
            showIndent(outfile, level)
            outfile.write('OBJ_XID="%s",\n' % (self.OBJ_XID,))
        if self.start is not None and 'start' not in already_processed:
            already_processed.add('start')
            showIndent(outfile, level)
            outfile.write('start="%s",\n' % (self.start,))
        if self.xlink_href is not None and 'xlink_href' not in already_processed:
            already_processed.add('xlink_href')
            showIndent(outfile, level)
            outfile.write('xlink_href="%s",\n' % (self.xlink_href,))
        if self.xlink_type is not None and 'xlink_type' not in already_processed:
            already_processed.add('xlink_type')
            showIndent(outfile, level)
            outfile.write('xlink_type="%s",\n' % (self.xlink_type,))
        if self.nelems is not None and 'nelems' not in already_processed:
            already_processed.add('nelems')
            showIndent(outfile, level)
            outfile.write('nelems="%s",\n' % (self.nelems,))
        if self.H5ObjectType is not None and 'H5ObjectType' not in already_processed:
            already_processed.add('H5ObjectType')
            showIndent(outfile, level)
            outfile.write('H5ObjectType="%s",\n' % (self.H5ObjectType,))
        if self.block is not None and 'block' not in already_processed:
            already_processed.add('block')
            showIndent(outfile, level)
            outfile.write('block="%s",\n' % (self.block,))
    def exportLiteralChildren(self, outfile, level, name_):
        pass
    def build(self, node):
        already_processed = set()
        self.buildAttributes(node, node.attrib, already_processed)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
        return self
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('H5Path', node)
        if value is not None and 'H5Path' not in already_processed:
            already_processed.add('H5Path')
            self.H5Path = value
        value = find_attr_value_('stride', node)
        if value is not None and 'stride' not in already_processed:
            already_processed.add('stride')
            self.stride = value
        value = find_attr_value_('OBJ-XID', node)
        if value is not None and 'OBJ-XID' not in already_processed:
            already_processed.add('OBJ-XID')
            self.OBJ_XID = value
        value = find_attr_value_('start', node)
        if value is not None and 'start' not in already_processed:
            already_processed.add('start')
            self.start = value
        value = find_attr_value_('xlink_href', node)
        if value is not None and 'xlink_href' not in already_processed:
            already_processed.add('xlink_href')
            self.xlink_href = value
        value = find_attr_value_('xlink_type', node)
        if value is not None and 'xlink_type' not in already_processed:
            already_processed.add('xlink_type')
            self.xlink_type = value
        value = find_attr_value_('nelems', node)
        if value is not None and 'nelems' not in already_processed:
            already_processed.add('nelems')
            self.nelems = value
        value = find_attr_value_('H5ObjectType', node)
        if value is not None and 'H5ObjectType' not in already_processed:
            already_processed.add('H5ObjectType')
            self.H5ObjectType = value
        value = find_attr_value_('block', node)
        if value is not None and 'block' not in already_processed:
            already_processed.add('block')
            self.block = value
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        pass
# end class NativeHDF5


class NoData(GeneratedsSuper):
    member_data_items_ = {
        'FillValue': MemberSpec_('FillValue', 'xs:string', 0),
    }
    subclass = None
    superclass = None
    def __init__(self, FillValue='0'):
        self.original_tagname_ = None
        self.FillValue = _cast(None, FillValue)
    def factory(*args_, **kwargs_):
        if NoData.subclass:
            return NoData.subclass(*args_, **kwargs_)
        else:
            return NoData(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_FillValue(self): return self.FillValue
    def set_FillValue(self, FillValue): self.FillValue = FillValue
    def hasContent_(self):
        if (

        ):
            return True
        else:
            return False
    def export(self, outfile, level, namespace_='hdf5:', name_='NoData', namespacedef_='xmlns:hdf5="http://hdfgroup.org/HDF5/XML/schema/HDF5-File"', pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.original_tagname_ is not None:
            name_ = self.original_tagname_
        showIndent(outfile, level, pretty_print)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = set()
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='NoData')
        if self.hasContent_():
            outfile.write('>%s' % (eol_, ))
            self.exportChildren(outfile, level + 1, namespace_='hdf5:', name_='NoData', pretty_print=pretty_print)
            outfile.write('</%s%s>%s' % (namespace_, name_, eol_))
        else:
            outfile.write('/>%s' % (eol_, ))
    def exportAttributes(self, outfile, level, already_processed, namespace_='hdf5:', name_='NoData'):
        if self.FillValue is not None and 'FillValue' not in already_processed:
            already_processed.add('FillValue')
            outfile.write(' FillValue=%s' % (self.gds_format_string(quote_attrib(self.FillValue).encode(ExternalEncoding), input_name='FillValue'), ))
    def exportChildren(self, outfile, level, namespace_='hdf5:', name_='NoData', fromsubclass_=False, pretty_print=True):
        pass
    def to_etree(self, parent_element=None, name_='NoData', mapping_=None):
        if parent_element is None:
            element = etree_.Element('{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        else:
            element = etree_.SubElement(parent_element, '{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        if self.FillValue is not None:
            element.set('FillValue', self.gds_format_string(self.FillValue))
        if mapping_ is not None:
            mapping_[self] = element
        return element
    def exportLiteral(self, outfile, level, name_='NoData'):
        level += 1
        already_processed = set()
        self.exportLiteralAttributes(outfile, level, already_processed, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, already_processed, name_):
        if self.FillValue is not None and 'FillValue' not in already_processed:
            already_processed.add('FillValue')
            showIndent(outfile, level)
            outfile.write('FillValue="%s",\n' % (self.FillValue,))
    def exportLiteralChildren(self, outfile, level, name_):
        pass
    def build(self, node):
        already_processed = set()
        self.buildAttributes(node, node.attrib, already_processed)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
        return self
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('FillValue', node)
        if value is not None and 'FillValue' not in already_processed:
            already_processed.add('FillValue')
            self.FillValue = value
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        pass
# end class NoData


class ObjectReferenceType(GeneratedsSuper):
    member_data_items_ = {
    }
    subclass = None
    superclass = None
    def __init__(self):
        self.original_tagname_ = None
    def factory(*args_, **kwargs_):
        if ObjectReferenceType.subclass:
            return ObjectReferenceType.subclass(*args_, **kwargs_)
        else:
            return ObjectReferenceType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def hasContent_(self):
        if (

        ):
            return True
        else:
            return False
    def export(self, outfile, level, namespace_='hdf5:', name_='ObjectReferenceType', namespacedef_='xmlns:hdf5="http://hdfgroup.org/HDF5/XML/schema/HDF5-File"', pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.original_tagname_ is not None:
            name_ = self.original_tagname_
        showIndent(outfile, level, pretty_print)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = set()
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='ObjectReferenceType')
        if self.hasContent_():
            outfile.write('>%s' % (eol_, ))
            self.exportChildren(outfile, level + 1, namespace_='hdf5:', name_='ObjectReferenceType', pretty_print=pretty_print)
            outfile.write('</%s%s>%s' % (namespace_, name_, eol_))
        else:
            outfile.write('/>%s' % (eol_, ))
    def exportAttributes(self, outfile, level, already_processed, namespace_='hdf5:', name_='ObjectReferenceType'):
        pass
    def exportChildren(self, outfile, level, namespace_='hdf5:', name_='ObjectReferenceType', fromsubclass_=False, pretty_print=True):
        pass
    def to_etree(self, parent_element=None, name_='ObjectReferenceType', mapping_=None):
        if parent_element is None:
            element = etree_.Element('{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        else:
            element = etree_.SubElement(parent_element, '{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        if mapping_ is not None:
            mapping_[self] = element
        return element
    def exportLiteral(self, outfile, level, name_='ObjectReferenceType'):
        level += 1
        already_processed = set()
        self.exportLiteralAttributes(outfile, level, already_processed, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, already_processed, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        pass
    def build(self, node):
        already_processed = set()
        self.buildAttributes(node, node.attrib, already_processed)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
        return self
    def buildAttributes(self, node, attrs, already_processed):
        pass
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        pass
# end class ObjectReferenceType


class OpaqueType(GeneratedsSuper):
    member_data_items_ = {
        'Tag': MemberSpec_('Tag', 'xs:string', 0),
        'Size': MemberSpec_('Size', 'xs:string', 0),
    }
    subclass = None
    superclass = None
    def __init__(self, Tag=None, Size=None):
        self.original_tagname_ = None
        self.Tag = _cast(None, Tag)
        self.Size = _cast(None, Size)
    def factory(*args_, **kwargs_):
        if OpaqueType.subclass:
            return OpaqueType.subclass(*args_, **kwargs_)
        else:
            return OpaqueType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_Tag(self): return self.Tag
    def set_Tag(self, Tag): self.Tag = Tag
    def get_Size(self): return self.Size
    def set_Size(self, Size): self.Size = Size
    def hasContent_(self):
        if (

        ):
            return True
        else:
            return False
    def export(self, outfile, level, namespace_='hdf5:', name_='OpaqueType', namespacedef_='xmlns:hdf5="http://hdfgroup.org/HDF5/XML/schema/HDF5-File"', pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.original_tagname_ is not None:
            name_ = self.original_tagname_
        showIndent(outfile, level, pretty_print)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = set()
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='OpaqueType')
        if self.hasContent_():
            outfile.write('>%s' % (eol_, ))
            self.exportChildren(outfile, level + 1, namespace_='hdf5:', name_='OpaqueType', pretty_print=pretty_print)
            outfile.write('</%s%s>%s' % (namespace_, name_, eol_))
        else:
            outfile.write('/>%s' % (eol_, ))
    def exportAttributes(self, outfile, level, already_processed, namespace_='hdf5:', name_='OpaqueType'):
        if self.Tag is not None and 'Tag' not in already_processed:
            already_processed.add('Tag')
            outfile.write(' Tag=%s' % (self.gds_format_string(quote_attrib(self.Tag).encode(ExternalEncoding), input_name='Tag'), ))
        if self.Size is not None and 'Size' not in already_processed:
            already_processed.add('Size')
            outfile.write(' Size=%s' % (self.gds_format_string(quote_attrib(self.Size).encode(ExternalEncoding), input_name='Size'), ))
    def exportChildren(self, outfile, level, namespace_='hdf5:', name_='OpaqueType', fromsubclass_=False, pretty_print=True):
        pass
    def to_etree(self, parent_element=None, name_='OpaqueType', mapping_=None):
        if parent_element is None:
            element = etree_.Element('{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        else:
            element = etree_.SubElement(parent_element, '{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        if self.Tag is not None:
            element.set('Tag', self.gds_format_string(self.Tag))
        if self.Size is not None:
            element.set('Size', self.gds_format_string(self.Size))
        if mapping_ is not None:
            mapping_[self] = element
        return element
    def exportLiteral(self, outfile, level, name_='OpaqueType'):
        level += 1
        already_processed = set()
        self.exportLiteralAttributes(outfile, level, already_processed, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, already_processed, name_):
        if self.Tag is not None and 'Tag' not in already_processed:
            already_processed.add('Tag')
            showIndent(outfile, level)
            outfile.write('Tag="%s",\n' % (self.Tag,))
        if self.Size is not None and 'Size' not in already_processed:
            already_processed.add('Size')
            showIndent(outfile, level)
            outfile.write('Size="%s",\n' % (self.Size,))
    def exportLiteralChildren(self, outfile, level, name_):
        pass
    def build(self, node):
        already_processed = set()
        self.buildAttributes(node, node.attrib, already_processed)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
        return self
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('Tag', node)
        if value is not None and 'Tag' not in already_processed:
            already_processed.add('Tag')
            self.Tag = value
        value = find_attr_value_('Size', node)
        if value is not None and 'Size' not in already_processed:
            already_processed.add('Size')
            self.Size = value
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        pass
# end class OpaqueType


class ReferenceType(GeneratedsSuper):
    member_data_items_ = {
        'ObjectReferenceType': MemberSpec_('ObjectReferenceType', 'ObjectReferenceType', 0),
        'RegionReferenceType': MemberSpec_('RegionReferenceType', 'RegionReferenceType', 0),
    }
    subclass = None
    superclass = None
    def __init__(self, ObjectReferenceType=None, RegionReferenceType=None):
        self.original_tagname_ = None
        self.ObjectReferenceType = ObjectReferenceType
        self.RegionReferenceType = RegionReferenceType
    def factory(*args_, **kwargs_):
        if ReferenceType.subclass:
            return ReferenceType.subclass(*args_, **kwargs_)
        else:
            return ReferenceType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_ObjectReferenceType(self): return self.ObjectReferenceType
    def set_ObjectReferenceType(self, ObjectReferenceType): self.ObjectReferenceType = ObjectReferenceType
    def get_RegionReferenceType(self): return self.RegionReferenceType
    def set_RegionReferenceType(self, RegionReferenceType): self.RegionReferenceType = RegionReferenceType
    def hasContent_(self):
        if (
            self.ObjectReferenceType is not None or
            self.RegionReferenceType is not None
        ):
            return True
        else:
            return False
    def export(self, outfile, level, namespace_='hdf5:', name_='ReferenceType', namespacedef_='xmlns:hdf5="http://hdfgroup.org/HDF5/XML/schema/HDF5-File"', pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.original_tagname_ is not None:
            name_ = self.original_tagname_
        showIndent(outfile, level, pretty_print)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = set()
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='ReferenceType')
        if self.hasContent_():
            outfile.write('>%s' % (eol_, ))
            self.exportChildren(outfile, level + 1, namespace_='hdf5:', name_='ReferenceType', pretty_print=pretty_print)
            showIndent(outfile, level, pretty_print)
            outfile.write('</%s%s>%s' % (namespace_, name_, eol_))
        else:
            outfile.write('/>%s' % (eol_, ))
    def exportAttributes(self, outfile, level, already_processed, namespace_='hdf5:', name_='ReferenceType'):
        pass
    def exportChildren(self, outfile, level, namespace_='hdf5:', name_='ReferenceType', fromsubclass_=False, pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.ObjectReferenceType is not None:
            self.ObjectReferenceType.export(outfile, level, namespace_='hdf5:', name_='ObjectReferenceType', pretty_print=pretty_print)
        if self.RegionReferenceType is not None:
            self.RegionReferenceType.export(outfile, level, namespace_='hdf5:', name_='RegionReferenceType', pretty_print=pretty_print)
    def to_etree(self, parent_element=None, name_='ReferenceType', mapping_=None):
        if parent_element is None:
            element = etree_.Element('{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        else:
            element = etree_.SubElement(parent_element, '{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        if self.ObjectReferenceType is not None:
            ObjectReferenceType_ = self.ObjectReferenceType
            ObjectReferenceType_.to_etree(element, name_='ObjectReferenceType', mapping_=mapping_)
        if self.RegionReferenceType is not None:
            RegionReferenceType_ = self.RegionReferenceType
            RegionReferenceType_.to_etree(element, name_='RegionReferenceType', mapping_=mapping_)
        if mapping_ is not None:
            mapping_[self] = element
        return element
    def exportLiteral(self, outfile, level, name_='ReferenceType'):
        level += 1
        already_processed = set()
        self.exportLiteralAttributes(outfile, level, already_processed, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, already_processed, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        if self.ObjectReferenceType is not None:
            showIndent(outfile, level)
            outfile.write('ObjectReferenceType=model_.ObjectReferenceType(\n')
            self.ObjectReferenceType.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.RegionReferenceType is not None:
            showIndent(outfile, level)
            outfile.write('RegionReferenceType=model_.RegionReferenceType(\n')
            self.RegionReferenceType.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
    def build(self, node):
        already_processed = set()
        self.buildAttributes(node, node.attrib, already_processed)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
        return self
    def buildAttributes(self, node, attrs, already_processed):
        pass
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'ObjectReferenceType':
            obj_ = ObjectReferenceType.factory()
            obj_.build(child_)
            self.ObjectReferenceType = obj_
            obj_.original_tagname_ = 'ObjectReferenceType'
        elif nodeName_ == 'RegionReferenceType':
            obj_ = RegionReferenceType.factory()
            obj_.build(child_)
            self.RegionReferenceType = obj_
            obj_.original_tagname_ = 'RegionReferenceType'
# end class ReferenceType


class RegionReferenceType(GeneratedsSuper):
    """This element is not specified yet in this schema."""
    member_data_items_ = {
    }
    subclass = None
    superclass = None
    def __init__(self):
        self.original_tagname_ = None
    def factory(*args_, **kwargs_):
        if RegionReferenceType.subclass:
            return RegionReferenceType.subclass(*args_, **kwargs_)
        else:
            return RegionReferenceType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def hasContent_(self):
        if (

        ):
            return True
        else:
            return False
    def export(self, outfile, level, namespace_='hdf5:', name_='RegionReferenceType', namespacedef_='xmlns:hdf5="http://hdfgroup.org/HDF5/XML/schema/HDF5-File"', pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.original_tagname_ is not None:
            name_ = self.original_tagname_
        showIndent(outfile, level, pretty_print)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = set()
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='RegionReferenceType')
        if self.hasContent_():
            outfile.write('>%s' % (eol_, ))
            self.exportChildren(outfile, level + 1, namespace_='hdf5:', name_='RegionReferenceType', pretty_print=pretty_print)
            outfile.write('</%s%s>%s' % (namespace_, name_, eol_))
        else:
            outfile.write('/>%s' % (eol_, ))
    def exportAttributes(self, outfile, level, already_processed, namespace_='hdf5:', name_='RegionReferenceType'):
        pass
    def exportChildren(self, outfile, level, namespace_='hdf5:', name_='RegionReferenceType', fromsubclass_=False, pretty_print=True):
        pass
    def to_etree(self, parent_element=None, name_='RegionReferenceType', mapping_=None):
        if parent_element is None:
            element = etree_.Element('{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        else:
            element = etree_.SubElement(parent_element, '{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        if mapping_ is not None:
            mapping_[self] = element
        return element
    def exportLiteral(self, outfile, level, name_='RegionReferenceType'):
        level += 1
        already_processed = set()
        self.exportLiteralAttributes(outfile, level, already_processed, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, already_processed, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        pass
    def build(self, node):
        already_processed = set()
        self.buildAttributes(node, node.attrib, already_processed)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
        return self
    def buildAttributes(self, node, attrs, already_processed):
        pass
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        pass
# end class RegionReferenceType


class RootGroup(GeneratedsSuper):
    member_data_items_ = {
        'OBJ-XID': MemberSpec_('OBJ-XID', 'xs:string', 0),
        'Name': MemberSpec_('Name', 'xs:string', 0),
        'H5Path': MemberSpec_('H5Path', 'xs:string', 0),
        'Attribute': MemberSpec_('Attribute', 'Attribute', 1),
        'Group': MemberSpec_('Group', 'Group', 1),
        'Dataset': MemberSpec_('Dataset', 'Dataset', 1),
        'NamedDataType': MemberSpec_('NamedDataType', 'NamedDataType', 1),
        'SoftLink': MemberSpec_('SoftLink', 'SoftLink', 1),
    }
    subclass = None
    superclass = None
    def __init__(self, OBJ_XID=None, Name=None, H5Path=None, Attribute=None, Group=None, Dataset=None, NamedDataType=None, SoftLink=None):
        self.original_tagname_ = None
        self.OBJ_XID = _cast(None, OBJ_XID)
        self.Name = _cast(None, Name)
        self.H5Path = _cast(None, H5Path)
        if Attribute is None:
            self.Attribute = []
        else:
            self.Attribute = Attribute
        if Group is None:
            self.Group = []
        else:
            self.Group = Group
        if Dataset is None:
            self.Dataset = []
        else:
            self.Dataset = Dataset
        if NamedDataType is None:
            self.NamedDataType = []
        else:
            self.NamedDataType = NamedDataType
        if SoftLink is None:
            self.SoftLink = []
        else:
            self.SoftLink = SoftLink
    def factory(*args_, **kwargs_):
        if RootGroup.subclass:
            return RootGroup.subclass(*args_, **kwargs_)
        else:
            return RootGroup(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_Attribute(self): return self.Attribute
    def set_Attribute(self, Attribute): self.Attribute = Attribute
    def add_Attribute(self, value): self.Attribute.append(value)
    def insert_Attribute(self, index, value): self.Attribute[index] = value
    def get_Group(self): return self.Group
    def set_Group(self, Group): self.Group = Group
    def add_Group(self, value): self.Group.append(value)
    def insert_Group(self, index, value): self.Group[index] = value
    def get_Dataset(self): return self.Dataset
    def set_Dataset(self, Dataset): self.Dataset = Dataset
    def add_Dataset(self, value): self.Dataset.append(value)
    def insert_Dataset(self, index, value): self.Dataset[index] = value
    def get_NamedDataType(self): return self.NamedDataType
    def set_NamedDataType(self, NamedDataType): self.NamedDataType = NamedDataType
    def add_NamedDataType(self, value): self.NamedDataType.append(value)
    def insert_NamedDataType(self, index, value): self.NamedDataType[index] = value
    def get_SoftLink(self): return self.SoftLink
    def set_SoftLink(self, SoftLink): self.SoftLink = SoftLink
    def add_SoftLink(self, value): self.SoftLink.append(value)
    def insert_SoftLink(self, index, value): self.SoftLink[index] = value
    def get_OBJ_XID(self): return self.OBJ_XID
    def set_OBJ_XID(self, OBJ_XID): self.OBJ_XID = OBJ_XID
    def get_Name(self): return self.Name
    def set_Name(self, Name): self.Name = Name
    def get_H5Path(self): return self.H5Path
    def set_H5Path(self, H5Path): self.H5Path = H5Path
    def hasContent_(self):
        if (
            self.Attribute or
            self.Group or
            self.Dataset or
            self.NamedDataType or
            self.SoftLink
        ):
            return True
        else:
            return False
    def export(self, outfile, level, namespace_='hdf5:', name_='RootGroup', namespacedef_='xmlns:hdf5="http://hdfgroup.org/HDF5/XML/schema/HDF5-File"', pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.original_tagname_ is not None:
            name_ = self.original_tagname_
        showIndent(outfile, level, pretty_print)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = set()
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='RootGroup')
        if self.hasContent_():
            outfile.write('>%s' % (eol_, ))
            self.exportChildren(outfile, level + 1, namespace_='hdf5:', name_='RootGroup', pretty_print=pretty_print)
            showIndent(outfile, level, pretty_print)
            outfile.write('</%s%s>%s' % (namespace_, name_, eol_))
        else:
            outfile.write('/>%s' % (eol_, ))
    def exportAttributes(self, outfile, level, already_processed, namespace_='hdf5:', name_='RootGroup'):
        if self.OBJ_XID is not None and 'OBJ_XID' not in already_processed:
            already_processed.add('OBJ_XID')
            outfile.write(' OBJ-XID=%s' % (self.gds_format_string(quote_attrib(self.OBJ_XID).encode(ExternalEncoding), input_name='OBJ-XID'), ))
        if self.Name is not None and 'Name' not in already_processed:
            already_processed.add('Name')
            outfile.write(' Name=%s' % (self.gds_format_string(quote_attrib(self.Name).encode(ExternalEncoding), input_name='Name'), ))
        if self.H5Path is not None and 'H5Path' not in already_processed:
            already_processed.add('H5Path')
            outfile.write(' H5Path=%s' % (self.gds_format_string(quote_attrib(self.H5Path).encode(ExternalEncoding), input_name='H5Path'), ))
    def exportChildren(self, outfile, level, namespace_='hdf5:', name_='RootGroup', fromsubclass_=False, pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        for Attribute_ in self.Attribute:
            Attribute_.export(outfile, level, namespace_='hdf5:', name_='Attribute', pretty_print=pretty_print)
        for Group_ in self.Group:
            Group_.export(outfile, level, namespace_='hdf5:', name_='Group', pretty_print=pretty_print)
        for Dataset_ in self.Dataset:
            Dataset_.export(outfile, level, namespace_='hdf5:', name_='Dataset', pretty_print=pretty_print)
        for NamedDataType_ in self.NamedDataType:
            NamedDataType_.export(outfile, level, namespace_='hdf5:', name_='NamedDataType', pretty_print=pretty_print)
        for SoftLink_ in self.SoftLink:
            SoftLink_.export(outfile, level, namespace_='hdf5:', name_='SoftLink', pretty_print=pretty_print)
    def to_etree(self, parent_element=None, name_='RootGroup', mapping_=None):
        if parent_element is None:
            element = etree_.Element('{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        else:
            element = etree_.SubElement(parent_element, '{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        if self.OBJ_XID is not None:
            element.set('OBJ-XID', self.gds_format_string(self.OBJ_XID))
        if self.Name is not None:
            element.set('Name', self.gds_format_string(self.Name))
        if self.H5Path is not None:
            element.set('H5Path', self.gds_format_string(self.H5Path))
        for Attribute_ in self.Attribute:
            Attribute_.to_etree(element, name_='Attribute', mapping_=mapping_)
        for Group_ in self.Group:
            Group_.to_etree(element, name_='Group', mapping_=mapping_)
        for Dataset_ in self.Dataset:
            Dataset_.to_etree(element, name_='Dataset', mapping_=mapping_)
        for NamedDataType_ in self.NamedDataType:
            NamedDataType_.to_etree(element, name_='NamedDataType', mapping_=mapping_)
        for SoftLink_ in self.SoftLink:
            SoftLink_.to_etree(element, name_='SoftLink', mapping_=mapping_)
        if mapping_ is not None:
            mapping_[self] = element
        return element
    def exportLiteral(self, outfile, level, name_='RootGroup'):
        level += 1
        already_processed = set()
        self.exportLiteralAttributes(outfile, level, already_processed, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, already_processed, name_):
        if self.OBJ_XID is not None and 'OBJ_XID' not in already_processed:
            already_processed.add('OBJ_XID')
            showIndent(outfile, level)
            outfile.write('OBJ_XID="%s",\n' % (self.OBJ_XID,))
        if self.Name is not None and 'Name' not in already_processed:
            already_processed.add('Name')
            showIndent(outfile, level)
            outfile.write('Name="%s",\n' % (self.Name,))
        if self.H5Path is not None and 'H5Path' not in already_processed:
            already_processed.add('H5Path')
            showIndent(outfile, level)
            outfile.write('H5Path="%s",\n' % (self.H5Path,))
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('Attribute=[\n')
        level += 1
        for Attribute_ in self.Attribute:
            showIndent(outfile, level)
            outfile.write('model_.Attribute(\n')
            Attribute_.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
        showIndent(outfile, level)
        outfile.write('Group=[\n')
        level += 1
        for Group_ in self.Group:
            showIndent(outfile, level)
            outfile.write('model_.Group(\n')
            Group_.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
        showIndent(outfile, level)
        outfile.write('Dataset=[\n')
        level += 1
        for Dataset_ in self.Dataset:
            showIndent(outfile, level)
            outfile.write('model_.Dataset(\n')
            Dataset_.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
        showIndent(outfile, level)
        outfile.write('NamedDataType=[\n')
        level += 1
        for NamedDataType_ in self.NamedDataType:
            showIndent(outfile, level)
            outfile.write('model_.NamedDataType(\n')
            NamedDataType_.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
        showIndent(outfile, level)
        outfile.write('SoftLink=[\n')
        level += 1
        for SoftLink_ in self.SoftLink:
            showIndent(outfile, level)
            outfile.write('model_.SoftLink(\n')
            SoftLink_.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
    def build(self, node):
        already_processed = set()
        self.buildAttributes(node, node.attrib, already_processed)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
        return self
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('OBJ-XID', node)
        if value is not None and 'OBJ-XID' not in already_processed:
            already_processed.add('OBJ-XID')
            self.OBJ_XID = value
        value = find_attr_value_('Name', node)
        if value is not None and 'Name' not in already_processed:
            already_processed.add('Name')
            self.Name = value
        value = find_attr_value_('H5Path', node)
        if value is not None and 'H5Path' not in already_processed:
            already_processed.add('H5Path')
            self.H5Path = value
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'Attribute':
            obj_ = Attribute.factory()
            obj_.build(child_)
            self.Attribute.append(obj_)
            obj_.original_tagname_ = 'Attribute'
        elif nodeName_ == 'Group':
            obj_ = Group.factory()
            obj_.build(child_)
            self.Group.append(obj_)
            obj_.original_tagname_ = 'Group'
        elif nodeName_ == 'Dataset':
            obj_ = Dataset.factory()
            obj_.build(child_)
            self.Dataset.append(obj_)
            obj_.original_tagname_ = 'Dataset'
        elif nodeName_ == 'NamedDataType':
            obj_ = NamedDataType.factory()
            obj_.build(child_)
            self.NamedDataType.append(obj_)
            obj_.original_tagname_ = 'NamedDataType'
        elif nodeName_ == 'SoftLink':
            obj_ = SoftLink.factory()
            obj_.build(child_)
            self.SoftLink.append(obj_)
            obj_.original_tagname_ = 'SoftLink'
# end class RootGroup


class ScalarDataspace(GeneratedsSuper):
    member_data_items_ = {
    }
    subclass = None
    superclass = None
    def __init__(self):
        self.original_tagname_ = None
    def factory(*args_, **kwargs_):
        if ScalarDataspace.subclass:
            return ScalarDataspace.subclass(*args_, **kwargs_)
        else:
            return ScalarDataspace(*args_, **kwargs_)
    factory = staticmethod(factory)
    def hasContent_(self):
        if (

        ):
            return True
        else:
            return False
    def export(self, outfile, level, namespace_='hdf5:', name_='ScalarDataspace', namespacedef_='xmlns:hdf5="http://hdfgroup.org/HDF5/XML/schema/HDF5-File"', pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.original_tagname_ is not None:
            name_ = self.original_tagname_
        showIndent(outfile, level, pretty_print)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = set()
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='ScalarDataspace')
        if self.hasContent_():
            outfile.write('>%s' % (eol_, ))
            self.exportChildren(outfile, level + 1, namespace_='hdf5:', name_='ScalarDataspace', pretty_print=pretty_print)
            outfile.write('</%s%s>%s' % (namespace_, name_, eol_))
        else:
            outfile.write('/>%s' % (eol_, ))
    def exportAttributes(self, outfile, level, already_processed, namespace_='hdf5:', name_='ScalarDataspace'):
        pass
    def exportChildren(self, outfile, level, namespace_='hdf5:', name_='ScalarDataspace', fromsubclass_=False, pretty_print=True):
        pass
    def to_etree(self, parent_element=None, name_='ScalarDataspace', mapping_=None):
        if parent_element is None:
            element = etree_.Element('{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        else:
            element = etree_.SubElement(parent_element, '{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        if mapping_ is not None:
            mapping_[self] = element
        return element
    def exportLiteral(self, outfile, level, name_='ScalarDataspace'):
        level += 1
        already_processed = set()
        self.exportLiteralAttributes(outfile, level, already_processed, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, already_processed, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        pass
    def build(self, node):
        already_processed = set()
        self.buildAttributes(node, node.attrib, already_processed)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
        return self
    def buildAttributes(self, node, attrs, already_processed):
        pass
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        pass
# end class ScalarDataspace


class SimpleDataspace(GeneratedsSuper):
    member_data_items_ = {
        'Ndims': MemberSpec_('Ndims', 'xs:positiveInteger', 0),
        'Dimension': MemberSpec_('Dimension', 'Dimension', 1),
    }
    subclass = None
    superclass = None
    def __init__(self, Ndims=None, Dimension=None):
        self.original_tagname_ = None
        self.Ndims = _cast(int, Ndims)
        if Dimension is None:
            self.Dimension = []
        else:
            self.Dimension = Dimension
    def factory(*args_, **kwargs_):
        if SimpleDataspace.subclass:
            return SimpleDataspace.subclass(*args_, **kwargs_)
        else:
            return SimpleDataspace(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_Dimension(self): return self.Dimension
    def set_Dimension(self, Dimension): self.Dimension = Dimension
    def add_Dimension(self, value): self.Dimension.append(value)
    def insert_Dimension(self, index, value): self.Dimension[index] = value
    def get_Ndims(self): return self.Ndims
    def set_Ndims(self, Ndims): self.Ndims = Ndims
    def hasContent_(self):
        if (
            self.Dimension
        ):
            return True
        else:
            return False
    def export(self, outfile, level, namespace_='hdf5:', name_='SimpleDataspace', namespacedef_='xmlns:hdf5="http://hdfgroup.org/HDF5/XML/schema/HDF5-File"', pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.original_tagname_ is not None:
            name_ = self.original_tagname_
        showIndent(outfile, level, pretty_print)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = set()
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='SimpleDataspace')
        if self.hasContent_():
            outfile.write('>%s' % (eol_, ))
            self.exportChildren(outfile, level + 1, namespace_='hdf5:', name_='SimpleDataspace', pretty_print=pretty_print)
            showIndent(outfile, level, pretty_print)
            outfile.write('</%s%s>%s' % (namespace_, name_, eol_))
        else:
            outfile.write('/>%s' % (eol_, ))
    def exportAttributes(self, outfile, level, already_processed, namespace_='hdf5:', name_='SimpleDataspace'):
        if self.Ndims is not None and 'Ndims' not in already_processed:
            already_processed.add('Ndims')
            outfile.write(' Ndims="%s"' % self.gds_format_integer(self.Ndims, input_name='Ndims'))
    def exportChildren(self, outfile, level, namespace_='hdf5:', name_='SimpleDataspace', fromsubclass_=False, pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        for Dimension_ in self.Dimension:
            Dimension_.export(outfile, level, namespace_='hdf5:', name_='Dimension', pretty_print=pretty_print)
    def to_etree(self, parent_element=None, name_='SimpleDataspace', mapping_=None):
        if parent_element is None:
            element = etree_.Element('{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        else:
            element = etree_.SubElement(parent_element, '{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        if self.Ndims is not None:
            element.set('Ndims', self.gds_format_integer(self.Ndims))
        for Dimension_ in self.Dimension:
            Dimension_.to_etree(element, name_='Dimension', mapping_=mapping_)
        if mapping_ is not None:
            mapping_[self] = element
        return element
    def exportLiteral(self, outfile, level, name_='SimpleDataspace'):
        level += 1
        already_processed = set()
        self.exportLiteralAttributes(outfile, level, already_processed, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, already_processed, name_):
        if self.Ndims is not None and 'Ndims' not in already_processed:
            already_processed.add('Ndims')
            showIndent(outfile, level)
            outfile.write('Ndims=%d,\n' % (self.Ndims,))
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('Dimension=[\n')
        level += 1
        for Dimension_ in self.Dimension:
            showIndent(outfile, level)
            outfile.write('model_.Dimension(\n')
            Dimension_.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
    def build(self, node):
        already_processed = set()
        self.buildAttributes(node, node.attrib, already_processed)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
        return self
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('Ndims', node)
        if value is not None and 'Ndims' not in already_processed:
            already_processed.add('Ndims')
            try:
                self.Ndims = int(value)
            except ValueError, exp:
                raise_parse_error(node, 'Bad integer attribute: %s' % exp)
            if self.Ndims <= 0:
                raise_parse_error(node, 'Invalid PositiveInteger')
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'Dimension':
            obj_ = Dimension.factory()
            obj_.build(child_)
            self.Dimension.append(obj_)
            obj_.original_tagname_ = 'Dimension'
# end class SimpleDataspace


class SoftLink(GeneratedsSuper):
    member_data_items_ = {
        'H5SourcePath': MemberSpec_('H5SourcePath', 'xs:string', 0),
        'OBJ-XID': MemberSpec_('OBJ-XID', 'xs:string', 0),
        'TargetObj': MemberSpec_('TargetObj', 'xs:string', 0),
        'Parents': MemberSpec_('Parents', 'xs:string', 0),
        'LinkName': MemberSpec_('LinkName', 'xs:string', 0),
        'TargetPath': MemberSpec_('TargetPath', 'xs:string', 0),
        'H5ParentPaths': MemberSpec_('H5ParentPaths', 'xs:string', 0),
    }
    subclass = None
    superclass = None
    def __init__(self, H5SourcePath=None, OBJ_XID=None, TargetObj=None, Parents=None, LinkName=None, TargetPath=None, H5ParentPaths=None):
        self.original_tagname_ = None
        self.H5SourcePath = _cast(None, H5SourcePath)
        self.OBJ_XID = _cast(None, OBJ_XID)
        self.TargetObj = _cast(None, TargetObj)
        self.Parents = _cast(None, Parents)
        self.LinkName = _cast(None, LinkName)
        self.TargetPath = _cast(None, TargetPath)
        self.H5ParentPaths = _cast(None, H5ParentPaths)
    def factory(*args_, **kwargs_):
        if SoftLink.subclass:
            return SoftLink.subclass(*args_, **kwargs_)
        else:
            return SoftLink(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_H5SourcePath(self): return self.H5SourcePath
    def set_H5SourcePath(self, H5SourcePath): self.H5SourcePath = H5SourcePath
    def get_OBJ_XID(self): return self.OBJ_XID
    def set_OBJ_XID(self, OBJ_XID): self.OBJ_XID = OBJ_XID
    def get_TargetObj(self): return self.TargetObj
    def set_TargetObj(self, TargetObj): self.TargetObj = TargetObj
    def get_Parents(self): return self.Parents
    def set_Parents(self, Parents): self.Parents = Parents
    def get_LinkName(self): return self.LinkName
    def set_LinkName(self, LinkName): self.LinkName = LinkName
    def get_TargetPath(self): return self.TargetPath
    def set_TargetPath(self, TargetPath): self.TargetPath = TargetPath
    def get_H5ParentPaths(self): return self.H5ParentPaths
    def set_H5ParentPaths(self, H5ParentPaths): self.H5ParentPaths = H5ParentPaths
    def hasContent_(self):
        if (

        ):
            return True
        else:
            return False
    def export(self, outfile, level, namespace_='hdf5:', name_='SoftLink', namespacedef_='xmlns:hdf5="http://hdfgroup.org/HDF5/XML/schema/HDF5-File"', pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.original_tagname_ is not None:
            name_ = self.original_tagname_
        showIndent(outfile, level, pretty_print)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = set()
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='SoftLink')
        if self.hasContent_():
            outfile.write('>%s' % (eol_, ))
            self.exportChildren(outfile, level + 1, namespace_='hdf5:', name_='SoftLink', pretty_print=pretty_print)
            outfile.write('</%s%s>%s' % (namespace_, name_, eol_))
        else:
            outfile.write('/>%s' % (eol_, ))
    def exportAttributes(self, outfile, level, already_processed, namespace_='hdf5:', name_='SoftLink'):
        if self.H5SourcePath is not None and 'H5SourcePath' not in already_processed:
            already_processed.add('H5SourcePath')
            outfile.write(' H5SourcePath=%s' % (self.gds_format_string(quote_attrib(self.H5SourcePath).encode(ExternalEncoding), input_name='H5SourcePath'), ))
        if self.OBJ_XID is not None and 'OBJ_XID' not in already_processed:
            already_processed.add('OBJ_XID')
            outfile.write(' OBJ-XID=%s' % (self.gds_format_string(quote_attrib(self.OBJ_XID).encode(ExternalEncoding), input_name='OBJ-XID'), ))
        if self.TargetObj is not None and 'TargetObj' not in already_processed:
            already_processed.add('TargetObj')
            outfile.write(' TargetObj=%s' % (self.gds_format_string(quote_attrib(self.TargetObj).encode(ExternalEncoding), input_name='TargetObj'), ))
        if self.Parents is not None and 'Parents' not in already_processed:
            already_processed.add('Parents')
            outfile.write(' Parents=%s' % (self.gds_format_string(quote_attrib(self.Parents).encode(ExternalEncoding), input_name='Parents'), ))
        if self.LinkName is not None and 'LinkName' not in already_processed:
            already_processed.add('LinkName')
            outfile.write(' LinkName=%s' % (self.gds_format_string(quote_attrib(self.LinkName).encode(ExternalEncoding), input_name='LinkName'), ))
        if self.TargetPath is not None and 'TargetPath' not in already_processed:
            already_processed.add('TargetPath')
            outfile.write(' TargetPath=%s' % (self.gds_format_string(quote_attrib(self.TargetPath).encode(ExternalEncoding), input_name='TargetPath'), ))
        if self.H5ParentPaths is not None and 'H5ParentPaths' not in already_processed:
            already_processed.add('H5ParentPaths')
            outfile.write(' H5ParentPaths=%s' % (self.gds_format_string(quote_attrib(self.H5ParentPaths).encode(ExternalEncoding), input_name='H5ParentPaths'), ))
    def exportChildren(self, outfile, level, namespace_='hdf5:', name_='SoftLink', fromsubclass_=False, pretty_print=True):
        pass
    def to_etree(self, parent_element=None, name_='SoftLink', mapping_=None):
        if parent_element is None:
            element = etree_.Element('{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        else:
            element = etree_.SubElement(parent_element, '{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        if self.H5SourcePath is not None:
            element.set('H5SourcePath', self.gds_format_string(self.H5SourcePath))
        if self.OBJ_XID is not None:
            element.set('OBJ-XID', self.gds_format_string(self.OBJ_XID))
        if self.TargetObj is not None:
            element.set('TargetObj', self.gds_format_string(self.TargetObj))
        if self.Parents is not None:
            element.set('Parents', self.gds_format_string(self.Parents))
        if self.LinkName is not None:
            element.set('LinkName', self.gds_format_string(self.LinkName))
        if self.TargetPath is not None:
            element.set('TargetPath', self.gds_format_string(self.TargetPath))
        if self.H5ParentPaths is not None:
            element.set('H5ParentPaths', self.gds_format_string(self.H5ParentPaths))
        if mapping_ is not None:
            mapping_[self] = element
        return element
    def exportLiteral(self, outfile, level, name_='SoftLink'):
        level += 1
        already_processed = set()
        self.exportLiteralAttributes(outfile, level, already_processed, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, already_processed, name_):
        if self.H5SourcePath is not None and 'H5SourcePath' not in already_processed:
            already_processed.add('H5SourcePath')
            showIndent(outfile, level)
            outfile.write('H5SourcePath="%s",\n' % (self.H5SourcePath,))
        if self.OBJ_XID is not None and 'OBJ_XID' not in already_processed:
            already_processed.add('OBJ_XID')
            showIndent(outfile, level)
            outfile.write('OBJ_XID="%s",\n' % (self.OBJ_XID,))
        if self.TargetObj is not None and 'TargetObj' not in already_processed:
            already_processed.add('TargetObj')
            showIndent(outfile, level)
            outfile.write('TargetObj="%s",\n' % (self.TargetObj,))
        if self.Parents is not None and 'Parents' not in already_processed:
            already_processed.add('Parents')
            showIndent(outfile, level)
            outfile.write('Parents="%s",\n' % (self.Parents,))
        if self.LinkName is not None and 'LinkName' not in already_processed:
            already_processed.add('LinkName')
            showIndent(outfile, level)
            outfile.write('LinkName="%s",\n' % (self.LinkName,))
        if self.TargetPath is not None and 'TargetPath' not in already_processed:
            already_processed.add('TargetPath')
            showIndent(outfile, level)
            outfile.write('TargetPath="%s",\n' % (self.TargetPath,))
        if self.H5ParentPaths is not None and 'H5ParentPaths' not in already_processed:
            already_processed.add('H5ParentPaths')
            showIndent(outfile, level)
            outfile.write('H5ParentPaths="%s",\n' % (self.H5ParentPaths,))
    def exportLiteralChildren(self, outfile, level, name_):
        pass
    def build(self, node):
        already_processed = set()
        self.buildAttributes(node, node.attrib, already_processed)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
        return self
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('H5SourcePath', node)
        if value is not None and 'H5SourcePath' not in already_processed:
            already_processed.add('H5SourcePath')
            self.H5SourcePath = value
        value = find_attr_value_('OBJ-XID', node)
        if value is not None and 'OBJ-XID' not in already_processed:
            already_processed.add('OBJ-XID')
            self.OBJ_XID = value
        value = find_attr_value_('TargetObj', node)
        if value is not None and 'TargetObj' not in already_processed:
            already_processed.add('TargetObj')
            self.TargetObj = value
        value = find_attr_value_('Parents', node)
        if value is not None and 'Parents' not in already_processed:
            already_processed.add('Parents')
            self.Parents = value
        value = find_attr_value_('LinkName', node)
        if value is not None and 'LinkName' not in already_processed:
            already_processed.add('LinkName')
            self.LinkName = value
        value = find_attr_value_('TargetPath', node)
        if value is not None and 'TargetPath' not in already_processed:
            already_processed.add('TargetPath')
            self.TargetPath = value
        value = find_attr_value_('H5ParentPaths', node)
        if value is not None and 'H5ParentPaths' not in already_processed:
            already_processed.add('H5ParentPaths')
            self.H5ParentPaths = value
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        pass
# end class SoftLink


class StorageLayout(GeneratedsSuper):
    member_data_items_ = {
        'ContiguousLayout': MemberSpec_('ContiguousLayout', 'ContiguousLayout', 0),
        'ChunkedLayout': MemberSpec_('ChunkedLayout', 'ChunkedLayout', 0),
        'CompactLayout': MemberSpec_('CompactLayout', 'CompactLayout', 0),
        'ExternalLayout': MemberSpec_('ExternalLayout', 'ExternalLayout', 0),
    }
    subclass = None
    superclass = None
    def __init__(self, ContiguousLayout=None, ChunkedLayout=None, CompactLayout=None, ExternalLayout=None):
        self.original_tagname_ = None
        self.ContiguousLayout = ContiguousLayout
        self.ChunkedLayout = ChunkedLayout
        self.CompactLayout = CompactLayout
        self.ExternalLayout = ExternalLayout
    def factory(*args_, **kwargs_):
        if StorageLayout.subclass:
            return StorageLayout.subclass(*args_, **kwargs_)
        else:
            return StorageLayout(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_ContiguousLayout(self): return self.ContiguousLayout
    def set_ContiguousLayout(self, ContiguousLayout): self.ContiguousLayout = ContiguousLayout
    def get_ChunkedLayout(self): return self.ChunkedLayout
    def set_ChunkedLayout(self, ChunkedLayout): self.ChunkedLayout = ChunkedLayout
    def get_CompactLayout(self): return self.CompactLayout
    def set_CompactLayout(self, CompactLayout): self.CompactLayout = CompactLayout
    def get_ExternalLayout(self): return self.ExternalLayout
    def set_ExternalLayout(self, ExternalLayout): self.ExternalLayout = ExternalLayout
    def hasContent_(self):
        if (
            self.ContiguousLayout is not None or
            self.ChunkedLayout is not None or
            self.CompactLayout is not None or
            self.ExternalLayout is not None
        ):
            return True
        else:
            return False
    def export(self, outfile, level, namespace_='hdf5:', name_='StorageLayout', namespacedef_='xmlns:hdf5="http://hdfgroup.org/HDF5/XML/schema/HDF5-File"', pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.original_tagname_ is not None:
            name_ = self.original_tagname_
        showIndent(outfile, level, pretty_print)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = set()
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='StorageLayout')
        if self.hasContent_():
            outfile.write('>%s' % (eol_, ))
            self.exportChildren(outfile, level + 1, namespace_='hdf5:', name_='StorageLayout', pretty_print=pretty_print)
            showIndent(outfile, level, pretty_print)
            outfile.write('</%s%s>%s' % (namespace_, name_, eol_))
        else:
            outfile.write('/>%s' % (eol_, ))
    def exportAttributes(self, outfile, level, already_processed, namespace_='hdf5:', name_='StorageLayout'):
        pass
    def exportChildren(self, outfile, level, namespace_='hdf5:', name_='StorageLayout', fromsubclass_=False, pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.ContiguousLayout is not None:
            self.ContiguousLayout.export(outfile, level, namespace_='hdf5:', name_='ContiguousLayout', pretty_print=pretty_print)
        if self.ChunkedLayout is not None:
            self.ChunkedLayout.export(outfile, level, namespace_='hdf5:', name_='ChunkedLayout', pretty_print=pretty_print)
        if self.CompactLayout is not None:
            self.CompactLayout.export(outfile, level, namespace_='hdf5:', name_='CompactLayout', pretty_print=pretty_print)
        if self.ExternalLayout is not None:
            self.ExternalLayout.export(outfile, level, namespace_='hdf5:', name_='ExternalLayout', pretty_print=pretty_print)
    def to_etree(self, parent_element=None, name_='StorageLayout', mapping_=None):
        if parent_element is None:
            element = etree_.Element('{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        else:
            element = etree_.SubElement(parent_element, '{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        if self.ContiguousLayout is not None:
            ContiguousLayout_ = self.ContiguousLayout
            ContiguousLayout_.to_etree(element, name_='ContiguousLayout', mapping_=mapping_)
        if self.ChunkedLayout is not None:
            ChunkedLayout_ = self.ChunkedLayout
            ChunkedLayout_.to_etree(element, name_='ChunkedLayout', mapping_=mapping_)
        if self.CompactLayout is not None:
            CompactLayout_ = self.CompactLayout
            CompactLayout_.to_etree(element, name_='CompactLayout', mapping_=mapping_)
        if self.ExternalLayout is not None:
            ExternalLayout_ = self.ExternalLayout
            ExternalLayout_.to_etree(element, name_='ExternalLayout', mapping_=mapping_)
        if mapping_ is not None:
            mapping_[self] = element
        return element
    def exportLiteral(self, outfile, level, name_='StorageLayout'):
        level += 1
        already_processed = set()
        self.exportLiteralAttributes(outfile, level, already_processed, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, already_processed, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        if self.ContiguousLayout is not None:
            showIndent(outfile, level)
            outfile.write('ContiguousLayout=model_.ContiguousLayout(\n')
            self.ContiguousLayout.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.ChunkedLayout is not None:
            showIndent(outfile, level)
            outfile.write('ChunkedLayout=model_.ChunkedLayout(\n')
            self.ChunkedLayout.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.CompactLayout is not None:
            showIndent(outfile, level)
            outfile.write('CompactLayout=model_.CompactLayout(\n')
            self.CompactLayout.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.ExternalLayout is not None:
            showIndent(outfile, level)
            outfile.write('ExternalLayout=model_.ExternalLayout(\n')
            self.ExternalLayout.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
    def build(self, node):
        already_processed = set()
        self.buildAttributes(node, node.attrib, already_processed)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
        return self
    def buildAttributes(self, node, attrs, already_processed):
        pass
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'ContiguousLayout':
            obj_ = ContiguousLayout.factory()
            obj_.build(child_)
            self.ContiguousLayout = obj_
            obj_.original_tagname_ = 'ContiguousLayout'
        elif nodeName_ == 'ChunkedLayout':
            obj_ = ChunkedLayout.factory()
            obj_.build(child_)
            self.ChunkedLayout = obj_
            obj_.original_tagname_ = 'ChunkedLayout'
        elif nodeName_ == 'CompactLayout':
            obj_ = CompactLayout.factory()
            obj_.build(child_)
            self.CompactLayout = obj_
            obj_.original_tagname_ = 'CompactLayout'
        elif nodeName_ == 'ExternalLayout':
            obj_ = ExternalLayout.factory()
            obj_.build(child_)
            self.ExternalLayout = obj_
            obj_.original_tagname_ = 'ExternalLayout'
# end class StorageLayout


class StringType(GeneratedsSuper):
    member_data_items_ = {
        'Cset': MemberSpec_('Cset', 'xs:NMTOKEN', 0),
        'StrSize': MemberSpec_('StrSize', 'xs:string', 0),
        'StrPad': MemberSpec_('StrPad', 'xs:NMTOKEN', 0),
    }
    subclass = None
    superclass = None
    def __init__(self, Cset=None, StrSize=None, StrPad=None):
        self.original_tagname_ = None
        self.Cset = _cast(None, Cset)
        self.StrSize = _cast(None, StrSize)
        self.StrPad = _cast(None, StrPad)
    def factory(*args_, **kwargs_):
        if StringType.subclass:
            return StringType.subclass(*args_, **kwargs_)
        else:
            return StringType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_Cset(self): return self.Cset
    def set_Cset(self, Cset): self.Cset = Cset
    def get_StrSize(self): return self.StrSize
    def set_StrSize(self, StrSize): self.StrSize = StrSize
    def get_StrPad(self): return self.StrPad
    def set_StrPad(self, StrPad): self.StrPad = StrPad
    def hasContent_(self):
        if (

        ):
            return True
        else:
            return False
    def export(self, outfile, level, namespace_='hdf5:', name_='StringType', namespacedef_='xmlns:hdf5="http://hdfgroup.org/HDF5/XML/schema/HDF5-File"', pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.original_tagname_ is not None:
            name_ = self.original_tagname_
        showIndent(outfile, level, pretty_print)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = set()
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='StringType')
        if self.hasContent_():
            outfile.write('>%s' % (eol_, ))
            self.exportChildren(outfile, level + 1, namespace_='hdf5:', name_='StringType', pretty_print=pretty_print)
            outfile.write('</%s%s>%s' % (namespace_, name_, eol_))
        else:
            outfile.write('/>%s' % (eol_, ))
    def exportAttributes(self, outfile, level, already_processed, namespace_='hdf5:', name_='StringType'):
        if self.Cset is not None and 'Cset' not in already_processed:
            already_processed.add('Cset')
            outfile.write(' Cset=%s' % (self.gds_format_string(quote_attrib(self.Cset).encode(ExternalEncoding), input_name='Cset'), ))
        if self.StrSize is not None and 'StrSize' not in already_processed:
            already_processed.add('StrSize')
            outfile.write(' StrSize=%s' % (self.gds_format_string(quote_attrib(self.StrSize).encode(ExternalEncoding), input_name='StrSize'), ))
        if self.StrPad is not None and 'StrPad' not in already_processed:
            already_processed.add('StrPad')
            outfile.write(' StrPad=%s' % (self.gds_format_string(quote_attrib(self.StrPad).encode(ExternalEncoding), input_name='StrPad'), ))
    def exportChildren(self, outfile, level, namespace_='hdf5:', name_='StringType', fromsubclass_=False, pretty_print=True):
        pass
    def to_etree(self, parent_element=None, name_='StringType', mapping_=None):
        if parent_element is None:
            element = etree_.Element('{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        else:
            element = etree_.SubElement(parent_element, '{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        if self.Cset is not None:
            element.set('Cset', self.gds_format_string(self.Cset))
        if self.StrSize is not None:
            element.set('StrSize', self.gds_format_string(self.StrSize))
        if self.StrPad is not None:
            element.set('StrPad', self.gds_format_string(self.StrPad))
        if mapping_ is not None:
            mapping_[self] = element
        return element
    def exportLiteral(self, outfile, level, name_='StringType'):
        level += 1
        already_processed = set()
        self.exportLiteralAttributes(outfile, level, already_processed, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, already_processed, name_):
        if self.Cset is not None and 'Cset' not in already_processed:
            already_processed.add('Cset')
            showIndent(outfile, level)
            outfile.write('Cset="%s",\n' % (self.Cset,))
        if self.StrSize is not None and 'StrSize' not in already_processed:
            already_processed.add('StrSize')
            showIndent(outfile, level)
            outfile.write('StrSize="%s",\n' % (self.StrSize,))
        if self.StrPad is not None and 'StrPad' not in already_processed:
            already_processed.add('StrPad')
            showIndent(outfile, level)
            outfile.write('StrPad="%s",\n' % (self.StrPad,))
    def exportLiteralChildren(self, outfile, level, name_):
        pass
    def build(self, node):
        already_processed = set()
        self.buildAttributes(node, node.attrib, already_processed)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
        return self
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('Cset', node)
        if value is not None and 'Cset' not in already_processed:
            already_processed.add('Cset')
            self.Cset = value
        value = find_attr_value_('StrSize', node)
        if value is not None and 'StrSize' not in already_processed:
            already_processed.add('StrSize')
            self.StrSize = value
        value = find_attr_value_('StrPad', node)
        if value is not None and 'StrPad' not in already_processed:
            already_processed.add('StrPad')
            self.StrPad = value
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        pass
# end class StringType


class SuperBlock(GeneratedsSuper):
    member_data_items_ = {
        'FormatVersion': MemberSpec_('FormatVersion', 'xs:string', 0),
        'OffsetSize': MemberSpec_('OffsetSize', 'xs:string', 0),
        'LengthSize': MemberSpec_('LengthSize', 'xs:string', 0),
    }
    subclass = None
    superclass = None
    def __init__(self, FormatVersion=None, OffsetSize=None, LengthSize=None):
        self.original_tagname_ = None
        self.FormatVersion = _cast(None, FormatVersion)
        self.OffsetSize = _cast(None, OffsetSize)
        self.LengthSize = _cast(None, LengthSize)
    def factory(*args_, **kwargs_):
        if SuperBlock.subclass:
            return SuperBlock.subclass(*args_, **kwargs_)
        else:
            return SuperBlock(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_FormatVersion(self): return self.FormatVersion
    def set_FormatVersion(self, FormatVersion): self.FormatVersion = FormatVersion
    def get_OffsetSize(self): return self.OffsetSize
    def set_OffsetSize(self, OffsetSize): self.OffsetSize = OffsetSize
    def get_LengthSize(self): return self.LengthSize
    def set_LengthSize(self, LengthSize): self.LengthSize = LengthSize
    def hasContent_(self):
        if (

        ):
            return True
        else:
            return False
    def export(self, outfile, level, namespace_='hdf5:', name_='SuperBlock', namespacedef_='xmlns:hdf5="http://hdfgroup.org/HDF5/XML/schema/HDF5-File"', pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.original_tagname_ is not None:
            name_ = self.original_tagname_
        showIndent(outfile, level, pretty_print)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = set()
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='SuperBlock')
        if self.hasContent_():
            outfile.write('>%s' % (eol_, ))
            self.exportChildren(outfile, level + 1, namespace_='hdf5:', name_='SuperBlock', pretty_print=pretty_print)
            outfile.write('</%s%s>%s' % (namespace_, name_, eol_))
        else:
            outfile.write('/>%s' % (eol_, ))
    def exportAttributes(self, outfile, level, already_processed, namespace_='hdf5:', name_='SuperBlock'):
        if self.FormatVersion is not None and 'FormatVersion' not in already_processed:
            already_processed.add('FormatVersion')
            outfile.write(' FormatVersion=%s' % (self.gds_format_string(quote_attrib(self.FormatVersion).encode(ExternalEncoding), input_name='FormatVersion'), ))
        if self.OffsetSize is not None and 'OffsetSize' not in already_processed:
            already_processed.add('OffsetSize')
            outfile.write(' OffsetSize=%s' % (self.gds_format_string(quote_attrib(self.OffsetSize).encode(ExternalEncoding), input_name='OffsetSize'), ))
        if self.LengthSize is not None and 'LengthSize' not in already_processed:
            already_processed.add('LengthSize')
            outfile.write(' LengthSize=%s' % (self.gds_format_string(quote_attrib(self.LengthSize).encode(ExternalEncoding), input_name='LengthSize'), ))
    def exportChildren(self, outfile, level, namespace_='hdf5:', name_='SuperBlock', fromsubclass_=False, pretty_print=True):
        pass
    def to_etree(self, parent_element=None, name_='SuperBlock', mapping_=None):
        if parent_element is None:
            element = etree_.Element('{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        else:
            element = etree_.SubElement(parent_element, '{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        if self.FormatVersion is not None:
            element.set('FormatVersion', self.gds_format_string(self.FormatVersion))
        if self.OffsetSize is not None:
            element.set('OffsetSize', self.gds_format_string(self.OffsetSize))
        if self.LengthSize is not None:
            element.set('LengthSize', self.gds_format_string(self.LengthSize))
        if mapping_ is not None:
            mapping_[self] = element
        return element
    def exportLiteral(self, outfile, level, name_='SuperBlock'):
        level += 1
        already_processed = set()
        self.exportLiteralAttributes(outfile, level, already_processed, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, already_processed, name_):
        if self.FormatVersion is not None and 'FormatVersion' not in already_processed:
            already_processed.add('FormatVersion')
            showIndent(outfile, level)
            outfile.write('FormatVersion="%s",\n' % (self.FormatVersion,))
        if self.OffsetSize is not None and 'OffsetSize' not in already_processed:
            already_processed.add('OffsetSize')
            showIndent(outfile, level)
            outfile.write('OffsetSize="%s",\n' % (self.OffsetSize,))
        if self.LengthSize is not None and 'LengthSize' not in already_processed:
            already_processed.add('LengthSize')
            showIndent(outfile, level)
            outfile.write('LengthSize="%s",\n' % (self.LengthSize,))
    def exportLiteralChildren(self, outfile, level, name_):
        pass
    def build(self, node):
        already_processed = set()
        self.buildAttributes(node, node.attrib, already_processed)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
        return self
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('FormatVersion', node)
        if value is not None and 'FormatVersion' not in already_processed:
            already_processed.add('FormatVersion')
            self.FormatVersion = value
        value = find_attr_value_('OffsetSize', node)
        if value is not None and 'OffsetSize' not in already_processed:
            already_processed.add('OffsetSize')
            self.OffsetSize = value
        value = find_attr_value_('LengthSize', node)
        if value is not None and 'LengthSize' not in already_processed:
            already_processed.add('LengthSize')
            self.LengthSize = value
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        pass
# end class SuperBlock


class TimeType(GeneratedsSuper):
    member_data_items_ = {
    }
    subclass = None
    superclass = None
    def __init__(self):
        self.original_tagname_ = None
    def factory(*args_, **kwargs_):
        if TimeType.subclass:
            return TimeType.subclass(*args_, **kwargs_)
        else:
            return TimeType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def hasContent_(self):
        if (

        ):
            return True
        else:
            return False
    def export(self, outfile, level, namespace_='hdf5:', name_='TimeType', namespacedef_='xmlns:hdf5="http://hdfgroup.org/HDF5/XML/schema/HDF5-File"', pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.original_tagname_ is not None:
            name_ = self.original_tagname_
        showIndent(outfile, level, pretty_print)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = set()
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='TimeType')
        if self.hasContent_():
            outfile.write('>%s' % (eol_, ))
            self.exportChildren(outfile, level + 1, namespace_='hdf5:', name_='TimeType', pretty_print=pretty_print)
            outfile.write('</%s%s>%s' % (namespace_, name_, eol_))
        else:
            outfile.write('/>%s' % (eol_, ))
    def exportAttributes(self, outfile, level, already_processed, namespace_='hdf5:', name_='TimeType'):
        pass
    def exportChildren(self, outfile, level, namespace_='hdf5:', name_='TimeType', fromsubclass_=False, pretty_print=True):
        pass
    def to_etree(self, parent_element=None, name_='TimeType', mapping_=None):
        if parent_element is None:
            element = etree_.Element('{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        else:
            element = etree_.SubElement(parent_element, '{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        if mapping_ is not None:
            mapping_[self] = element
        return element
    def exportLiteral(self, outfile, level, name_='TimeType'):
        level += 1
        already_processed = set()
        self.exportLiteralAttributes(outfile, level, already_processed, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, already_processed, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        pass
    def build(self, node):
        already_processed = set()
        self.buildAttributes(node, node.attrib, already_processed)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
        return self
    def buildAttributes(self, node, attrs, already_processed):
        pass
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        pass
# end class TimeType


class VLType(GeneratedsSuper):
    member_data_items_ = {
        'DataType': MemberSpec_('DataType', 'DataType', 0),
    }
    subclass = None
    superclass = None
    def __init__(self, DataType=None):
        self.original_tagname_ = None
        self.DataType = DataType
    def factory(*args_, **kwargs_):
        if VLType.subclass:
            return VLType.subclass(*args_, **kwargs_)
        else:
            return VLType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_DataType(self): return self.DataType
    def set_DataType(self, DataType): self.DataType = DataType
    def hasContent_(self):
        if (
            self.DataType is not None
        ):
            return True
        else:
            return False
    def export(self, outfile, level, namespace_='hdf5:', name_='VLType', namespacedef_='xmlns:hdf5="http://hdfgroup.org/HDF5/XML/schema/HDF5-File"', pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.original_tagname_ is not None:
            name_ = self.original_tagname_
        showIndent(outfile, level, pretty_print)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = set()
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='VLType')
        if self.hasContent_():
            outfile.write('>%s' % (eol_, ))
            self.exportChildren(outfile, level + 1, namespace_='hdf5:', name_='VLType', pretty_print=pretty_print)
            showIndent(outfile, level, pretty_print)
            outfile.write('</%s%s>%s' % (namespace_, name_, eol_))
        else:
            outfile.write('/>%s' % (eol_, ))
    def exportAttributes(self, outfile, level, already_processed, namespace_='hdf5:', name_='VLType'):
        pass
    def exportChildren(self, outfile, level, namespace_='hdf5:', name_='VLType', fromsubclass_=False, pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.DataType is not None:
            self.DataType.export(outfile, level, namespace_='hdf5:', name_='DataType', pretty_print=pretty_print)
    def to_etree(self, parent_element=None, name_='VLType', mapping_=None):
        if parent_element is None:
            element = etree_.Element('{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        else:
            element = etree_.SubElement(parent_element, '{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        if self.DataType is not None:
            DataType_ = self.DataType
            DataType_.to_etree(element, name_='DataType', mapping_=mapping_)
        if mapping_ is not None:
            mapping_[self] = element
        return element
    def exportLiteral(self, outfile, level, name_='VLType'):
        level += 1
        already_processed = set()
        self.exportLiteralAttributes(outfile, level, already_processed, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, already_processed, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        if self.DataType is not None:
            showIndent(outfile, level)
            outfile.write('DataType=model_.DataType(\n')
            self.DataType.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
    def build(self, node):
        already_processed = set()
        self.buildAttributes(node, node.attrib, already_processed)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
        return self
    def buildAttributes(self, node, attrs, already_processed):
        pass
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'DataType':
            obj_ = DataType.factory()
            obj_.build(child_)
            self.DataType = obj_
            obj_.original_tagname_ = 'DataType'
# end class VLType


class RequiredFilter(GeneratedsSuper):
    member_data_items_ = {
        'Deflate': MemberSpec_('Deflate', 'Deflate', 0),
        'Fletcher32': MemberSpec_('Fletcher32', 'Fletcher32', 0),
        'Shuffle': MemberSpec_('Shuffle', 'Shuffle', 0),
        'SZIP': MemberSpec_('SZIP', 'SZIP', 0),
    }
    subclass = None
    superclass = None
    def __init__(self, Deflate=None, Fletcher32=None, Shuffle=None, SZIP=None):
        self.original_tagname_ = None
        self.Deflate = Deflate
        self.Fletcher32 = Fletcher32
        self.Shuffle = Shuffle
        self.SZIP = SZIP
    def factory(*args_, **kwargs_):
        if RequiredFilter.subclass:
            return RequiredFilter.subclass(*args_, **kwargs_)
        else:
            return RequiredFilter(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_Deflate(self): return self.Deflate
    def set_Deflate(self, Deflate): self.Deflate = Deflate
    def get_Fletcher32(self): return self.Fletcher32
    def set_Fletcher32(self, Fletcher32): self.Fletcher32 = Fletcher32
    def get_Shuffle(self): return self.Shuffle
    def set_Shuffle(self, Shuffle): self.Shuffle = Shuffle
    def get_SZIP(self): return self.SZIP
    def set_SZIP(self, SZIP): self.SZIP = SZIP
    def hasContent_(self):
        if (
            self.Deflate is not None or
            self.Fletcher32 is not None or
            self.Shuffle is not None or
            self.SZIP is not None
        ):
            return True
        else:
            return False
    def export(self, outfile, level, namespace_='hdf5:', name_='RequiredFilter', namespacedef_='xmlns:hdf5="http://hdfgroup.org/HDF5/XML/schema/HDF5-File"', pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.original_tagname_ is not None:
            name_ = self.original_tagname_
        showIndent(outfile, level, pretty_print)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = set()
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='RequiredFilter')
        if self.hasContent_():
            outfile.write('>%s' % (eol_, ))
            self.exportChildren(outfile, level + 1, namespace_='hdf5:', name_='RequiredFilter', pretty_print=pretty_print)
            showIndent(outfile, level, pretty_print)
            outfile.write('</%s%s>%s' % (namespace_, name_, eol_))
        else:
            outfile.write('/>%s' % (eol_, ))
    def exportAttributes(self, outfile, level, already_processed, namespace_='hdf5:', name_='RequiredFilter'):
        pass
    def exportChildren(self, outfile, level, namespace_='hdf5:', name_='RequiredFilter', fromsubclass_=False, pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.Deflate is not None:
            self.Deflate.export(outfile, level, namespace_='hdf5:', name_='Deflate', pretty_print=pretty_print)
        if self.Fletcher32 is not None:
            self.Fletcher32.export(outfile, level, namespace_='hdf5:', name_='Fletcher32', pretty_print=pretty_print)
        if self.Shuffle is not None:
            self.Shuffle.export(outfile, level, namespace_='hdf5:', name_='Shuffle', pretty_print=pretty_print)
        if self.SZIP is not None:
            self.SZIP.export(outfile, level, namespace_='hdf5:', name_='SZIP', pretty_print=pretty_print)
    def to_etree(self, parent_element=None, name_='RequiredFilter', mapping_=None):
        if parent_element is None:
            element = etree_.Element('{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        else:
            element = etree_.SubElement(parent_element, '{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        if self.Deflate is not None:
            Deflate_ = self.Deflate
            Deflate_.to_etree(element, name_='Deflate', mapping_=mapping_)
        if self.Fletcher32 is not None:
            Fletcher32_ = self.Fletcher32
            Fletcher32_.to_etree(element, name_='Fletcher32', mapping_=mapping_)
        if self.Shuffle is not None:
            Shuffle_ = self.Shuffle
            Shuffle_.to_etree(element, name_='Shuffle', mapping_=mapping_)
        if self.SZIP is not None:
            SZIP_ = self.SZIP
            SZIP_.to_etree(element, name_='SZIP', mapping_=mapping_)
        if mapping_ is not None:
            mapping_[self] = element
        return element
    def exportLiteral(self, outfile, level, name_='RequiredFilter'):
        level += 1
        already_processed = set()
        self.exportLiteralAttributes(outfile, level, already_processed, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, already_processed, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        if self.Deflate is not None:
            showIndent(outfile, level)
            outfile.write('Deflate=model_.Deflate(\n')
            self.Deflate.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.Fletcher32 is not None:
            showIndent(outfile, level)
            outfile.write('Fletcher32=model_.Fletcher32(\n')
            self.Fletcher32.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.Shuffle is not None:
            showIndent(outfile, level)
            outfile.write('Shuffle=model_.Shuffle(\n')
            self.Shuffle.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.SZIP is not None:
            showIndent(outfile, level)
            outfile.write('SZIP=model_.SZIP(\n')
            self.SZIP.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
    def build(self, node):
        already_processed = set()
        self.buildAttributes(node, node.attrib, already_processed)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
        return self
    def buildAttributes(self, node, attrs, already_processed):
        pass
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'Deflate':
            obj_ = Deflate.factory()
            obj_.build(child_)
            self.Deflate = obj_
            obj_.original_tagname_ = 'Deflate'
        elif nodeName_ == 'Fletcher32':
            obj_ = Fletcher32.factory()
            obj_.build(child_)
            self.Fletcher32 = obj_
            obj_.original_tagname_ = 'Fletcher32'
        elif nodeName_ == 'Shuffle':
            obj_ = Shuffle.factory()
            obj_.build(child_)
            self.Shuffle = obj_
            obj_.original_tagname_ = 'Shuffle'
        elif nodeName_ == 'SZIP':
            obj_ = SZIP.factory()
            obj_.build(child_)
            self.SZIP = obj_
            obj_.original_tagname_ = 'SZIP'
# end class RequiredFilter


class Deflate(GeneratedsSuper):
    member_data_items_ = {
        'Level': MemberSpec_('Level', 'xs:int', 0),
    }
    subclass = None
    superclass = None
    def __init__(self, Level=6):
        self.original_tagname_ = None
        self.Level = _cast(int, Level)
    def factory(*args_, **kwargs_):
        if Deflate.subclass:
            return Deflate.subclass(*args_, **kwargs_)
        else:
            return Deflate(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_Level(self): return self.Level
    def set_Level(self, Level): self.Level = Level
    def hasContent_(self):
        if (

        ):
            return True
        else:
            return False
    def export(self, outfile, level, namespace_='hdf5:', name_='Deflate', namespacedef_='xmlns:hdf5="http://hdfgroup.org/HDF5/XML/schema/HDF5-File"', pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.original_tagname_ is not None:
            name_ = self.original_tagname_
        showIndent(outfile, level, pretty_print)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = set()
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='Deflate')
        if self.hasContent_():
            outfile.write('>%s' % (eol_, ))
            self.exportChildren(outfile, level + 1, namespace_='hdf5:', name_='Deflate', pretty_print=pretty_print)
            outfile.write('</%s%s>%s' % (namespace_, name_, eol_))
        else:
            outfile.write('/>%s' % (eol_, ))
    def exportAttributes(self, outfile, level, already_processed, namespace_='hdf5:', name_='Deflate'):
        if self.Level is not None and 'Level' not in already_processed:
            already_processed.add('Level')
            outfile.write(' Level="%s"' % self.gds_format_integer(self.Level, input_name='Level'))
    def exportChildren(self, outfile, level, namespace_='hdf5:', name_='Deflate', fromsubclass_=False, pretty_print=True):
        pass
    def to_etree(self, parent_element=None, name_='Deflate', mapping_=None):
        if parent_element is None:
            element = etree_.Element('{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        else:
            element = etree_.SubElement(parent_element, '{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        if self.Level is not None:
            element.set('Level', self.gds_format_integer(self.Level))
        if mapping_ is not None:
            mapping_[self] = element
        return element
    def exportLiteral(self, outfile, level, name_='Deflate'):
        level += 1
        already_processed = set()
        self.exportLiteralAttributes(outfile, level, already_processed, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, already_processed, name_):
        if self.Level is not None and 'Level' not in already_processed:
            already_processed.add('Level')
            showIndent(outfile, level)
            outfile.write('Level=%d,\n' % (self.Level,))
    def exportLiteralChildren(self, outfile, level, name_):
        pass
    def build(self, node):
        already_processed = set()
        self.buildAttributes(node, node.attrib, already_processed)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
        return self
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('Level', node)
        if value is not None and 'Level' not in already_processed:
            already_processed.add('Level')
            try:
                self.Level = int(value)
            except ValueError, exp:
                raise_parse_error(node, 'Bad integer attribute: %s' % exp)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        pass
# end class Deflate


class Fletcher32(GeneratedsSuper):
    member_data_items_ = {
    }
    subclass = None
    superclass = None
    def __init__(self):
        self.original_tagname_ = None
    def factory(*args_, **kwargs_):
        if Fletcher32.subclass:
            return Fletcher32.subclass(*args_, **kwargs_)
        else:
            return Fletcher32(*args_, **kwargs_)
    factory = staticmethod(factory)
    def hasContent_(self):
        if (

        ):
            return True
        else:
            return False
    def export(self, outfile, level, namespace_='hdf5:', name_='Fletcher32', namespacedef_='xmlns:hdf5="http://hdfgroup.org/HDF5/XML/schema/HDF5-File"', pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.original_tagname_ is not None:
            name_ = self.original_tagname_
        showIndent(outfile, level, pretty_print)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = set()
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='Fletcher32')
        if self.hasContent_():
            outfile.write('>%s' % (eol_, ))
            self.exportChildren(outfile, level + 1, namespace_='hdf5:', name_='Fletcher32', pretty_print=pretty_print)
            outfile.write('</%s%s>%s' % (namespace_, name_, eol_))
        else:
            outfile.write('/>%s' % (eol_, ))
    def exportAttributes(self, outfile, level, already_processed, namespace_='hdf5:', name_='Fletcher32'):
        pass
    def exportChildren(self, outfile, level, namespace_='hdf5:', name_='Fletcher32', fromsubclass_=False, pretty_print=True):
        pass
    def to_etree(self, parent_element=None, name_='Fletcher32', mapping_=None):
        if parent_element is None:
            element = etree_.Element('{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        else:
            element = etree_.SubElement(parent_element, '{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        if mapping_ is not None:
            mapping_[self] = element
        return element
    def exportLiteral(self, outfile, level, name_='Fletcher32'):
        level += 1
        already_processed = set()
        self.exportLiteralAttributes(outfile, level, already_processed, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, already_processed, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        pass
    def build(self, node):
        already_processed = set()
        self.buildAttributes(node, node.attrib, already_processed)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
        return self
    def buildAttributes(self, node, attrs, already_processed):
        pass
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        pass
# end class Fletcher32


class Shuffle(GeneratedsSuper):
    member_data_items_ = {
    }
    subclass = None
    superclass = None
    def __init__(self):
        self.original_tagname_ = None
    def factory(*args_, **kwargs_):
        if Shuffle.subclass:
            return Shuffle.subclass(*args_, **kwargs_)
        else:
            return Shuffle(*args_, **kwargs_)
    factory = staticmethod(factory)
    def hasContent_(self):
        if (

        ):
            return True
        else:
            return False
    def export(self, outfile, level, namespace_='hdf5:', name_='Shuffle', namespacedef_='xmlns:hdf5="http://hdfgroup.org/HDF5/XML/schema/HDF5-File"', pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.original_tagname_ is not None:
            name_ = self.original_tagname_
        showIndent(outfile, level, pretty_print)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = set()
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='Shuffle')
        if self.hasContent_():
            outfile.write('>%s' % (eol_, ))
            self.exportChildren(outfile, level + 1, namespace_='hdf5:', name_='Shuffle', pretty_print=pretty_print)
            outfile.write('</%s%s>%s' % (namespace_, name_, eol_))
        else:
            outfile.write('/>%s' % (eol_, ))
    def exportAttributes(self, outfile, level, already_processed, namespace_='hdf5:', name_='Shuffle'):
        pass
    def exportChildren(self, outfile, level, namespace_='hdf5:', name_='Shuffle', fromsubclass_=False, pretty_print=True):
        pass
    def to_etree(self, parent_element=None, name_='Shuffle', mapping_=None):
        if parent_element is None:
            element = etree_.Element('{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        else:
            element = etree_.SubElement(parent_element, '{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        if mapping_ is not None:
            mapping_[self] = element
        return element
    def exportLiteral(self, outfile, level, name_='Shuffle'):
        level += 1
        already_processed = set()
        self.exportLiteralAttributes(outfile, level, already_processed, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, already_processed, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        pass
    def build(self, node):
        already_processed = set()
        self.buildAttributes(node, node.attrib, already_processed)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
        return self
    def buildAttributes(self, node, attrs, already_processed):
        pass
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        pass
# end class Shuffle


class SZIP(GeneratedsSuper):
    member_data_items_ = {
        'Header': MemberSpec_('Header', 'xs:string', 0),
        'ByteOrder': MemberSpec_('ByteOrder', 'xs:string', 0),
        'Coding': MemberSpec_('Coding', 'xs:string', 0),
        'Pixels_per_block': MemberSpec_('Pixels_per_block', 'xs:nonNegativeInteger', 0),
        'Mode': MemberSpec_('Mode', 'xs:string', 0),
    }
    subclass = None
    superclass = None
    def __init__(self, Header=None, ByteOrder=None, Coding='Entropy', Pixels_per_block=None, Mode=None):
        self.original_tagname_ = None
        self.Header = _cast(None, Header)
        self.ByteOrder = _cast(None, ByteOrder)
        self.Coding = _cast(None, Coding)
        self.Pixels_per_block = _cast(int, Pixels_per_block)
        self.Mode = _cast(None, Mode)
    def factory(*args_, **kwargs_):
        if SZIP.subclass:
            return SZIP.subclass(*args_, **kwargs_)
        else:
            return SZIP(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_Header(self): return self.Header
    def set_Header(self, Header): self.Header = Header
    def get_ByteOrder(self): return self.ByteOrder
    def set_ByteOrder(self, ByteOrder): self.ByteOrder = ByteOrder
    def get_Coding(self): return self.Coding
    def set_Coding(self, Coding): self.Coding = Coding
    def get_Pixels_per_block(self): return self.Pixels_per_block
    def set_Pixels_per_block(self, Pixels_per_block): self.Pixels_per_block = Pixels_per_block
    def get_Mode(self): return self.Mode
    def set_Mode(self, Mode): self.Mode = Mode
    def hasContent_(self):
        if (

        ):
            return True
        else:
            return False
    def export(self, outfile, level, namespace_='hdf5:', name_='SZIP', namespacedef_='xmlns:hdf5="http://hdfgroup.org/HDF5/XML/schema/HDF5-File"', pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.original_tagname_ is not None:
            name_ = self.original_tagname_
        showIndent(outfile, level, pretty_print)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = set()
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='SZIP')
        if self.hasContent_():
            outfile.write('>%s' % (eol_, ))
            self.exportChildren(outfile, level + 1, namespace_='hdf5:', name_='SZIP', pretty_print=pretty_print)
            outfile.write('</%s%s>%s' % (namespace_, name_, eol_))
        else:
            outfile.write('/>%s' % (eol_, ))
    def exportAttributes(self, outfile, level, already_processed, namespace_='hdf5:', name_='SZIP'):
        if self.Header is not None and 'Header' not in already_processed:
            already_processed.add('Header')
            outfile.write(' Header=%s' % (self.gds_format_string(quote_attrib(self.Header).encode(ExternalEncoding), input_name='Header'), ))
        if self.ByteOrder is not None and 'ByteOrder' not in already_processed:
            already_processed.add('ByteOrder')
            outfile.write(' ByteOrder=%s' % (self.gds_format_string(quote_attrib(self.ByteOrder).encode(ExternalEncoding), input_name='ByteOrder'), ))
        if self.Coding is not None and 'Coding' not in already_processed:
            already_processed.add('Coding')
            outfile.write(' Coding=%s' % (self.gds_format_string(quote_attrib(self.Coding).encode(ExternalEncoding), input_name='Coding'), ))
        if self.Pixels_per_block is not None and 'Pixels_per_block' not in already_processed:
            already_processed.add('Pixels_per_block')
            outfile.write(' Pixels_per_block="%s"' % self.gds_format_integer(self.Pixels_per_block, input_name='Pixels_per_block'))
        if self.Mode is not None and 'Mode' not in already_processed:
            already_processed.add('Mode')
            outfile.write(' Mode=%s' % (self.gds_format_string(quote_attrib(self.Mode).encode(ExternalEncoding), input_name='Mode'), ))
    def exportChildren(self, outfile, level, namespace_='hdf5:', name_='SZIP', fromsubclass_=False, pretty_print=True):
        pass
    def to_etree(self, parent_element=None, name_='SZIP', mapping_=None):
        if parent_element is None:
            element = etree_.Element('{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        else:
            element = etree_.SubElement(parent_element, '{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        if self.Header is not None:
            element.set('Header', self.gds_format_string(self.Header))
        if self.ByteOrder is not None:
            element.set('ByteOrder', self.gds_format_string(self.ByteOrder))
        if self.Coding is not None:
            element.set('Coding', self.gds_format_string(self.Coding))
        if self.Pixels_per_block is not None:
            element.set('Pixels_per_block', self.gds_format_integer(self.Pixels_per_block))
        if self.Mode is not None:
            element.set('Mode', self.gds_format_string(self.Mode))
        if mapping_ is not None:
            mapping_[self] = element
        return element
    def exportLiteral(self, outfile, level, name_='SZIP'):
        level += 1
        already_processed = set()
        self.exportLiteralAttributes(outfile, level, already_processed, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, already_processed, name_):
        if self.Header is not None and 'Header' not in already_processed:
            already_processed.add('Header')
            showIndent(outfile, level)
            outfile.write('Header="%s",\n' % (self.Header,))
        if self.ByteOrder is not None and 'ByteOrder' not in already_processed:
            already_processed.add('ByteOrder')
            showIndent(outfile, level)
            outfile.write('ByteOrder="%s",\n' % (self.ByteOrder,))
        if self.Coding is not None and 'Coding' not in already_processed:
            already_processed.add('Coding')
            showIndent(outfile, level)
            outfile.write('Coding="%s",\n' % (self.Coding,))
        if self.Pixels_per_block is not None and 'Pixels_per_block' not in already_processed:
            already_processed.add('Pixels_per_block')
            showIndent(outfile, level)
            outfile.write('Pixels_per_block=%d,\n' % (self.Pixels_per_block,))
        if self.Mode is not None and 'Mode' not in already_processed:
            already_processed.add('Mode')
            showIndent(outfile, level)
            outfile.write('Mode="%s",\n' % (self.Mode,))
    def exportLiteralChildren(self, outfile, level, name_):
        pass
    def build(self, node):
        already_processed = set()
        self.buildAttributes(node, node.attrib, already_processed)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
        return self
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('Header', node)
        if value is not None and 'Header' not in already_processed:
            already_processed.add('Header')
            self.Header = value
        value = find_attr_value_('ByteOrder', node)
        if value is not None and 'ByteOrder' not in already_processed:
            already_processed.add('ByteOrder')
            self.ByteOrder = value
        value = find_attr_value_('Coding', node)
        if value is not None and 'Coding' not in already_processed:
            already_processed.add('Coding')
            self.Coding = value
        value = find_attr_value_('Pixels_per_block', node)
        if value is not None and 'Pixels_per_block' not in already_processed:
            already_processed.add('Pixels_per_block')
            try:
                self.Pixels_per_block = int(value)
            except ValueError, exp:
                raise_parse_error(node, 'Bad integer attribute: %s' % exp)
            if self.Pixels_per_block < 0:
                raise_parse_error(node, 'Invalid NonNegativeInteger')
        value = find_attr_value_('Mode', node)
        if value is not None and 'Mode' not in already_processed:
            already_processed.add('Mode')
            self.Mode = value
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        pass
# end class SZIP


class FillValueInfo(GeneratedsSuper):
    member_data_items_ = {
        'FillTime': MemberSpec_('FillTime', 'xs:string', 0),
        'AllocationTime': MemberSpec_('AllocationTime', 'xs:string', 0),
        'FillValue': MemberSpec_('FillValue', 'FillValue', 0),
    }
    subclass = None
    superclass = None
    def __init__(self, FillTime=None, AllocationTime=None, FillValue=None):
        self.original_tagname_ = None
        self.FillTime = _cast(None, FillTime)
        self.AllocationTime = _cast(None, AllocationTime)
        self.FillValue = FillValue
    def factory(*args_, **kwargs_):
        if FillValueInfo.subclass:
            return FillValueInfo.subclass(*args_, **kwargs_)
        else:
            return FillValueInfo(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_FillValue(self): return self.FillValue
    def set_FillValue(self, FillValue): self.FillValue = FillValue
    def get_FillTime(self): return self.FillTime
    def set_FillTime(self, FillTime): self.FillTime = FillTime
    def get_AllocationTime(self): return self.AllocationTime
    def set_AllocationTime(self, AllocationTime): self.AllocationTime = AllocationTime
    def hasContent_(self):
        if (
            self.FillValue is not None
        ):
            return True
        else:
            return False
    def export(self, outfile, level, namespace_='hdf5:', name_='FillValueInfo', namespacedef_='xmlns:hdf5="http://hdfgroup.org/HDF5/XML/schema/HDF5-File"', pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.original_tagname_ is not None:
            name_ = self.original_tagname_
        showIndent(outfile, level, pretty_print)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = set()
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='FillValueInfo')
        if self.hasContent_():
            outfile.write('>%s' % (eol_, ))
            self.exportChildren(outfile, level + 1, namespace_='hdf5:', name_='FillValueInfo', pretty_print=pretty_print)
            showIndent(outfile, level, pretty_print)
            outfile.write('</%s%s>%s' % (namespace_, name_, eol_))
        else:
            outfile.write('/>%s' % (eol_, ))
    def exportAttributes(self, outfile, level, already_processed, namespace_='hdf5:', name_='FillValueInfo'):
        if self.FillTime is not None and 'FillTime' not in already_processed:
            already_processed.add('FillTime')
            outfile.write(' FillTime=%s' % (self.gds_format_string(quote_attrib(self.FillTime).encode(ExternalEncoding), input_name='FillTime'), ))
        if self.AllocationTime is not None and 'AllocationTime' not in already_processed:
            already_processed.add('AllocationTime')
            outfile.write(' AllocationTime=%s' % (self.gds_format_string(quote_attrib(self.AllocationTime).encode(ExternalEncoding), input_name='AllocationTime'), ))
    def exportChildren(self, outfile, level, namespace_='hdf5:', name_='FillValueInfo', fromsubclass_=False, pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.FillValue is not None:
            self.FillValue.export(outfile, level, namespace_='hdf5:', name_='FillValue', pretty_print=pretty_print)
    def to_etree(self, parent_element=None, name_='FillValueInfo', mapping_=None):
        if parent_element is None:
            element = etree_.Element('{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        else:
            element = etree_.SubElement(parent_element, '{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        if self.FillTime is not None:
            element.set('FillTime', self.gds_format_string(self.FillTime))
        if self.AllocationTime is not None:
            element.set('AllocationTime', self.gds_format_string(self.AllocationTime))
        if self.FillValue is not None:
            FillValue_ = self.FillValue
            FillValue_.to_etree(element, name_='FillValue', mapping_=mapping_)
        if mapping_ is not None:
            mapping_[self] = element
        return element
    def exportLiteral(self, outfile, level, name_='FillValueInfo'):
        level += 1
        already_processed = set()
        self.exportLiteralAttributes(outfile, level, already_processed, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, already_processed, name_):
        if self.FillTime is not None and 'FillTime' not in already_processed:
            already_processed.add('FillTime')
            showIndent(outfile, level)
            outfile.write('FillTime="%s",\n' % (self.FillTime,))
        if self.AllocationTime is not None and 'AllocationTime' not in already_processed:
            already_processed.add('AllocationTime')
            showIndent(outfile, level)
            outfile.write('AllocationTime="%s",\n' % (self.AllocationTime,))
    def exportLiteralChildren(self, outfile, level, name_):
        if self.FillValue is not None:
            showIndent(outfile, level)
            outfile.write('FillValue=model_.FillValue(\n')
            self.FillValue.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
    def build(self, node):
        already_processed = set()
        self.buildAttributes(node, node.attrib, already_processed)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
        return self
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('FillTime', node)
        if value is not None and 'FillTime' not in already_processed:
            already_processed.add('FillTime')
            self.FillTime = value
        value = find_attr_value_('AllocationTime', node)
        if value is not None and 'AllocationTime' not in already_processed:
            already_processed.add('AllocationTime')
            self.AllocationTime = value
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'FillValue':
            obj_ = FillValue.factory()
            obj_.build(child_)
            self.FillValue = obj_
            obj_.original_tagname_ = 'FillValue'
# end class FillValueInfo


class FillValue(GeneratedsSuper):
    member_data_items_ = {
        'Data': MemberSpec_('Data', 'Data', 0),
        'NoFill': MemberSpec_('NoFill', 'NoFill', 0),
    }
    subclass = None
    superclass = None
    def __init__(self, Data=None, NoFill=None):
        self.original_tagname_ = None
        self.Data = Data
        self.NoFill = NoFill
    def factory(*args_, **kwargs_):
        if FillValue.subclass:
            return FillValue.subclass(*args_, **kwargs_)
        else:
            return FillValue(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_Data(self): return self.Data
    def set_Data(self, Data): self.Data = Data
    def get_NoFill(self): return self.NoFill
    def set_NoFill(self, NoFill): self.NoFill = NoFill
    def hasContent_(self):
        if (
            self.Data is not None or
            self.NoFill is not None
        ):
            return True
        else:
            return False
    def export(self, outfile, level, namespace_='hdf5:', name_='FillValue', namespacedef_='xmlns:hdf5="http://hdfgroup.org/HDF5/XML/schema/HDF5-File"', pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.original_tagname_ is not None:
            name_ = self.original_tagname_
        showIndent(outfile, level, pretty_print)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = set()
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='FillValue')
        if self.hasContent_():
            outfile.write('>%s' % (eol_, ))
            self.exportChildren(outfile, level + 1, namespace_='hdf5:', name_='FillValue', pretty_print=pretty_print)
            showIndent(outfile, level, pretty_print)
            outfile.write('</%s%s>%s' % (namespace_, name_, eol_))
        else:
            outfile.write('/>%s' % (eol_, ))
    def exportAttributes(self, outfile, level, already_processed, namespace_='hdf5:', name_='FillValue'):
        pass
    def exportChildren(self, outfile, level, namespace_='hdf5:', name_='FillValue', fromsubclass_=False, pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.Data is not None:
            self.Data.export(outfile, level, namespace_='hdf5:', name_='Data', pretty_print=pretty_print)
        if self.NoFill is not None:
            self.NoFill.export(outfile, level, namespace_='hdf5:', name_='NoFill', pretty_print=pretty_print)
    def to_etree(self, parent_element=None, name_='FillValue', mapping_=None):
        if parent_element is None:
            element = etree_.Element('{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        else:
            element = etree_.SubElement(parent_element, '{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        if self.Data is not None:
            Data_ = self.Data
            Data_.to_etree(element, name_='Data', mapping_=mapping_)
        if self.NoFill is not None:
            NoFill_ = self.NoFill
            NoFill_.to_etree(element, name_='NoFill', mapping_=mapping_)
        if mapping_ is not None:
            mapping_[self] = element
        return element
    def exportLiteral(self, outfile, level, name_='FillValue'):
        level += 1
        already_processed = set()
        self.exportLiteralAttributes(outfile, level, already_processed, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, already_processed, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        if self.Data is not None:
            showIndent(outfile, level)
            outfile.write('Data=model_.Data(\n')
            self.Data.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.NoFill is not None:
            showIndent(outfile, level)
            outfile.write('NoFill=model_.NoFill(\n')
            self.NoFill.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
    def build(self, node):
        already_processed = set()
        self.buildAttributes(node, node.attrib, already_processed)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
        return self
    def buildAttributes(self, node, attrs, already_processed):
        pass
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'Data':
            obj_ = Data.factory()
            obj_.build(child_)
            self.Data = obj_
            obj_.original_tagname_ = 'Data'
        elif nodeName_ == 'NoFill':
            obj_ = NoFill.factory()
            obj_.build(child_)
            self.NoFill = obj_
            obj_.original_tagname_ = 'NoFill'
# end class FillValue


class NoFill(GeneratedsSuper):
    member_data_items_ = {
    }
    subclass = None
    superclass = None
    def __init__(self):
        self.original_tagname_ = None
    def factory(*args_, **kwargs_):
        if NoFill.subclass:
            return NoFill.subclass(*args_, **kwargs_)
        else:
            return NoFill(*args_, **kwargs_)
    factory = staticmethod(factory)
    def hasContent_(self):
        if (

        ):
            return True
        else:
            return False
    def export(self, outfile, level, namespace_='hdf5:', name_='NoFill', namespacedef_='xmlns:hdf5="http://hdfgroup.org/HDF5/XML/schema/HDF5-File"', pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.original_tagname_ is not None:
            name_ = self.original_tagname_
        showIndent(outfile, level, pretty_print)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = set()
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='NoFill')
        if self.hasContent_():
            outfile.write('>%s' % (eol_, ))
            self.exportChildren(outfile, level + 1, namespace_='hdf5:', name_='NoFill', pretty_print=pretty_print)
            outfile.write('</%s%s>%s' % (namespace_, name_, eol_))
        else:
            outfile.write('/>%s' % (eol_, ))
    def exportAttributes(self, outfile, level, already_processed, namespace_='hdf5:', name_='NoFill'):
        pass
    def exportChildren(self, outfile, level, namespace_='hdf5:', name_='NoFill', fromsubclass_=False, pretty_print=True):
        pass
    def to_etree(self, parent_element=None, name_='NoFill', mapping_=None):
        if parent_element is None:
            element = etree_.Element('{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        else:
            element = etree_.SubElement(parent_element, '{http://hdfgroup.org/HDF5/XML/schema/HDF5-File}' + name_)
        if mapping_ is not None:
            mapping_[self] = element
        return element
    def exportLiteral(self, outfile, level, name_='NoFill'):
        level += 1
        already_processed = set()
        self.exportLiteralAttributes(outfile, level, already_processed, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, already_processed, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        pass
    def build(self, node):
        already_processed = set()
        self.buildAttributes(node, node.attrib, already_processed)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
        return self
    def buildAttributes(self, node, attrs, already_processed):
        pass
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        pass
# end class NoFill


GDSClassesMapping = {
}


USAGE_TEXT = """
Usage: python <Parser>.py [ -s ] <in_xml_file>
"""


def usage():
    print USAGE_TEXT
    sys.exit(1)


def get_root_tag(node):
    tag = Tag_pattern_.match(node.tag).groups()[-1]
    rootClass = GDSClassesMapping.get(tag)
    if rootClass is None:
        rootClass = globals().get(tag)
    return tag, rootClass


def parse(inFileName, silence=False):
    doc = parsexml_(inFileName)
    rootNode = doc.getroot()
    rootTag, rootClass = get_root_tag(rootNode)
    if rootClass is None:
        rootTag = 'HDF5-File'
        rootClass = HDF5_File
    rootObj = rootClass.factory()
    rootObj.build(rootNode)
    # Enable Python to collect the space used by the DOM.
    doc = None
    if not silence:
        sys.stdout.write('<?xml version="1.0" ?>\n')
        rootObj.export(
            sys.stdout, 0, name_=rootTag,
            namespacedef_='xmlns:hdf5="http://hdfgroup.org/HDF5/XML/schema/HDF5-File"',
            pretty_print=True)
    return rootObj


def parseEtree(inFileName, silence=False):
    doc = parsexml_(inFileName)
    rootNode = doc.getroot()
    rootTag, rootClass = get_root_tag(rootNode)
    if rootClass is None:
        rootTag = 'HDF5-File'
        rootClass = HDF5_File
    rootObj = rootClass.factory()
    rootObj.build(rootNode)
    # Enable Python to collect the space used by the DOM.
    doc = None
    mapping = {}
    rootElement = rootObj.to_etree(None, name_=rootTag, mapping_=mapping)
    reverse_mapping = rootObj.gds_reverse_node_mapping(mapping)
    if not silence:
        content = etree_.tostring(
            rootElement, pretty_print=True,
            xml_declaration=True, encoding="utf-8")
        sys.stdout.write(content)
        sys.stdout.write('\n')
    return rootObj, rootElement, mapping, reverse_mapping


def parseString(inString, silence=False):
    from StringIO import StringIO
    doc = parsexml_(StringIO(inString))
    rootNode = doc.getroot()
    rootTag, rootClass = get_root_tag(rootNode)
    if rootClass is None:
        rootTag = 'HDF5-File'
        rootClass = HDF5_File
    rootObj = rootClass.factory()
    rootObj.build(rootNode)
    # Enable Python to collect the space used by the DOM.
    doc = None
    if not silence:
        sys.stdout.write('<?xml version="1.0" ?>\n')
        rootObj.export(
            sys.stdout, 0, name_=rootTag,
            namespacedef_='xmlns:hdf5="http://hdfgroup.org/HDF5/XML/schema/HDF5-File"')
    return rootObj


def parseLiteral(inFileName, silence=False):
    doc = parsexml_(inFileName)
    rootNode = doc.getroot()
    rootTag, rootClass = get_root_tag(rootNode)
    if rootClass is None:
        rootTag = 'HDF5-File'
        rootClass = HDF5_File
    rootObj = rootClass.factory()
    rootObj.build(rootNode)
    # Enable Python to collect the space used by the DOM.
    doc = None
    if not silence:
        sys.stdout.write('#from tmp06sup import *\n\n')
        sys.stdout.write('import tmp06sup as model_\n\n')
        sys.stdout.write('rootObj = model_.rootClass(\n')
        rootObj.exportLiteral(sys.stdout, 0, name_=rootTag)
        sys.stdout.write(')\n')
    return rootObj


def main():
    args = sys.argv[1:]
    if len(args) == 1:
        parse(args[0])
    else:
        usage()


if __name__ == '__main__':
    #import pdb; pdb.set_trace()
    main()


__all__ = [
    "ArrayDimension",
    "ArrayType",
    "AtomicType",
    "Attribute",
    "BitfieldType",
    "ChunkDimension",
    "ChunkedLayout",
    "CompactLayout",
    "ComplexDataspace",
    "CompoundType",
    "Compression",
    "ContiguousLayout",
    "Data",
    "DataType",
    "Dataset",
    "DatasetPtr",
    "Dataspace",
    "Deflate",
    "Dimension",
    "EnumType",
    "ExternalFileInfo",
    "ExternalLayout",
    "Field",
    "FillValue",
    "FillValueInfo",
    "Fletcher32",
    "FloatType",
    "Group",
    "GroupPtr",
    "HDF5_File",
    "IntegerType",
    "NamedDataType",
    "NamedDataTypePtr",
    "NativeHDF5",
    "NoData",
    "NoFill",
    "ObjectReferenceType",
    "OpaqueType",
    "ReferenceType",
    "RegionReferenceType",
    "RequiredFilter",
    "RootGroup",
    "SZIP",
    "ScalarDataspace",
    "Shuffle",
    "SimpleDataspace",
    "SoftLink",
    "StorageLayout",
    "StringType",
    "SuperBlock",
    "TimeType",
    "VLType"
]
